<?php

require ("global.php");

?>
<html>
<head>
<STYLE type=text/css>
BODY {
  font-family: arial;
  font-size: 10pt;
  font-variant: normal;
  font-style: normal;
}
P {
  font-family: arial;
  font-size: 10pt;
  font-variant: normal;
  font-style: normal;
}
</STYLE>
</head>
<body>
<?php

// ###################### Start Prune #######################
if ($action=="prune") {

  echo "<p>Prune by date</p>\n";

  echo "<table border=0>";

  echo doformheader("thread","prunedate");
  echo makeinputcode("Delete threads with last post older than x days:","daysdelete","");
  echo makechoosercode("Forum","forumid","forum",-1,"All forums");

  echo doformfooter();

  echo "<hr>";

  echo "<p>Prune by username</p>\n";

  echo "<table border=0>";

  echo doformheader("thread","pruneuser");
  echo makeinputcode("Username","username");
  echo makechoosercode("Forum","forumid","forum",-1,"All forums");

  echo doformfooter();

}

// ###################### Start Prune by date #######################
if ($action=="prunedate") {
  if (isset($daysdelete)==0 or $daysdelete==0) {
    echo "<p>Please enter an age of post to delete</p>";
    exit;
  }

  if ($confirm!=1) {

    if ($forumid==-1) {
      $forumtitle="all";
    } else {
      $forum=$DB_site->query_first("SELECT title FROM forum WHERE forumid=$forumid");
      $forumtitle=$forum[title];
    }
    echo "<p>You are about to delete all threads from the $forumtitle forum older than $daysdelete day(s).<p>Click <a href=\"thread.php?action=prunedate&forumid=$forumid&daysdelete=$daysdelete&confirm=1\">here</a> to confirm and delete them all.</p>\n<p>Click <a href=\"thread.php?action=prunedatesel&forumid=$forumid&daysdelete=$daysdelete\">here</a> to select those to delete.</p>";
    exit;
  }

  $forumcheck=iif($forumid!=-1,"forumid=$forumid AND ","");

  $datecut=time()-($daysdelete*86400);
  $threads=$DB_site->query("SELECT threadid FROM thread WHERE $forumcheck thread.lastpost<=$datecut");
  while ($thread=$DB_site->fetch_array($threads)) {
    $DB_site->query("DELETE FROM post WHERE threadid=$thread[threadid]");
  }
  $datecut=time()-($daysdelete*86400);
  $DB_site->query("DELETE FROM thread WHERE $forumcheck thread.lastpost<=$datecut");

  echo "<p>Posts deleted successfully! It is recommend that you <a href=\"misc.php\">update counters</a> now.</p>";
}

// ###################### Start Prune by date selector #######################
if ($action=="prunedatesel") {

  echo doformheader("thread","doprunedate");
  echo "<table border=0>";
  $forumcheck=iif($forumid!=-1,"forumid=$forumid AND ","");

  $datecut=time()-($daysdelete*86400);
  $threads=$DB_site->query("SELECT threadid,title FROM thread WHERE $forumcheck thread.lastpost<=$datecut");
  while ($thread=$DB_site->fetch_array($threads)) {
    echo makeyesnocode("Delete: <a href=\"../showthread.php?threadid=$thread[threadid]\" target=_blank>$thread[title]</a>","delete[$thread[threadid]]",1);
  }

  echo doformfooter("Submit - only click here if you are ABSOLUTELY certain");
}

// ###################### Start Prune by date selected #######################
if ($action=="doprunedate") {

  echo "<p>Deleting...</p>";

  while (list($key,$val)=each($delete)) {
    if ($val==1) {
      $DB_site->query("DELETE FROM post WHERE threadid=$key");
      $DB_site->query("DELETE FROM thread WHERE threadid=$key");
    }
  }

  echo "<p>Posts deleted successfully! It is recommend that you <a href=\"misc.php\">update counters</a> now.</p>";
}

// ###################### Start Prune by user #######################
if ($action=="pruneuser") {
  if ($confirm!=1) {

    if (isset($username)==0 or $username=="") {
      echo "<p>Please enter a username to search for</p>";
      exit;
    }

    if ($forumid==-1) {
      $forumtitle="all forums";
    } else {
      $forum=$DB_site->query_first("SELECT title FROM forum WHERE forumid=$forumid");
      $forumtitle="the $forum[title] forum";
    }
    echo "<p>You are about to delete all posts and threads from $forumtitle by one of these users. Please select one:</p>";

    $users=$DB_site->query("SELECT userid,username FROM user WHERE INSTR(username,'".addslashes($username)."')>0 ORDER BY username");
    while ($user=$DB_site->fetch_array($users)) {
      echo "<p>Click <a href=\"thread.php?action=pruneuser&forumid=$forumid&userid=$user[userid]&confirm=1\">here</a> to confirm and delete all posts by <b>$user[username]</b>.<br>Click <a href=\"thread.php?action=pruneusersel&forumid=$forumid&userid=$user[userid]&confirm=1\">here</a> to select which posts to delete by <b>$user[username]</b>.</p>";
    }

    exit;
  }

  $forumcheck=iif($forumid!=-1,"forumid=$forumid AND ","");

  $usernames=$DB_site->query_first("SELECT username FROM user WHERE userid=$userid");
  $username=$usernames[username];

  $threads=$DB_site->query("SELECT threadid FROM thread WHERE $forumcheck 1=1");
  while ($thread=$DB_site->fetch_array($threads)) {
    $DB_site->query("DELETE FROM post WHERE threadid=$thread[threadid] AND userid=$userid");
  }
  $threads=$DB_site->query("SELECT threadid FROM thread WHERE $forumcheck postusername='".addslashes($username)."'");
  while ($thread=$DB_site->fetch_array($threads)) {
    $DB_site->query("DELETE FROM post WHERE threadid=$thread[threadid]");
  }
  $DB_site->query("DELETE FROM thread WHERE $forumcheck postusername='".addslashes($username)."'");

  echo "<p>Posts deleted successfully! It is recommend that you <a href=\"misc.php\">update counters</a> now.</p>";
}

// ###################### Start prune by user selector #######################
if ($action=="pruneusersel") {

  echo doformheader("thread","dopruneuser");
  echo "<table border=0>";

  $usernames=$DB_site->query_first("SELECT username FROM user WHERE userid=$userid");
  $username=$usernames[username];

  $forumcheck=iif($forumid!=-1,"thread.forumid=$forumid AND ","");

  $threads=$DB_site->query("SELECT threadid,title FROM thread WHERE $forumcheck postusername='".addslashes($username)."'");
  while ($thread=$DB_site->fetch_array($threads)) {
    echo makeyesnocode("Delete thread: <a href=\"../showthread.php?threadid=$thread[threadid]\" target=_blank>$thread[title]</a>","deletethread[$thread[threadid]]",1);
  }
  $threads=$DB_site->query("SELECT post.postid,thread.threadid,thread.title FROM thread,post WHERE thread.threadid=post.threadid AND $forumcheck post.userid=$userid");
  while ($thread=$DB_site->fetch_array($threads)) {
    echo makeyesnocode("Delete post: <a href=\"../showthread.php?threadid=$thread[threadid]\" target=_blank>$thread[title]</a>, post id $thread[postid]","deletepost[$thread[postid]]",1);
  }

  echo doformfooter("Submit - only click here if you are ABSOLUTELY certain");
}

// ###################### Start Prune by user selected #######################
if ($action=="dopruneuser") {
  echo "<p>Deleting...</p>";

  while (list($key,$val)=each($deletethread)) {
    if ($val==1) {
      $DB_site->query("DELETE FROM post WHERE threadid=$key");
      $DB_site->query("DELETE FROM thread WHERE threadid=$key");
    }
  }

  while (list($key,$val)=each($deletepost)) {
    if ($val==1) {
      $DB_site->query("DELETE FROM post WHERE postid=$key");
    }
  }

  echo "<p>Posts deleted successfully! It is recommend that you <a href=\"misc.php\">update counters</a> now.</p>";
}

// ###################### Start Move #######################
if ($action=="move") {

  echo "<p>Move by date</p>\n";

  echo "<table border=0>";

  echo doformheader("thread","movedate");
  echo makeinputcode("Move threads with last post older than x days:","daysmove","");
  echo makechoosercode("Source Forum","forumid","forum",-1,"All forums");
  echo makechoosercode("Destination Forum","destforumid","forum");

  echo doformfooter();

  echo "<hr>";

  echo "<p>Move by username</p>\n";

  echo "<table border=0>";

  echo doformheader("thread","moveuser");
  echo makeinputcode("Username","username");
  echo makechoosercode("Source Forum","forumid","forum",-1,"All forums");
  echo makechoosercode("Destination Forum","destforumid","forum");

  echo doformfooter();

}

// ###################### Start by Move Date #######################
if ($action=="movedate") {
  if (isset($daysmove)==0 or $daysmove=="") {
    echo "<p>Please enter an age of post to move</p>";
    exit;
  }

  if ($confirm!=1) {

    if ($forumid==-1) {
      $forumtitle="all";
    } else {
      $forum=$DB_site->query_first("SELECT title FROM forum WHERE forumid=$forumid");
      $forumtitle=$forum[title];
    }
    echo "<p>You are about to move all threads from the $forumtitle forum older than $daysmove day(s).<p>Click <a href=\"thread.php?action=movedate&forumid=$forumid&daysmove=$daysmove&destforumid=$destforumid&confirm=1\">here</a> to confirm and move them all.</p>\n<p>Click <a href=\"thread.php?action=movedatesel&forumid=$forumid&destforumid=$destforumid&daysmove=$daysmove\">here</a> to confirm and select those to move.</p>";
    exit;
  }

  $forumcheck=iif($forumid!=-1,"forumid=$forumid AND ","");

  $datecut=time()-($daysmove*86400);
  $DB_site->query("UPDATE thread SET forumid=$destforumid WHERE $forumcheck thread.lastpost<=$datecut");

  echo "<p>Posts moved successfully! It is recommend that you <a href=\"misc.php\">update counters</a> now.</p>";
}

// ###################### Start Move by date selector #######################
if ($action=="movedatesel") {

  echo doformheader("thread","domovedate");
  echo makehiddencode("destforumid",$destforumid);

  echo "<table border=0>";
  $forumcheck=iif($forumid!=-1,"forumid=$forumid AND ","");

  $datecut=time()-($daysmove*86400);
  $threads=$DB_site->query("SELECT threadid,title FROM thread WHERE $forumcheck thread.lastpost<=$datecut");
  while ($thread=$DB_site->fetch_array($threads)) {
    echo makeyesnocode("Move: <a href=\"../showthread.php?threadid=$thread[threadid]\" target=_blank>$thread[title]</a>","move[$thread[threadid]]",1);
  }

  echo doformfooter("Submit - only click here if you are ABSOLUTELY certain");
}

// ###################### Start Move by date selected #######################
if ($action=="domovedate") {

  echo "<p>Moving...</p>";

  while (list($key,$val)=each($move)) {
    if ($val==1) {
      $DB_site->query("UPDATE thread SET forumid=$destforumid WHERE threadid=$key");
    }
  }

  echo "<p>Posts moved successfully! It is recommend that you <a href=\"misc.php\">update counters</a> now.</p>";
}

// ###################### Start Move by user #######################
if ($action=="moveuser") {
  if ($confirm!=1) {

    if (isset($username)==0 or $username=="") {
      echo "<p>Please enter a username to search for</p>";
      exit;
    }

    if ($forumid==-1) {
      $forumtitle="all forums";
    } else {
      $forum=$DB_site->query_first("SELECT title FROM forum WHERE forumid=$forumid");
      $forumtitle="the $forum[title] forum";
    }
    echo "<p>You are about to move all posts and threads from $forumtitle by one of these users. Please select one:</p>";

    $users=$DB_site->query("SELECT userid,username FROM user WHERE INSTR(username,'".addslashes($username)."')>0 ORDER BY username");
    while ($user=$DB_site->fetch_array($users)) {
      echo "<p>Click <a href=\"thread.php?action=moveuser&forumid=$forumid&destforumid=$destforumid&userid=$user[userid]&confirm=1\">here</a> to confirm and move all posts by <b>$user[username]</b>.<br>Click <a href=\"thread.php?action=moveusersel&forumid=$forumid&destforumid=$destforumid&userid=$user[userid]&confirm=1\">here</a> to select which posts to move by <b>$user[username]</b>.</p>";
    }

    exit;
  }

  $forumcheck=iif($forumid!=-1,"forumid=$forumid AND ","");

  $usernames=$DB_site->query_first("SELECT username FROM user WHERE userid=$userid");
  $username=$usernames[username];

  $DB_site->query("UPDATE thread SET forumid=$destforumid WHERE $forumcheck postusername='".addslashes($username)."'");

  echo "<p>Posts moved successfully! It is recommend that you <a href=\"misc.php\">update counters</a> now.</p>";
}

// ###################### Start move by user selector #######################
if ($action=="moveusersel") {

  echo doformheader("thread","domoveuser");
  echo makehiddencode("destforumid",$destforumid);
  echo "<table border=0>";

  $usernames=$DB_site->query_first("SELECT username FROM user WHERE userid=$userid");
  $username=$usernames[username];

  $forumcheck=iif($forumid!=-1,"thread.forumid=$forumid AND ","");

  $threads=$DB_site->query("SELECT threadid,title FROM thread WHERE $forumcheck postusername='".addslashes($username)."'");
  while ($thread=$DB_site->fetch_array($threads)) {
    echo makeyesnocode("Move thread: <a href=\"../showthread.php?threadid=$thread[threadid]\" target=_blank>$thread[title]</a>","movethread[$thread[threadid]]",1);
  }

  echo doformfooter("Submit - only click here if you are ABSOLUTELY certain");
}

// ###################### Start move by user selected #######################
if ($action=="domoveuser") {
  echo "<p>Deleting...</p>";

  while (list($key,$val)=each($movethread)) {
    if ($val==1) {
      $DB_site->query("UPDATE thread SET forumid=$destforumid WHERE threadid=$key");
    }
  }

  echo "<p>Posts moved successfully! It is recommend that you <a href=\"misc.php\">update counters</a> now.</p>";
}


?>
</body>
</html>
