<?php

require("global.php");

if (isset($action)==0 or $action=="") {
  $action="editpost";
}

checkipban();

// ############################### start edit post ###############################
if ($action=="editpost") {

  // verify postid
  $postid = verifyid("post",$postid);

  $getthread=$DB_site->query_first("SELECT threadid,visible FROM post WHERE postid=$postid");
  $threadid=$getthread[threadid];
  if ($getthread[visible]==0) {
    $idname="post";
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_invalidid")."\");");
  }

  $threadinfo=$DB_site->query_first("SELECT title,forumid,open,visible FROM thread WHERE threadid=$threadid");
  if ($wordwrap!=0) {
    $threadinfo[title]=dowordwrap($threadinfo[title]);
  }
  $threadtitle=htmlspecialchars($threadinfo[title]);
  $forumid=$threadinfo[forumid];
  if ($threadinfo[visible]==0) {
    $idname="thread";
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_invalidid")."\");");
  }

  if ($threadinfo[open]==0) {
    eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_threadclosed")."\",\"showthread.php?threadid=$threadid\");");

    exit;
  }

  $foruminfo=$DB_site->query_first("SELECT title,description,active,allowposting,categoryid,titleimage,edittemplate,headertemplate,useadvheader,footertemplate,useadvfooter,rulestemplate,allowbbcode,allowimages,allowhtml,allowsmilies FROM forum WHERE forumid=$threadinfo[forumid]");
  $forumtitle=htmlspecialchars($foruminfo[title]);
  if ($foruminfo[active]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
    exit;
  }
  if ($foruminfo[allowposting]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumnoreply",0));
    exit;
  }
  if ($foruminfo[titleimage]!="") {
    $titleimage=$foruminfo[titleimage];
  }
  if ($foruminfo[edittemplate]!="") {
    $usetemplate=$foruminfo[edittemplate];
  } else {
    $usetemplate="editpost";
  }

  $bbcodeon=iif($foruminfo[allowbbcode]==1,$ontext,$offtext);
  $imgcodeon=iif($foruminfo[allowimages]==1,$ontext,$offtext);
  $htmlcodeon=iif($foruminfo[allowhtml]==1,$ontext,$offtext);
  $smilieson=iif($foruminfo[allowsmilies]==1,$ontext,$offtext);
  if ($foruminfo[rulestemplate]!="") {
    eval("\$forumrules = \"".gettemplate("$foruminfo[rulestemplate]")."\";");
  } else {
    eval("\$forumrules = \"".gettemplate("forumrules")."\";");
  }

  $getcategory=$DB_site->query_first("SELECT title,categoryid FROM category WHERE category.categoryid=$foruminfo[categoryid]");
  $categorytitle=$getcategory[title];
  $categoryid=$getcategory[categoryid];

  $username=$bbusername;
  $password=$bbpassword;

  $postinfo=$DB_site->query_first("SELECT userid,dateline,title,pagetext,allowsmilie,signature,email,iconid FROM post WHERE postid=$postid");
  $message=htmlspecialchars($postinfo[pagetext]);
  $postdate=date($dateformat,$postinfo[dateline]+(($timeoffset+$bbtimezoneoffset)*3600));
  $posttime=date($timeformat,$postinfo[dateline]+(($timeoffset+$bbtimezoneoffset)*3600));
  $posttitle=htmlspecialchars($postinfo[title]);

  if ($showicons==1) {
    $posticons=chooseicons($postinfo[iconid]);
  }  else {
    $posticons="";
  }

  $userinfo=$DB_site->query_first("SELECT username FROM user WHERE userid=$postinfo[userid]");
  $postusername=htmlspecialchars($userinfo[username]);

  $parseurlchecked="CHECKED";
  $emailchecked=iif($postinfo[email]==1,"CHECKED","");
  $disablesmilieschecked=iif($postinfo[allowsmilie]==1,"","CHECKED");
  $signaturechecked=iif($postinfo[signature]==1,"CHECKED","");

  // check user is allowed to do edit
  $getperms=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($getperms[canedit]==0 and $getperms[candelete]==0 and $getperms[canadminedit]==0) {
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  }
  if (($getperms[canedit]==1 or $getperms[candelete]==1) and $getperms[canadminedit]==0) {
    if ($bbuserid!=$postinfo[userid]) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
      exit;
    } else {
      // check for time limits
      if ($postinfo[dateline]<(time()-($edittimelimit*60)) and $edittimelimit!=0) {
        eval("echo standarderror(\$bbtitle,\"".gettemplate("error_edittimelimit")."\");");
        exit;
      }
    }
  }

  // parse header ##################
  if ($foruminfo[headertemplate]!="") {
    if ($foruminfo[useadvheader]==1) {
      eval(gettemplate("$foruminfo[headertemplate]").";");
    } else {
      eval("\$header = \"".gettemplate("$foruminfo[headertemplate]")."\";");
    }
  }
  if ($foruminfo[footertemplate]!="") {
    if ($foruminfo[useadvfooter]==1) {
      eval(gettemplate("$foruminfo[footertemplate]").";");
    } else {
      eval("\$footer = \"".gettemplate("$foruminfo[footertemplate]")."\";");
    }
  }

  if ($foruminfo[allowsmilies]==1) {
    eval("\$disablesmiliesoption = \"".gettemplate("disablesmiliesoption")."\";");
  }
  eval("echo dovars(\"".gettemplate("$usetemplate")."\");");

}

// ############################### start update post ###############################
if ($action=="updatepost") {

  //check valid username and password and get user id
  $userid=verifyusername($username,$password);

  $postid = verifyid("post",$postid);

  // get threadid
  $postinfo=$DB_site->query_first("SELECT threadid,visible,userid,dateline FROM post WHERE postid=$postid");
  $threadid=$postinfo[threadid];
  if ($postinfo[visible]==0) {
    $idname="thread";
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_invalidid")."\");");
    exit;
  }

  $getthread=$DB_site->query_first("SELECT forumid,visible,open FROM thread WHERE threadid=$threadid");
  $forumid=$getthread[forumid];
  if ($getthread[visible]==0) {
    $idname="thread";
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_invalidid")."\");");
    exit;
  }
  if ($getthread[open]==0) {
    eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_threadclosed")."\",\"showthread.php?threadid=$threadid\");");

    exit;
  }


  $foruminfo=$DB_site->query_first("SELECT active,allowposting FROM forum WHERE forumid=$forumid");
  if ($foruminfo[active]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
    exit;
  }
  if ($foruminfo[allowposting]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumnoreply",0));
    exit;
  }

  if ($deletepost=="yes") {

    // check for permissions to do this
    $getperms=getpermissions($bbuserid,$bbusergroupid,$forumid);
    if ($getperms[candelete]==0 and $getperms[canadminedit]==0) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
      exit;
    }
    //check that it is the original poster try to edit
    if ($getperms[candelete]==1 and $getperms[canadminedit]==0) {
      if ($bbuserid!=$postinfo[userid]) {
        eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
        exit;
      } else {
        // check for time limits
        if ($postinfo[dateline]<(time()-($edittimelimit*60)) and $edittimelimit!=0) {
          eval("echo standarderror(\$bbtitle,\"".gettemplate("error_edittimelimit")."\");");
          exit;
        }
      }
    }

    //get first post in thread
    $getfirst=$DB_site->query_first("SELECT postid,dateline FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    if ($getfirst[postid]==$postid) {
      // delete thread

      // decrement users post counts
      $posts=$DB_site->query("SELECT userid FROM post WHERE threadid=$threadid");
      while ($post=$DB_site->fetch_array($posts)) {
        $DB_site->query("UPDATE user SET posts=posts-1 WHERE userid=$post[userid]");
      }

      $DB_site->query("DELETE FROM post WHERE threadid=$threadid");

      $DB_site->query("DELETE FROM thread WHERE threadid=$threadid");

      // update forum counts
      if ($numpost=$DB_site->query_first("SELECT COUNT(postid) AS posts FROM post,thread WHERE thread.threadid=post.threadid AND thread.forumid=$forumid")) {
        $numberposts=$numpost[posts];
      } else {
        $numberposts=0;
      }
      if ($lastposts=$DB_site->query_first("SELECT lastpost FROM thread WHERE forumid=$forumid ORDER BY lastpost DESC LIMIT 1")) {
        $lastpost=$lastposts[lastpost];
      } else {
        $lastpost=0;
      }
      $DB_site->query("UPDATE forum SET replycount=$numberposts,threadcount=threadcount-1,lastpost=$lastpost WHERE forumid=$forumid");

      eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_deletethread")."\",\"forumdisplay.php?forumid=$forumid\");");

    } else {
      //delete just this post

      // decrement user post count
      $getuserid=$DB_site->query_first("SELECT userid FROM post WHERE postid=$postid");
      $DB_site->query("UPDATE user SET posts=posts-1 WHERE userid=$getuserid[userid]");

      $DB_site->query("DELETE FROM post WHERE postid=$postid");
      indexthread($threadid);

      // update forum counts
      if ($lastposts=$DB_site->query_first("SELECT lastpost FROM thread WHERE forumid=$forumid ORDER BY lastpost DESC LIMIT 1")) {
        $lastpost=$lastposts[lastpost];
      } else {
        $lastpost=0;
      }
      $DB_site->query("UPDATE forum SET replycount=replycount-1,lastpost=$lastpost WHERE forumid=$forumid");

      $getlastpost=$DB_site->query_first("SELECT postid FROM post WHERE threadid=$threadid ORDER BY dateline DESC");
      $lastusername=$DB_site->query_first("SELECT username,userid FROM post WHERE postid=$getlastpost[postid]");
      if ($lastusername[userid]==0) {
        $lastusername=$lastusername[username];
      } else {
        $users=$DB_site->query_first("SELECT username FROM user WHERE userid=$lastusername[userid]");
        $lastusername=$users[username];
      }

      $DB_site->query("UPDATE thread SET replycount=replycount-1,lastposter='".addslashes($lastusername)."' WHERE threadid=$threadid");

      eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_deletepost")."\",\"showthread.php?threadid=$threadid\");");
    }

  } else {
    // check for message
    if ($message=="") {
      echo standarderror($bbtitle,gettemplate("error_nosubject",0));
      exit;
    }

    $getperms=getpermissions($bbuserid,$bbusergroupid,$forumid);
    if ($getperms[canedit]==0 and $getperms[canadminedit]==0) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
      exit;
    }
    if ($getperms[canedit]==1 and $getperms[canadminedit]==0) {
      if ($bbuserid!=$postinfo[userid]) {
        eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
        exit;
      } else {
        // check for time limits
        if ($postinfo[dateline]<(time()-($edittimelimit*60)) and $edittimelimit!=0) {
          eval("echo standarderror(\$bbtitle,\"".gettemplate("error_edittimelimit")."\");");
          exit;
        }
      }
    }

    // decode check boxes
    $parseurl=iif($parseurl=="yes",1,0);
    $email=iif($email=="yes",1,0);
    $allowsmilie=iif($disablesmilies=="yes",0,1);
    $signature=iif($signature=="yes",1,0);

    if ($showeditedby==1 and $postinfo[dateline]<(time()-($noeditedbytime*60))) {
      if ($getperms[canadminedit]==0 or $showeditedbyadmin==1 or ($getperms[canadminedit]==1 and $getperms[cancontrolpanel]==0)) {
        $getorig=$DB_site->query_first("SELECT pagetext FROM post WHERE postid=$postid");

        $messagenew=str_replace("\n","",str_replace("\r","",$message));
        $pagetextnew=str_replace("\n","",str_replace("\r","",$getorig[pagetext]));

        if ($messagenew!=$pagetextnew) {
          // get rid of excess "edited by..."

          $editedby=gettemplate("editedby",0);
          $editpos=strpos($message,trim(substr($editedby,0,10)));
          if ($editpos!=0) {
            $message=trim(substr($message,0,$editpos));
          }

          $dateedited=date($dateformat,time()+(($timeoffset)*3600));
          $timeedited=date($timeformat,time()+(($timeoffset)*3600));

          eval("\$message .= \"".gettemplate("editedby")."\";");
        }
      }
    }

    // check max images
    if ($maximages!=0) {
      $parsedmessage=bbcodeparse($message,$forumid,$allowsmilie);
      if (countchar($parsedmessage,"<img")>$maximages) {
        eval("echo standarderror(\$bbtitle,\"".gettemplate("error_toomanyimages")."\");");
        exit;
      }
    }

    if (isset($iconid)==0 or $iconid=="") {
      $iconid=0;
    }
    $iconid = intval($iconid);

    if ($parseurl==1) {
      $message=parseurl($message);
    }

    $title=censortext($title);
    $message=censortext($message);

    $DB_site->query("UPDATE post SET title='".addslashes($title)."',pagetext='".addslashes($message)."',allowsmilie=$allowsmilie,email=$email,signature=$signature,iconid=$iconid WHERE postid=$postid");

    indexthread($threadid);

    eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_editthanks")."\",\"showthread.php?postid=$postid#post$postid\");");
  }
}

?>