<?php
$noheader=1;

// get rid of slashes in get / post / cookie data
if (get_magic_quotes_gpc()==1 and is_array($GLOBALS)==1) {
  while(list($key,$val)=each($GLOBALS)) {
    if (is_string($val)==1) {
      $GLOBALS[$key]=stripslashes($val);
    }
  }
}

set_magic_quotes_runtime(0);

error_reporting(7);

if (isset($noheader)==0 or $noheader==0) {
  // default headers
  header("HTTP/1.0 200 OK");
  header("HTTP/1.1 200 OK");
  header("Content-type: text/html");
}
if ($nocache==1) {
  // no caching
  header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");             // Date in the past
  header("Last-Modified: " . gmdate("D, d M Y H:i:s") . "GMT"); // always modified
  header("Cache-Control: no-cache, must-revalidate");           // HTTP/1.1
  header("Pragma: no-cache");                                   // HTTP/1.0
}

// ###################### Start init #######################
//load config
require("admin/config.php");

// init db **********************
// load db class
$dbclassname="admin/db_$dbservertype.php";
require($dbclassname);

$DB_site=new DB_Sql_vb;

$DB_site->appname="vBulletin";
$DB_site->appshortname="vBulletin (forum)";
$DB_site->database=$dbname;
$DB_site->server=$servername;
$DB_site->user=$dbusername;
$DB_site->password=$dbpassword;

$DB_site->connect();
// end init db

// load options and other major templates
$temps=$DB_site->query("SELECT template,title 
                        FROM template 
                        WHERE title='options' OR title='cssinclude' OR title='header' OR title='footer' OR title='fivelinks'
                           OR title='jumpforumbit' OR title='forumjump'");
while ($temp=$DB_site->fetch_array($temps)) {
  $templatecache["$temp[title]"]=$temp[template];
  if ($temp[title]=="options") { eval($temp[template]); }
}

// load vars
$vars=$DB_site->query("SELECT findword,replaceword FROM replacement ORDER BY replacementid DESC");
while($var=$DB_site->fetch_array($vars)) {
	$varcache["$var[findword]"] = $var[replaceword];
}

// ###################### Start dovars #######################
function dovars($vartext) {
  // parses replacement vars

  global $varcache;

  $newtext=$vartext;
  
  reset($varcache);
  
  while(list($key,$val)=each($varcache)) {
    $newtext=str_replace($key,$val,$newtext);
  }

  return $newtext;
}

// ###################### Start standarderror #######################
function standarderror($title="",$error="",$headinsert="") {
  // print standard error page
  global $header,$footer,$cssinclude,$fivelinks,$forumjump,$timezone,$bbtitle,$hometitle,$bburl,$homeurl,$copyrighttext,$privacyurl,$contactuslink,$webmasteremail,$technicalemail,$faxnumber,$address,$companyname,$titleimage,$replyimage,$newthreadimage,$closedthreadimage,$lastvisitdate,$timenow;

  makeforumjump();

  $pagetitle = "$title";
  $errormessage = $error;

  eval("\$returnval = dovars(\"".gettemplate("standarderror")."\");");

  return $returnval;
}

// ###################### Start standardredirect #######################
function standardredirect($title="",$message="",$redirectloc="") {
  // print standard redirect page

  global $header,$footer,$cssinclude,$fivelinks,$forumjump,$timezone,$bbtitle,$hometitle,$bburl,$homeurl,$copyrighttext,$privacyurl,$contactuslink,$webmasteremail,$technicalemail,$faxnumber,$address,$companyname,$titleimage,$replyimage,$newthreadimage,$closedthreadimage,$lastvisitdate,$timenow;

  makeforumjump();

  $pagetitle = "$title";
  $errormessage = $message;
  $url=$redirectloc;

  eval("\$returnval = dovars(\"".gettemplate("standardredirect")."\");");

  return $returnval;
}

// ###################### Start iif #######################
function iif ($expression,$returntrue,$returnfalse) {

  if ($expression==0) {
    $areturn=$returnfalse;
  } else {
    $areturn=$returntrue;
  }
  return $areturn;

}

// ###################### Start verifyusername #######################
function verifyusername($username,$password,$allowmd5=1) {
  // function to verify username and password, and return the userid
  global $DB_site,$seniormemberposts,$memberposts,$juniormemberpermission,$memberpermission,$seniormemberpermission;

  if ($user=$DB_site->query_first("SELECT userid,password FROM user WHERE username='".addslashes($username)."'")) {
    if ($user[password]!=$password) {
      if (($allowmd5==1 and substr(md5($user[password]),0,strlen($user[password]))!=$password) or $allowmd5==0) {
        echo standarderror($bbtitle,gettemplate("error_wrongpassword",0));
        exit;
      }
    }
    $userid=$user[userid];
  } else {
    echo standarderror($bbtitle,gettemplate("error_wrongusername",0));
    exit;
  }

  return $userid;

}

// ###################### Start dowordwraptext #######################
function dowordwrap($wordwraptext) {
  global $wordwrap;

  if ($text!="") {
    $text=eregi_replace("([^\n\r \./<>\"\\-]{".$wordwrap."})"," \\1 ",$wordwraptext);
  } else {
    $text=$wordwraptext;
  }

  return $text;

}

// ###################### Start bbcodeparse #######################
function bbcodeparse($bbcode,$forumid=0,$allowsmilie=1) {

  bbcodeparse2($bbcode,$forumid,$allowsmilie);

  global $bbcode2;

  return $bbcode2;
}

function bbcodeparse2($bbcode,$forumid=0,$allowsmilie=1) {
  // parses text for vB code, smilies and censoring

  global $DB_site,$bbcode2;
  global $allowhtml,$allowbbcode,$allowbbimagecode,$allowsmilies,$wordwrap,$forumcache;

  if ($bbcode!="") {
    if ($wordwrap!=0) {
      $bbcode=dowordwrap($bbcode);
    }

    if ($forumid!=0) {
      if (!$forumcache[$forumid]) {
      	$forum=$DB_site->query_first("SELECT allowbbcode,allowhtml,allowimages,allowsmilies FROM forum WHERE forumid=$forumid");
      	$forumcache[$forumid] = $forum;
      } else {
      	$forum = $forumcache[$forumid];
      }
      $dohtml=$forum[allowhtml];
      $dobbimagecode=$forum[allowimages];
      $dosmilies=$forum[allowsmilies];
      $dobbcode=$forum[allowbbcode];
    } else {
      $dohtml=$allowhtml;
      $dobbcode=$allowbbcode;
      $dobbimagecode=$allowbbimagecode;
      $dosmilies=$allowsmilies;
    }

    if ($dohtml==0) {
      // kill any rogue html code
      $bbcode=str_replace("&","&amp;",$bbcode);
      $bbcode=str_replace("<","&lt;",$bbcode);
      $bbcode=str_replace(">","&gt;",$bbcode);
    }

    //smilies
    if ($allowsmilie==1 and $dosmilies==1) {
      global $smiliecache;
      if (!$smiliecache) {
        $smilies=$DB_site->query("SELECT smilietext,smiliepath FROM smilie");
        $sci = 0;
        while ($smilie=$DB_site->fetch_array($smilies)) {
          if (trim($smilie[smilietext])!="") {
            $smiliecache[smilietext][$sci] = $smilie[smilietext];
            $smiliecache[smiliepath][$sci] = $smilie[smiliepath];
            $sci++;
          }
        }
      }
      for ($sci=0;$sci<count($smiliecache[smilietext]);$sci++) {
        $bbcode=str_replace(trim($smiliecache[smilietext][$sci]),"<img src=\"".$smiliecache[smiliepath][$sci]."\" border=0>",$bbcode);
      }
    }

    if ($dobbcode==1) {
      // user defined bb codes
      global $bbcodecache;
      if (!$bbcodecache) {
        $bbcodes=$DB_site->query("SELECT findcode,replacecode FROM bbcode");
        $bbci = 0;
        while ($abbcode=$DB_site->fetch_array($bbcodes)) {
          if ($abbcode[findcode]!="") {
            $bbcodecache[findcode][$bbci] = $abbcode[findcode];
            $bbcodecache[replacecode][$bbci] = $abbcode[replacecode];
            $bbci++;
          }
        }
      }
      for ($bbci=0;$bbci<count($bbcodecache[findcode]);$bbci++) {
        $bbcode=eregi_replace(quotemeta($bbcodecache[findcode][$bbci]),quotemeta($bbcodecache[replacecode][$bbci]),$bbcode);
      }

      // do [url]xxx[/url]
      $bbcode=eregi_replace("\\[url\\]www.([^\\[]*)\\[/url\\]","<a href=\"http://www.\\1\" target=_blank>\\1</a>",$bbcode);
      $bbcode=eregi_replace("\\[url\\]([^\\[]*)\\[/url\\]","<a href=\"\\1\" target=_blank>\\1</a>",$bbcode);

      // change neccessary &quot; back to "
      $bbcode=eregi_replace("\\[url=\&quot;","[url=\"",$bbcode);
      $bbcode=eregi_replace("\\&quot;\\]","\"]",$bbcode);
      // do [url="xxx"]yyy[/url]
      $bbcode=eregi_replace("\\[url=\"([^\"]*)\"\\]([^\\[]*)\\[\\/url\\]","<a href=\"\\1\" target=_blank>\\2</a>",$bbcode);
      $bbcode=eregi_replace("\\[url=([^\"]*)\\]([^\\[]*)\\[\\/url\\]","<a href=\"\\1\" target=_blank>\\2</a>",$bbcode);

      // do [email]xxx[/email]
      $bbcode=eregi_replace("\\[email\\]([^\\[]*)\\[/email\\]","<a href=\"mailto:\\1\">\\1</a>",$bbcode);

      // do lists
      $bbcode=eregi_replace("\\[list","[list",$bbcode);  // make lower case
      $bbcode=eregi_replace("\\[/list","[/list",$bbcode);  // make lower case

      $bbcode=str_replace("[list]","<ul type=square>",$bbcode);
      $bbcode=str_replace("[/list]","</ul>",$bbcode);
      $bbcode=str_replace("[list=1]","<ol type=1>",$bbcode);
      $bbcode=str_replace("[list=a]","<ol type=A>",$bbcode);
      $bbcode=str_replace("[list=A]","<ol type=A>",$bbcode);
      $bbcode=str_replace("[/list=1]","</ol>",$bbcode);
      $bbcode=str_replace("[/list=a]","</ol>",$bbcode);
      $bbcode=str_replace("[/list=A]","</ol>",$bbcode);
      $bbcode=str_replace("[*]","<li>",$bbcode);

      // do quotes
      $bbcode=eregi_replace("quote\\]","quote]",$bbcode);  // make lower case
      $bbcode=str_replace("[quote]\r\n","<blockquote><smallfont>quote:</smallfont><hr>",$bbcode);
      $bbcode=str_replace("[quote]","<blockquote><smallfont>quote:</smallfont><hr>",$bbcode);
      $bbcode=str_replace("[/quote]\r\n","<hr></blockquote>",$bbcode);
      $bbcode=str_replace("[/quote]","<hr></blockquote>",$bbcode);

      // do code tags
      $bbcode=eregi_replace("code\\]","code]",$bbcode);  // make lower case
      $bbcode=str_replace("[code]\r\n","</normalfont><blockquote><pre><smallfont>code:</smallfont><hr>",$bbcode);
      $bbcode=str_replace("[code]","</normalfont><blockquote><pre><smallfont>code:</smallfont><hr>",$bbcode);
      $bbcode=str_replace("[/code]\r\n","<hr></pre><normalfont></blockquote>",$bbcode);
      $bbcode=str_replace("[/code]","<hr></pre><normalfont></blockquote>",$bbcode);

      if ($dobbimagecode==1) {
        // do [img]xxx[/img]
        $bbcode=eregi_replace("\\[img\\]([^\\[]*)\\[/img\\]","<img src=\"\\1\" border=0>",$bbcode);
      }


      // get rid of stray <br> tags in the code - upsets older browsers (IE 4.72 reported problems)
      $codebits=explode("</normalfont><pre><smallfont>code:</smallfont></normalfont><hr><blockquote>",$bbcode);
      list($key,$bbcode)=each($codebits);
      $bbcode=nl2br($bbcode);

      while (list($key,$val)=each($codebits)) {

        $sbbits=explode("</blockquote><hr></pre><normalfont>",$val);
        $newbits=$sbbits[0]."</blockquote><hr></pre><normalfont>".nl2br($sbbits[1]);
        $bbcode.="</normalfont><pre><smallfont>code:</smallfont></normalfont><hr><blockquote>".$newbits;

      }
    } else {
      $bbcode=nl2br($bbcode);
    }

    $bbcode=censortext($bbcode);
  }

  $bbcode2=$bbcode;

  return 1;
}

// ###################### Start censortext #######################
function censortext($text) {
  global $enablecensor,$censorwords,$censorchar;
  if ($enablecensor==1) {
    $censorword=explode(" ",$censorwords);

    while (list($key,$val)=each($censorword)) {
      if ($val!="") {
        if (substr($val,0,1)=="{") {
          $val=substr($val,1,-1);

          $text=eregi_replace("([^A-Za-z])".$val."([^A-Za-z])","\\1".repeatchar($censorchar,strlen($val))."\\2",$text);
        } else {
          $text=eregi_replace($val,repeatchar($censorchar,strlen($val)),$text);
        }
      }
    }

  }

  return $text;
}

// ###################### Start gettemplate #######################
function gettemplate($templatename,$escape=1) {
  // gets a template from the db or from the local cache
  global $templatecache,$DB_site;

  if ($templatecache[$templatename]!="") {
    $template=$templatecache[$templatename];
  } else {
    $gettemp=$DB_site->query_first("SELECT template FROM template WHERE title='".addslashes($templatename)."'");
    $template=$gettemp[template];
    $templatecache[$templatename]=$template;
  }

  if ($escape==1) {
    $template=str_replace("\"","\\\"",$template);
  }
  return $template;
}

// ###################### Start verifyid #######################
function verifyid($idname,$id) {
  // verifies an id number and returns a correct one if it can be found
  global $DB_site,$webmasteremail;

  if (isset($id)==0 or $id==0 or $id=="") {
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_noid")."\");");

    exit;

  } else {
    $id=intval($id);
    if (!$check=$DB_site->query_first("SELECT $idname"."id FROM $idname WHERE $idname"."id=$id")) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_invalidid")."\");");

      exit;
    }
  }

  return $id;
}

// ###################### Start repeatchar #######################
function repeatchar($char,$times) {
  // returns the contents of $char repeatd $times times
  $counter=0;

  while ($counter++<$times) {
    $retstring.=$char;
  }

  return $retstring;
}

// ###################### Start checkipban #######################
function checkipban() {
  // checkes to see if the current ip address is banned
  global $enablebanning,$banip,$webmasteremail;

  if ($enablebanning==1 and $banip!="") {
    $ipaddress=getenv("REMOTE_ADDR");

    $addresses=explode(" ",$banip);
    while (list($key,$val)=each($addresses)) {
      if (strstr(" ".$ipaddress," ".trim($val))!="") {
        eval("echo standarderror(\$bbtitle,\"".gettemplate("error_banip")."\");");
        exit;
      }
    }
  }
  return 1;
}

// ###################### Start chooseicons #######################
function chooseicons($seliconid=0) {
  // retursn the icons chooser for posting new messages
  global $DB_site;

/*
  if ($seliconid==0) {
    $seliconid=1;
  }
*/

  $icons=$DB_site->query("SELECT iconid,iconpath,title FROM icon ORDER BY iconid");

  $counter=0;
  $posticonbits = "";
  while ($icon=$DB_site->fetch_array($icons)) {

    if ($counter%7==0 and $counter!=0) {
      $posticonbits.="<br>\n";
    }

    $counter++;

    $iconid=$icon[iconid];
    $iconpath=$icon[iconpath];
    if ($seliconid==$iconid) {
      $iconchecked="CHECKED";
    } else {
      $iconchecked="";
    }
    $alttext=$icon[title];

    eval("\$posticonbits.= \"".gettemplate("posticonbit")."\";");

  }

  if ($seliconid==0) {
    $iconchecked="CHECKED";
  } else {
    $iconchecked="";
  }

  eval("\$posticons.= \"".gettemplate("posticons")."\";");

  return $posticons;

}

// ###################### Start parseurl #######################
function parseurl($messagetext) {
  // the auto parser - adds [url] tags around neccessary things

  // catch those with a space or new line before
  $messagetext=eregi_replace("([ \r\n])http://([^ ,\r\n]*)","\\1[url]http://\\2[/url]",$messagetext);
  $messagetext=eregi_replace("([ \r\n])https://([^ ,\r\n]*)","\\1[url]https://\\2[/url]",$messagetext);
  $messagetext=eregi_replace("([ \r\n])ftp://([^ ,\r\n]*)","\\1[url]ftp://\\2[/url]",$messagetext);
  $messagetext=eregi_replace("([ \r\n])www\\.([^ ,\r\n]*)","\\1[url]http://www.\\2[/url]",$messagetext);

  // catch those right at the begninning
  $messagetext=eregi_replace("^http://([^ ,\r\n]*)","[url]http://\\1[/url]",$messagetext);
  $messagetext=eregi_replace("^https://([^ ,\r\n]*)","[url]https://\\1[/url]",$messagetext);
  $messagetext=eregi_replace("^ftp://([^ ,\r\n]*)","[url]ftp://\\1[/url]",$messagetext);
  $messagetext=eregi_replace("^www\\.([^ ,\r\n]*)","[url]http://www.\\1[/url]",$messagetext);

  return $messagetext;
}

// ###################### Start getpermissions #######################
function getpermissions($userid=0,$usergroupid=0,$forumid=0) {
  	// gets permissions, depending on given userid and forumid
  	global $DB_site,$hideprivateforums;
if ($hideprivateforums==1) {
	global $permcache;
	if (!$permcache) {
		if ($usergroupid==0) {
		    if ($userid==0) {
		      $usergroupid=1;
		    } else {
		      $getuser=$DB_site->query_first("SELECT usergroupid FROM user WHERE userid=$userid");
		      $usergroupid=$getuser[usergroupid];
		    }
		}
		$thisperm=$DB_site->query_first("SELECT canview,cansearch,canemail,canpostnew,canreply,canadminedit,canedit,candelete,canopenclose,canmove,cancontrolpanel FROM usergroup WHERE usergroupid=$usergroupid");
		$permcache["0,0,0"] = $thisperm;
		$theseperms=$DB_site->query("SELECT forumid,canview,cansearch,canemail,canpostnew,canreply,canadminedit,canedit,candelete,canopenclose,canmove FROM forumpermission WHERE usergroupid=$usergroupid");
		while($thisperm=$DB_site->fetch_array($theseperms)) {
			$thisfid = $thisperm[forumid];
			$permcache["$userid,$usergroupid,$thisfid"] = $thisperm;
		}
	}
	$thisone = "$userid,$usergroupid,$forumid";
	if ($permcache["$userid,$usergroupid,$forumid"]) {
		$getperms = $permcache["$userid,$usergroupid,$forumid"];
	} else {
		$getperms=$permcache["0,0,0"];
	}
} else {
  if ($usergroupid==0) {
    if ($userid==0) {
      $usergroupid=1;
    } else {
      $getuser=$DB_site->query_first("SELECT usergroupid FROM user WHERE userid=$userid");
      $usergroupid=$getuser[usergroupid];
    }
  }

  if ($forumid==0) {
    $getperms=$DB_site->query_first("SELECT canview,cansearch,canemail,canpostnew,canreply,canadminedit,canedit,candelete,canopenclose,canmove,cancontrolpanel FROM usergroup WHERE usergroupid=$usergroupid");
  } else {
    if (!$getperms=$DB_site->query_first("SELECT canview,cansearch,canemail,canpostnew,canreply,canadminedit,canedit,candelete,canopenclose,canmove FROM forumpermission WHERE usergroupid=$usergroupid AND forumid=$forumid")) {
      $getperms=$DB_site->query_first("SELECT canview,cansearch,canemail,canpostnew,canreply,canadminedit,canedit,candelete,canopenclose,canmove,cancontrolpanel FROM usergroup WHERE usergroupid=$usergroupid");
    }
  }
}
	
  return $getperms;

}

// ###################### Start wordsonly #######################
function wordsonly ($text) {
  //for the searching - strips out unneccessary bits
  $text=strtolower($text);

  $text=ereg_replace("<pre>[^<]*</pre>"," ",$text);
  $text=ereg_replace("<[^>]*>"," ",$text); // remove HTML <> tags
  $text=ereg_replace("&[^;];"," ",$text); // remove HTML special chars
//  $text=ereg_replace("[^ 0-9a-z]"," ",$text); // keep only letters and numbers

  $counter=0;

  $words=explode(" ",$text);
  while (list($key,$val)=each($words)) {
    if ($val!="the" and $val!="this" and $val!="and" and $val!="but" and $val!="was" and $val!="that" and $val!="with" and $val!="its" and $val!="you" and $val!="they" and $val!="what" and $val!="why" and $val!="for" and $val!="are" and $val!="our" and $val!="then" and $val!="there" and $val!="which") {
      $counter++;
      $wordarray[$val]=1;
    }
  }

  if ($counter>0) {
    while (list($key,$val)=each($wordarray)) {
      $newwords[]=$key;
    }

    $newwords=implode($newwords," ");
  } else {
    $newwords="";
  }

  return $newwords;
}

// ###################### Start indexthread #######################
function indexthread($threadid) {
  //adds a thread into the search index
  global $DB_site;

  $thread=$DB_site->query_first("SELECT threadid,title FROM thread WHERE threadid=$threadid");

  $subject=$thread[title];

  $posts=$DB_site->query("SELECT post.userid, post.username AS guestname, pagetext, user.username AS username
                          FROM post
                          LEFT JOIN user ON (user.userid = post.userid)
                          WHERE threadid=$thread[threadid] AND visible=1");
   $usernames = "";
   while ($post=$DB_site->fetch_array($posts)) {
		if ($post[userid]!=0) {
			if ($post[username] != "") {
				$usernames.=" $post[username] ";
			}
		} else {
			if ($post[guestname] != "") {
				$usernames.=" $post[guestname] ";
			}
		}
		$pagetext.=" $post[pagetext] ";
	}

  $subject=wordsonly($subject);
  $pagetext=$subject." ".wordsonly($pagetext);
  $usernames=wordsonly($usernames);

  $DB_site->query("UPDATE thread SET subjectindex=' ".addslashes($subject)." ',threadindex=' ".addslashes($pagetext)." ',userindex=' ".addslashes($usernames)." ' WHERE threadid=$threadid");

  return 1;
}


// ###################### Start makeforumjump #######################
function makeforumjump() {
  // this generates the jump to box
  global $DB_site,$forumid,$optionselected,$usecategories,$jumpforumid,$jumpforumtitle,$jumpforumbits,$curforumid;
  global $hideprivateforums,$defaultselected, $forumjump,$bbuserid,$bbusergroupid;

  if ($forumid!="") {
     $curforumid=$forumid;
  } else {
     if ($threadid!="")
     {
        $getforumid=$DB_site->query_first("SELECT forumid FROM thread WHERE threadid=$threadid");
        $curforumid=$getforumid[forumid];
     }
  }  


  $forums=$DB_site->query("SELECT category.categoryid, category.title AS categorytitle,
                                  forumid, forum.title AS forumtitle
                           FROM category
                           LEFT JOIN forum ON (category.categoryid = forum.categoryid)
                           WHERE category.displayorder<>0 AND forum.displayorder <> 0 AND active=1
                           ORDER BY category.displayorder, forum.displayorder");
  $firstcat = 0;
  $jumpforumbit = "";
  while ($forum=$DB_site->fetch_array($forums)) {
     $currentcat = $forum[categoryid];
     if ($usecategories == 1) {
         $optionselected="";        
         if ($firstcat != $currentcat) { // Print Category
            $firstcat = $forum[categoryid];
            // This creates our "blank line" in the dropdown
            $jumpforumid="";   
            $jumpforumtitle="";
            eval("\$jumpforumbits .= \"".gettemplate("jumpforumbit")."\";");
            $jumpforumid="cat$forum[categoryid]";
            $jumpforumtitle="Category: $forum[categorytitle]";
            eval("\$jumpforumbits .= \"".gettemplate("jumpforumbit")."\";");
            $jumpforumid="";
            $jumpforumtitle="--------------------";
            eval("\$jumpforumbits .= \"".gettemplate("jumpforumbit")."\";");
         }
     } 

     if ($hideprivateforums==1) {    
        $getperms=getpermissions($bbuserid,$bbusergroupid,$forum[forumid]);    
     } else {    
        $getperms[canview]=1;    
     } 
        
     if ($getperms[canview]==1) {    
        $jumpforumid=$forum[forumid];    
        $jumpforumtitle="  $forum[forumtitle]";    
        if ($curforumid==$jumpforumid) {    
           $optionselected="selected";    
           $selectedone=1;    
        }    
        eval("\$jumpforumbits .= \"".gettemplate("jumpforumbit")."\";");    
     }    
  }
  
  if ($selectedone!=1) {
     $defaultselected="selected";
  }
  eval("\$forumjump = \"".gettemplate("forumjump")."\";");
}

// ###################### Start countchar #######################
function countchar($string,$char) {
  //counts number of times $char occus in $string

  $charpos=strstr($string,$char);
  if ($charpos!="") {
    $charcount=countchar(substr($charpos,strlen($char)),$char)+1;
  } else {
    $charcount=0;
  }

  return $charcount;

}

// ###################### Start cookies #######################
if (isset($username)!=0 and $username!="" and isset($password)!=0) {
  if (strpos($username,"%")>0) {
    $username=urldecode($username);
  }
  $bbuserid=0;
  $bbpassword="";
  if ($userinfo=$DB_site->query_first("SELECT userid,password FROM user WHERE username='".addslashes($username)."'")) {
    if ($userinfo[password]==$password or substr(md5($userinfo[password]),0,strlen($userinfo[password]))==$password) {
      setcookie("bbuserid",$userinfo[userid],mktime(0,0,0,0,0,2020),$cookiepath);
      setcookie("bbpassword",substr(md5($userinfo[password]),0,strlen($userinfo[password])),mktime(0,0,0,0,0,2020),$cookiepath);
      $bbuserid=$userinfo[userid];
      $bbpassword=substr(md5($userinfo[password]),0,strlen($userinfo[password]));
    }
  }
}

$bbusergroupid=1;

if (isset($bbuserid)!=0 and $bbuserid!=0 and isset($bbpassword)!=0) {

  $bbuserid=$bbuserid;
  if ($userinfo=$DB_site->query_first("SELECT daysprune,lastvisit,lastactivity,cookieuser,username,password,usergroupid,timezoneoffset FROM user WHERE userid=$bbuserid")) {
    if ($bbpassword==$userinfo[password] or $bbpassword==substr(md5($userinfo[password]),0,strlen($userinfo[password]))) {
      if (isset($daysprune)==0 or $daysprune==0) {
        $daysprune=$userinfo[daysprune];
      }

      $bbusergroupid=$userinfo[usergroupid];
      $bbtimezoneoffset=$userinfo[timezoneoffset];
      if (time()-$userinfo[lastactivity]>$cookietimeout) {
        $DB_site->query("UPDATE user SET lastvisit=lastactivity WHERE userid=$bbuserid");
        $bblastvisit=$userinfo[lastactivity];
      } else {
        $bblastvisit=$userinfo[lastvisit];
      }

      $lastvisitdate=date($dateformat,$bblastvisit+(($timeoffset+$bbtimezoneoffset)*3600))." ".date($timeformat,$bblastvisit+(($timeoffset+$bbtimezoneoffset)*3600));
      $DB_site->query("UPDATE user SET lastactivity=".time()." WHERE userid=$bbuserid");

      if ($userinfo[cookieuser]==1) {
        $bbusername=$userinfo[username];
        $bbpassword=substr(md5($userinfo[password]),0,strlen($userinfo[password]));
      } else {
        $bbpassword="";
      }
    } else {
      $bbuserid=0;
    }
  } else {
    $bbuserid=0;
  }
} else {
  $bbuserid=0;
}

if ($bbuserid==0) {
  $bbpassword="";
  if (isset($bblastvisit)!=0 and $bblastvisit!=0) {
    $bblastvisit=$bblastvisit;
    if (isset($bblastactivity)==0 or $bblastactivity==0) {
      $bblastactivity=time();
    }
    if (time()-$bblastactivity>$cookietimeout) {
      setcookie("bblastvisit",$bblastactivity,mktime(0,0,0,0,0,2020),$cookiepath);
      $bblastvisit=$bblastactivity;
    }
  } else {
    setcookie("bblastvisit",time(),mktime(0,0,0,0,0,2020),$cookiepath);
    $bblastvisit=time();
  }
  setcookie("bblastactivity",time(),mktime(0,0,0,0,0,2020),$cookiepath);

  $lastvisitdate=date($dateformat,$bblastvisit+(($timeoffset)*3600))." ".date($timeformat,$bblastvisit+(($timeoffset)*3600));

}

if ($displayloggedin==1) {
  $ipaddress=getenv("REMOTE_ADDR");
  $scriptpath=$REQUEST_URI;
  $scriptpath=eregi_replace("username=([^&]*)","",$scriptpath);
  $scriptpath=eregi_replace("password=([^&]*)","",$scriptpath);
  $scriptpath=str_replace("&&","",$scriptpath);
  $scriptpath=str_replace("?&","?",$scriptpath);
  $datenow=time();
  if ($session=$DB_site->query_first("SELECT sessionid FROM session WHERE ipaddress='$ipaddress'")) {
  	 $bbuserid = intval($bbuserid);
    $DB_site->query("UPDATE session SET userid=$bbuserid,lastactivity=$datenow,location='".addslashes($scriptpath)."' WHERE sessionid=$session[sessionid]");
  } else {
    $DB_site->query("INSERT INTO session (sessionid,userid,ipaddress,lastactivity,location) VALUES (NULL,$bbuserid,'$ipaddress',$datenow,'".addslashes($scriptpath)."')");
  }
  $DB_site->query("DELETE FROM session WHERE (userid<>$bbuserid AND ipaddress='$ipaddress') OR (userid=$bbuserid AND userid<>0 AND ipaddress<>'$ipaddress') OR lastactivity<".(time()-$cookietimeout));
}

if (isset($bblastvisit)==0 or $bblastvisit==0) {
  $bblastvisit=time();
  $lastvisitdate="Never";
}

// ###################### Start templates #######################

// parse css ################## not really needed!
eval("\$cssinclude = \"".gettemplate("cssinclude")."\";");

// parse header ##################
if ($useadvheader==1) {
  eval(gettemplate("header",0));
} else {
  eval("\$header = \"".gettemplate("header")."\";");
}
if ($useadvfooter==1) {
  eval(gettemplate("footer",0));
} else {
  eval("\$footer = \"".gettemplate("footer")."\";");
}

eval("\$fivelinks = \"".gettemplate("fivelinks")."\";");

if ($url=="") {
  $url=getenv("HTTP_REFERER");
}

$timezoneorig=$timezone;

if ($bbtimezoneoffset!=0) {
  if ($bbtimezoneoffset>0) {
    $timezone.=" +$bbtimezoneoffset hours";
  } else {
    $timezone.=" $bbtimezoneoffset hours";
  }
}

$timenow=date($timeformat,time()+(($timeoffset+$bbtimezoneoffset)*3600));
// end prepare default templates ********************

// check that board is active - if not admin, then display error
if ($bbactive==0) {
  $permissions=getpermissions($bbuserid,$bbusergroupid);
  if ($permissions[cancontrolpanel]==0) {
    echo standarderror($bbtitle,$bbclosedreason);
    exit;
  }

}

?>