<?php

require("global.php");

if (isset($action)==0 or $action=="") {
  $action="newreply";
}

checkipban();

// ############################### start post reply ###############################
if ($action=="postreply") {

  // check for subject and message
  if ($message=="") {
    echo standarderror($bbtitle,gettemplate("error_nosubject",0));
    exit;
  }

  //check valid username and password and get user id
  if ($password=="" and $username!="") {
    if ($checkuser=$DB_site->query_first("SELECT username FROM user WHERE username='".addslashes($username)."'")) {
      $userid=verifyusername($username,$password);
      $username=$checkuser[username];
    } else {
      $userid=0;
      $signature="";
      $email="";
    }
  } else {
    $userid=verifyusername($username,$password);

    $userinfo=$DB_site->query_first("SELECT canpost,lastpost,usertitle,customtitle,usergroupid,posts FROM user WHERE userid=$userid");
    if ($userinfo[canpost]==0) {
      echo standarderror($bbtitle,gettemplate("error_usernopost",0));
      exit;
    }

  }

  $threadid=verifyid("thread",$threadid);

  // decode check boxes
  $parseurl=iif($parseurl=="yes",1,0);
  $email=iif($email=="yes",1,0);
  $allowsmilie=iif($disablesmilies=="yes",0,1);
  $signature=iif($signature=="yes",1,0);
  $preview=iif($preview!="",1,0);

  $threadinfo=$DB_site->query_first("SELECT title,forumid,replycount,open FROM thread WHERE threadid=$threadid");
  if ($wordwrap!=0) {
    $threadinfo[title]=dowordwrap($threadinfo[title]);
  }
  $threadtitle=$threadinfo[title];
  if ($threadinfo[open]==0) {
    eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_threadclosed")."\",\"showthread.php?threadid=$threadid\");");

    exit;
  }

  $foruminfo=$DB_site->query_first("SELECT forumid,title,active,allowposting,moderatenew FROM forum WHERE forumid=$threadinfo[forumid]");
  $forumid=$foruminfo[forumid];
  $forumtitle=$foruminfo[title];
  if ($foruminfo[active]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
    exit;
  }
  if ($foruminfo[allowposting]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumnoreply",0));
    exit;
  }
  $visible=iif($foruminfo[moderatenew]==1,0,1);

  if ($parseurl==1) {
    $message=parseurl($message);
  }

  if ($preview==1) {
    $previewpost=1;
    $previewmessage=bbcodeparse($message,$forumid,$allowsmilie);

    if ($signature==1) {
      $getsig=$DB_site->query_first("SELECT signature FROM user WHERE userid=$userid");
      $previewmessage.=bbcodeparse("\n__________________\n$getsig[signature]",0,$allowsmilies);
    }

    eval("\$postpreview=\"".gettemplate("postpreview")."\";");

    $parseurlchecked=iif($parseurl==1,"checked","");
    $emailchecked=iif($email==1,"checked","");
    $disablesmilieschecked=iif($allowsmilie==0,"checked","");
    $signaturechecked=iif($signature==1,"checked","");
    $previewchecked=0;

    $bbusername=$username;
    $bbpassword=$password;

    $action="newreply";
  } else {

    if ($enablefloodcheck==1) {
      if ($userid!=0 and time()-$userinfo[lastpost]<=$floodchecktime) {
        eval("echo standarderror(\$bbtitle,\"".gettemplate("error_floodcheck")."\");");
        exit;
      }
    }

    $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
    if ($permissions[canview]!=1 or $permissions[canreply]!=1) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
      exit;
    }

    // check max images
    if ($maximages!=0) {
      $parsedmessage=bbcodeparse($message,$forumid,$allowsmilie);
      if (countchar($parsedmessage,"<img")>$maximages) {
        eval("echo standarderror(\$bbtitle,\"".gettemplate("error_toomanyimages")."\");");
        exit;
      }
    }

    if ($enableemail==1) {
      // do emails

      // get last reply time
      $lastposttime=$DB_site->query_first("SELECT dateline FROM post WHERE threadid=$threadid ORDER BY dateline DESC LIMIT 1");

      $useremails=$DB_site->query("SELECT DISTINCT user.email,thread.title FROM post,user,thread WHERE thread.threadid=$threadid AND post.threadid=$threadid AND post.userid=user.userid AND post.email=1 AND user.userid<>$userid AND user.lastactivity>$lastposttime[dateline]");
      while ($useremail=$DB_site->fetch_array($useremails)) {

        $subject=$useremail[title];
        $toemail=$useremail[email];

        eval("\$emailmsg = \"".gettemplate("notifyemail")."\";");
        eval("\$emailsubject = \"".gettemplate("notifyemailsubject")."\";");

        mail($toemail,$emailsubject,$emailmsg,"From: \"$bbtitle Post Manager\" <$webmasteremail>");
      }
    }

    if ($logip==1 or $logip==2) {
      $ipaddress=getenv("REMOTE_ADDR");
    } else {
      $ipaddress="";
    }

    if (isset($iconid)==0 or $iconid=="") {
      $iconid=0;
    }

    if ($userid==0) {
      $postusername=$username;
    } else {
      $postusername="";
    }

    $title=censortext($title);
    $message=censortext($message);

    // see if there has been a post identical to this in the last 5 mins.  If so, update that one, as user has probably done a double post
    $datecut=time()-300;
    if ($prevpost=$DB_site->query_first("SELECT postid,visible FROM post WHERE threadid=$threadid AND username='".addslashes($postusername)."' AND userid=$userid AND title='".addslashes($title)."' AND dateline>$datecut AND pagetext='".addslashes($message)."'")) {
      $postid=$prevpost[postid];
      
      $iconid = intval($iconid);
      
      $DB_site->query("UPDATE post SET title='".addslashes($title)."',pagetext='".addslashes($message)."',allowsmilie=$allowsmilie,email=$email,signature=$signature,iconid=$iconid WHERE postid=$postid");

      // redirect
      if ($prevpost[visible]==1) {
        $goto="showthread.php?postid=$postid#post$postid";
      } else {
        $goto="forumdisplay.php?forumid=$forumid";
      }
      eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_postthanks")."\",\"$goto\");");

    } else {

      $DB_site->query("INSERT INTO post (postid,threadid,title,username,userid,dateline,pagetext,allowsmilie,email,signature,ipaddress,iconid,visible) VALUES (NULL,$threadid,'".addslashes($title)."','".addslashes($postusername)."',$userid,".time().",'".addslashes($message)."',$allowsmilie,$email,$signature,'$ipaddress',$iconid,$visible)");
      $postid=$DB_site->insert_id();

      indexthread($threadid);

      if ($visible==1) {
        if ($threadinfo[replycount]%10==0) {
          $replies=$DB_site->query_first("SELECT COUNT(postid)-1 AS replies FROM post WHERE threadid=$threadid");
          $DB_site->query("UPDATE thread SET lastpost=".time().",replycount=$replies[replies],lastposter='".addslashes($username)."' WHERE threadid=$threadid");
        } else {
          $DB_site->query("UPDATE thread SET lastpost=".time().",replycount=replycount+1,lastposter='".addslashes($username)."' WHERE threadid=$threadid");
        }
      }

      // update forum stuff
      $DB_site->query("UPDATE forum SET replycount=replycount+1,lastpost=".time().",lastposter='".addslashes($username)."' WHERE forumid=$threadinfo[forumid]");

      // update user stuff
      if ($userid!=0) {
        $usergroup=$DB_site->query_first("SELECT usertitle FROM usergroup WHERE usergroupid=$userinfo[usergroupid]");
        if ($usergroup[usertitle]=="") {
          $gettitle=$DB_site->query_first("SELECT title FROM usertitle WHERE minposts<=$userinfo[posts]+1 ORDER BY minposts DESC LIMIT 1");
          $usertitle=$gettitle[title];
        } else {
          $usertitle=$usergroup[usertitle];
        }

        if ($userinfo[customtitle]==0) {
          $dotitle="usertitle='".addslashes($usertitle)."',";
        }

        $DB_site->query("UPDATE user SET posts=posts+1,$dotitle"."lastpost=".time()." WHERE userid=$userid");
      }

      // send email to moderators
      if ($enableemail==1) {
        $moderators=$DB_site->query_first("SELECT newpostemail FROM forum WHERE forumid=$threadinfo[forumid]");
        if ($moderators[newpostemail]!="") {
          $mods=explode(" ",$moderators[newpostemail]);
          while (list($key,$val)=each($mods)) {
            $subject=$threadtitle;
            $toemail=$val;

            eval("\$emailmsg = \"".gettemplate("moderatoremail")."\";");

            mail($toemail,"Notification: New BB Post",$emailmsg,"From: \"$bbtitle Post Manager\" <$webmasteremail>");
          }
        }
      }

      // redirect
      if ($visible==1) {
        $goto="showthread.php?postid=$postid#post$postid";
      } else {
        $goto="forumdisplay.php?forumid=$forumid";
      }
      eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_postthanks")."\",\"$goto\");");
    }
  }
}

// ############################### start new reply ###############################
if ($action=="newreply") {

  // check for valid thread or post
  if (isset($threadid)==0 or $threadid==0) {
    if (isset($postid)==0 or $postid==0) {
      $idname="thread";
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_noid")."\");");

      exit;

    } else {
      if (!$post=$DB_site->query_first("SELECT postid FROM post WHERE postid=$postid AND visible=1")) {
        $idname="post";
        eval("echo standarderror(\$bbtitle,\"".gettemplate("error_invalidid")."\");");

        exit;
      }
      $getthread=$DB_site->query_first("SELECT threadid,title,pagetext,username,userid,dateline FROM post WHERE postid=$postid");
      $threadid=$getthread[threadid];
      if ($getthread[userid]==0) {
        $originalposter=htmlspecialchars($getthread[username]);
      } else {
        $getusername=$DB_site->query_first("SELECT username FROM user WHERE userid=$getthread[userid]");
        $originalposter=htmlspecialchars($getusername[username]);
      }
      if ($getthread[title]!="") {
        $title="Re: $getthread[title]";
      }
      $postdate=date($dateformat,$getthread[dateline]+(($timeoffset+$bbtimezoneoffset)*3600));
      $posttime=date($timeformat,$getthread[dateline]+(($timeoffset+$bbtimezoneoffset)*3600));
      $pagetext=htmlspecialchars($getthread[pagetext]);
      eval("\$message = \"".gettemplate("quotereply")."\";");
    }

  } else {
    if (!$thread=$DB_site->query_first("SELECT threadid FROM thread WHERE threadid=$threadid")) {
      $idname="thread";
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_invalidid")."\");");

      exit;
    }
  }

  $threadinfo=$DB_site->query_first("SELECT title,forumid,open,visible FROM thread WHERE threadid=$threadid");
  if ($wordwrap!=0) {
    $threadinfo[title]=dowordwrap($threadinfo[title]);
  }
  $threadtitle=htmlspecialchars($threadinfo[title]);
  $forumid=$threadinfo[forumid];
  if ($threadinfo[visible]==0) {
    $idname="thread";
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_invalidid")."\");");
  }

  if ($threadinfo[open]==0) {
    eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_threadclosed")."\",\"showthread.php?threadid=$threadid\");");

    exit;
  }

  $foruminfo=$DB_site->query_first("SELECT title,description,active,categoryid,allowposting,titleimage,replytemplate,headertemplate,useadvheader,footertemplate,useadvfooter,rulestemplate,allowbbcode,allowimages,allowhtml,allowsmilies FROM forum WHERE forumid=$threadinfo[forumid]");
  $forumtitle=htmlspecialchars($foruminfo[title]);
  if ($foruminfo[active]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
    exit;
  }
  if ($foruminfo[allowposting]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumnoreply",0));
    exit;
  }
  if ($foruminfo[titleimage]!="") {
    $titleimage=$foruminfo[titleimage];
  }
  if ($foruminfo[replytemplate]!="") {
    $usetemplate=$foruminfo[replytemplate];
  } else {
    $usetemplate="newreply";
  }

  $bbcodeon=iif($foruminfo[allowbbcode]==1,$ontext,$offtext);
  $imgcodeon=iif($foruminfo[allowimages]==1,$ontext,$offtext);
  $htmlcodeon=iif($foruminfo[allowhtml]==1,$ontext,$offtext);
  $smilieson=iif($foruminfo[allowsmilies]==1,$ontext,$offtext);
  if ($foruminfo[rulestemplate]!="") {
    eval("\$forumrules = \"".gettemplate("$foruminfo[rulestemplate]")."\";");
  } else {
    eval("\$forumrules = \"".gettemplate("forumrules")."\";");
  }

  $getcategory=$DB_site->query_first("SELECT title,categoryid FROM category WHERE category.categoryid=$foruminfo[categoryid]");
  $categorytitle=$getcategory[title];
  $categoryid=$getcategory[categoryid];

  $posts=$DB_site->query("SELECT user.username AS username,post.username AS fakename,post.pagetext,post.allowsmilie FROM post LEFT JOIN user ON (post.userid=user.userid) WHERE post.visible=1 AND post.threadid=$threadid ORDER BY dateline DESC");
  if ($DB_site->num_rows($posts)>$maxposts) {
    eval("\$threadreviewbits = \"".gettemplate("threadreview")."\";");
  } else {
    while ($post=$DB_site->fetch_array($posts)) {

      $username=$post[username];
      if (!$username) { $username = $post[fakename]; }
      $reviewmessage=bbcodeparse($post[pagetext],$forumid,$post[allowsmilie]);

      eval("\$threadreviewbits .= \"".gettemplate("threadreviewbit")."\";");

    }
  }

  if ($bbuserid!=0 and $previewpost!=1) {
    $userinfo=$DB_site->query_first("SELECT signature,emailnotification FROM user WHERE userid=$bbuserid");
    if ($userinfo[signature]!="") {
      $signaturechecked="CHECKED";
    }
    if ($userinfo[emailnotification]!=0) {
      $emailchecked="checked";
    }
  }

  if ($showicons==1) {
    $posticons=chooseicons($iconid);
  }  else {
    $posticons="";
  }

  if (isset($parseurl)==0) {
    $parseurlchecked="CHECKED";
  }

  // get cookies if set
  $username=$bbusername;
  $password=$bbpassword;

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]!=1 or $permissions[canreply]!=1) {
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  }

  // parse header ##################
  if ($foruminfo[headertemplate]!="") {
    if ($foruminfo[useadvheader]==1) {
      eval(gettemplate("$foruminfo[headertemplate]").";");
    } else {
      eval("\$header = \"".gettemplate("$foruminfo[headertemplate]")."\";");
    }
  }
  if ($foruminfo[footertemplate]!="") {
    if ($foruminfo[useadvfooter]==1) {
      eval(gettemplate("$foruminfo[footertemplate]").";");
    } else {
      eval("\$footer = \"".gettemplate("$foruminfo[footertemplate]")."\";");
    }
  }

  if ($foruminfo[allowsmilies]==1) {
    eval("\$disablesmiliesoption = \"".gettemplate("disablesmiliesoption")."\";");
  }
  eval("echo dovars(\"".gettemplate("$usetemplate")."\");");

}

?>