<?php

require("global.php");

checkipban();

// ############################### start open / close thread ###############################
if ($action=="openclosethread") {

  $threadid = verifyid("thread",$threadid);

  $threadinfo=$DB_site->query_first("SELECT title,forumid FROM thread WHERE threadid=$threadid");
  if ($wordwrap!=0) {
    $threadinfo[title]=dowordwrap($threadinfo[title]);
  }
  $threadtitle=htmlspecialchars($threadinfo[title]);

  $getthread=$DB_site->query_first("SELECT forumid FROM thread WHERE threadid=$threadid");
  $forumid=$getthread[forumid];
  $foruminfo=$DB_site->query_first("SELECT active,allowposting,title FROM forum WHERE forumid=$forumid");
  $forumtitle=$foruminfo[title];
  if ($foruminfo[active]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
    exit;
  }

  $username=$bbusername;
  $password=$bbpassword;

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]==0 or ($permissions[canopenclose]==0 and $permissions[canadminedit]==0)) {
    $firstpostinfo=$DB_site->query_first("SELECT userid FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  } elseif ($permissions[canadminedit]==0) {
    $firstpostinfo=$DB_site->query_first("SELECT userid FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    if ($bbuserid!=$firstpostinfo[userid]) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
      exit;
    }
  }

  eval("echo dovars(\"".gettemplate("openclosethread")."\");");

}

// ############################### start do open / close thread ###############################
if ($action=="doopenclose") {

  //check valid username and password and get user id
  $userid=verifyusername($username,$password);

  $getthread=$DB_site->query_first("SELECT forumid FROM thread WHERE threadid=$threadid");
  $forumid=$getthread[forumid];

  $foruminfo=$DB_site->query_first("SELECT active,allowposting FROM forum WHERE forumid=$forumid");
  if ($foruminfo[active]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
    exit;
  }
  $threadinfo=$DB_site->query_first("SELECT open FROM thread WHERE threadid=$threadid");

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]==0 or ($permissions[canopenclose]==0 and $permissions[canadminedit]==0)) {
    $firstpostinfo=$DB_site->query_first("SELECT userid FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  } elseif ($permissions[canadminedit]==0) {
    $firstpostinfo=$DB_site->query_first("SELECT userid FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    if ($bbuserid!=$firstpostinfo[userid]) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
      exit;
    }
  }

  if ($threadinfo[open]==1) {
    $DB_site->query("UPDATE thread SET open=0 WHERE threadid=$threadid");
    $action="closing";
  } else {
    $DB_site->query("UPDATE thread SET open=1 WHERE threadid=$threadid");
    $action="opening";
  }

  eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_openclose")."\",\"showthread.php?threadid=$threadid\");");

}

// ############################### start delete thread ###############################
if ($action=="deletethread") {

  $threadid = verifyid("thread",$threadid);

  $threadinfo=$DB_site->query_first("SELECT title,forumid FROM thread WHERE threadid=$threadid");
  if ($wordwrap!=0) {
    $threadinfo[title]=dowordwrap($threadinfo[title]);
  }
  $threadtitle=htmlspecialchars($threadinfo[title]);

  $forumid=$threadinfo[forumid];
  $foruminfo=$DB_site->query_first("SELECT active,allowposting,title FROM forum WHERE forumid=$forumid");
  $forumtitle=$foruminfo[title];
  if ($foruminfo[active]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
    exit;
  }

  $username=$bbusername;
  $password=$bbpassword;

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]==0 or ($permissions[candelete]==0 and $permissions[canadminedit]==0)) {
    $firstpostinfo=$DB_site->query_first("SELECT userid FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  } elseif ($permissions[canadminedit]==0) {
    $firstpostinfo=$DB_site->query_first("SELECT userid FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    if ($bbuserid!=$firstpostinfo[userid]) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
      exit;
    }
  }

  eval("echo dovars(\"".gettemplate("deletethread")."\");");

}

// ############################### start do delete thread ###############################
if ($action=="dodeletethread") {

  //check valid username and password and get user id
  $userid=verifyusername($username,$password);

  $getthread=$DB_site->query_first("SELECT forumid FROM thread WHERE threadid=$threadid");
  $forumid=$getthread[forumid];

  $foruminfo=$DB_site->query_first("SELECT active,allowposting FROM forum WHERE forumid=$forumid");
  if ($foruminfo[active]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
    exit;
  }

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]==0 or ($permissions[candelete]==0 and $permissions[canadminedit]==0)) {
    $firstpostinfo=$DB_site->query_first("SELECT userid FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  } elseif ($permissions[canadminedit]==0) {
    $firstpostinfo=$DB_site->query_first("SELECT userid FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    if ($bbuserid!=$firstpostinfo[userid]) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
      exit;
    }
  }

  // decrement users post counts
  $posts=$DB_site->query("SELECT userid FROM post WHERE threadid=$threadid");
  while ($post=$DB_site->fetch_array($posts)) {
    $DB_site->query("UPDATE user SET posts=posts-1 WHERE userid=$post[userid]");
  }

  $DB_site->query("DELETE FROM post WHERE threadid=$threadid");

  $DB_site->query("DELETE FROM thread WHERE threadid=$threadid");

  // update forum counts
  if ($numpost=$DB_site->query_first("SELECT COUNT(postid) AS posts FROM post,thread WHERE thread.threadid=post.threadid AND thread.forumid=$forumid")) {
    $numberposts=$numpost[posts];
  } else {
    $numberposts=0;
  }
  if ($lastposts=$DB_site->query_first("SELECT lastpost,lastposter FROM thread WHERE forumid=$forumid ORDER BY lastpost DESC LIMIT 1")) {
    $lastpost=$lastposts[lastpost];
    $lastposter=$lastposts[lastposter];
  } else {
    $lastpost=0;
    $lastposter="";
  }
  $DB_site->query("UPDATE forum SET replycount=$numberposts,threadcount=threadcount-1,lastpost=$lastpost,lastposter='".addslashes($lastposter)."' WHERE forumid=$forumid");

  eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_deletethread")."\",\"forumdisplay.php?forumid=$forumid\");");

}

// ############################### start get ip address ###############################
if ($action=="getip") {
  $postid = verifyid("post",$postid);

  $getthread=$DB_site->query_first("SELECT threadid FROM post WHERE postid=$postid");
  $threadid=$getthread[threadid];

  $checkip=$DB_site->query_first("SELECT ipaddress FROM post WHERE postid=$postid");

  if ($logip!=1) {
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_ipdisabled")."\");");
    exit;
  }

  if ($checkip[ipaddress]=="") {
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_noip")."\");");
    exit;
  }

  $username=$bbusername;
  $password=$bbpassword;

  $getthreadinfo=$DB_site->query_first("SELECT forumid FROM thread WHERE threadid=$threadid");
  $forumid=$getthreadinfo[forumid];

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]!=1 or $permissions[canadminedit]!=1) {
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  }

  eval("echo dovars(\"".gettemplate("getip")."\");");

}

// ############################### start retrieve ip ###############################
if ($action=="retrieveip") {

  $checkip=$DB_site->query_first("SELECT ipaddress FROM post WHERE postid=$postid");

  $userid=verifyusername($username,$password);

  $getthread=$DB_site->query_first("SELECT threadid FROM post WHERE postid=$postid");
  $threadid=$getthread[threadid];

  $getthread=$DB_site->query_first("SELECT forumid FROM thread WHERE threadid=$threadid");
  $forumid=$getthread[forumid];

  $ipaddress=$checkip[ipaddress];

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]!=1 or $permissions[canadminedit]!=1) {
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  }

  eval("echo standarderror(\$bbtitle,\"".gettemplate("displayip")."\");");
}

// ############################### start move thread ###############################
if ($action=="move") {

  $threadid = verifyid("thread",$threadid);

  makeforumjump();

  $threadinfo=$DB_site->query_first("SELECT title,forumid FROM thread WHERE threadid=$threadid");
  if ($wordwrap!=0) {
    $threadinfo[title]=dowordwrap($threadinfo[title]);
  }
  $threadtitle=htmlspecialchars($threadinfo[title]);
  $forumid=$threadinfo[forumid];

  $foruminfo=$DB_site->query_first("SELECT title FROM forum WHERE forumid=$threadinfo[forumid]");
  $forumtitle=htmlspecialchars($foruminfo[title]);

  $username=$bbusername;
  $password=$bbpassword;

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]==0 or ($permissions[canmove]==0 and $permissions[canadminedit]==0)) {
    $firstpostinfo=$DB_site->query_first("SELECT userid FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  } elseif ($permissions[canadminedit]==0) {
    $firstpostinfo=$DB_site->query_first("SELECT userid FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    if ($bbuserid!=$firstpostinfo[userid]) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
      exit;
    }
  }

  eval("echo dovars(\"".gettemplate("move")."\");");

}

// ############################### start do move thread ###############################
if ($action=="domove") {

  //check valid username and password and get user id
  $userid=verifyusername($username,$password);

  $forumid = verifyid("forum",$forumid);

  $threadinfo=$DB_site->query_first("SELECT forumid FROM thread WHERE threadid=$threadid");
  $curforumid=$threadinfo[forumid];

  $permissions=getpermissions($bbuserid,$bbusergroupid,$curforumid);
  if ($permissions[canview]==0 or ($permissions[canmove]==0 and $permissions[canadminedit]==0)) {
    $firstpostinfo=$DB_site->query_first("SELECT userid FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  } elseif ($permissions[canadminedit]==0) {
    $firstpostinfo=$DB_site->query_first("SELECT userid FROM post WHERE threadid=$threadid ORDER BY dateline LIMIT 1");
    if ($bbuserid!=$firstpostinfo[userid]) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
      exit;
    }
  }
  $forumid = intval($forumid);
  $DB_site->query("UPDATE thread SET forumid=$forumid WHERE threadid=$threadid");

  // update forum counts
  if ($numpost=$DB_site->query_first("SELECT COUNT(postid) AS posts FROM post,thread WHERE thread.threadid=post.threadid AND thread.forumid=$forumid")) {
    $numberposts=$numpost[posts];
  } else {
    $numberposts=0;
  }
  if ($lastposts=$DB_site->query_first("SELECT lastpost,lastposter FROM thread WHERE forumid=$forumid ORDER BY lastpost DESC LIMIT 1")) {
    $lastpost=$lastposts[lastpost];
    $lastposter=$lastposts[lastposter];
  } else {
    $lastpost=0;
    $lastposter="";
  }
  $DB_site->query("UPDATE forum SET replycount=$numberposts,threadcount=threadcount+1,lastpost=$lastpost,lastposter='".addslashes($lastposter)."' WHERE forumid=$forumid");

  // update forum counts
  if ($numpost=$DB_site->query_first("SELECT COUNT(postid) AS posts FROM post,thread WHERE thread.threadid=post.threadid AND thread.forumid=$curforumid")) {
    $numberposts=$numpost[posts];
  } else {
    $numberposts=0;
  }
  if ($lastposts=$DB_site->query_first("SELECT lastpost,lastposter FROM thread WHERE forumid=$curforumid ORDER BY lastpost DESC LIMIT 1")) {
    $lastpost=$lastposts[lastpost];
    $lastposter=$lastposts[lastposter];
  } else {
    $lastpost=0;
    $lastposter="";
  }
  $DB_site->query("UPDATE forum SET replycount=$numberposts,threadcount=threadcount-1,lastpost=$lastpost,lastposter='".addslashes($lastposter)."' WHERE forumid=$curforumid");

  eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_movethread")."\",\"showthread.php?threadid=$threadid\");");
}

// ############################### start edit thread ###############################
if ($action=="editthread") {

  // verify postid
  $threadid = verifyid("thread",$threadid);

  $threadinfo=$DB_site->query_first("SELECT title,visible,forumid,open,iconid,notes FROM thread WHERE threadid=$threadid");
  if ($wordwrap!=0) {
    $threadinfo[title]=dowordwrap($threadinfo[title]);
  }
  $threadtitle=htmlspecialchars($threadinfo[title]);
  $notes=htmlspecialchars($threadinfo[notes]);

  $forumid=$threadinfo[forumid];

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]!=1 or $permissions[canadminedit]!=1) {
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  }

  if ($threadinfo[open]==0) {
    eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_threadclosed")."\",\"showthread.php?threadid=$threadid\");");

    exit;
  }

  $foruminfo=$DB_site->query_first("SELECT title,active,allowposting FROM forum WHERE forumid=$threadinfo[forumid]");
  $forumtitle=htmlspecialchars($foruminfo[title]);
  if ($foruminfo[active]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
    exit;
  }
  if ($foruminfo[allowposting]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumnoreply",0));
    exit;
  }

  $username=$bbusername;
  $password=$bbpassword;

  $visiblechecked=iif($threadinfo[visible]==1,"CHECKED","");

  if ($showicons==1) {
    $posticons=chooseicons($threadinfo[iconid]);
  }  else {
    $posticons="";
  }

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]!=1 or $permissions[canadminedit]!=1) {
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  }

  eval("echo dovars(\"".gettemplate("editthread")."\");");

}

// ############################### start update thread ###############################
if ($action=="updatethread") {

  //check valid username and password and get user id
  $userid=verifyusername($username,$password);

  $getthread=$DB_site->query_first("SELECT forumid FROM thread WHERE threadid=$threadid");
  $forumid=$getthread[forumid];

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]!=1 or $permissions[canadminedit]!=1) {
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  }

  $foruminfo=$DB_site->query_first("SELECT active,allowposting FROM forum WHERE forumid=$forumid");
  if ($foruminfo[active]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumclosed",0));
    exit;
  }
  if ($foruminfo[allowposting]==0) {
    echo standarderror($bbtitle,gettemplate("error_forumnoreply",0));
    exit;
  }

  $visible=iif($visible=="yes",1,0);

  if ($iconid=="") {
    $iconid=0;
  }
  $iconid = intval($iconid);
  
  $DB_site->query("UPDATE thread SET visible=$visible,title='".addslashes($title)."',iconid=$iconid,notes='".addslashes($notes)."' WHERE threadid=$threadid");
  indexthread($threadid);

  $permissions=getpermissions($bbuserid,$bbusergroupid,$forumid);
  if ($permissions[canview]!=1 or $permissions[canadminedit]!=1) {
    eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
    exit;
  }

  eval("echo standardredirect(\$bbtitle,\"".gettemplate("redirect_editthread")."\",\"showthread.php?threadid=$threadid\");");
}

?>