<?php
// version numbers:
$codeversionnumber="1.1.4";
$codeinfo="RELEASE 1";

$noheader=1;

// get rid of slashes in get / post / cookie data
if (get_magic_quotes_gpc()==1 and is_array($GLOBALS)==1) {
  while(list($key,$val)=each($GLOBALS)) {
    if (is_string($val)==1) {
      $GLOBALS[$key]=stripslashes($val);
    }
  }
}
set_magic_quotes_runtime(0);

if (isset($noheader)==0 or $noheader==0) {
  // default headers
  header("HTTP/1.0 200 OK");
  header("HTTP/1.1 200 OK");
  header("Content-type: text/html");
}

if ($nocache==1) {
  // no caching
  header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");             // Date in the past
  header("Last-Modified: " . gmdate("D, d M Y H:i:s") . "GMT"); // always modified
  header("Cache-Control: no-cache, must-revalidate");           // HTTP/1.1
  header("Pragma: no-cache");                                   // HTTP/1.0
}


// ###################### Start init #######################
//load config
require("config.php");

// init db **********************
// load db class
$dbclassname="db_$dbservertype.php";
require($dbclassname);

$DB_site=new DB_Sql_vb;

$DB_site->appname="vBulletin Control Panel";
$DB_site->appshortname="vBulletin (cp)";
$DB_site->database=$dbname;
$DB_site->server=$servername;
$DB_site->user=$dbusername;
$DB_site->password=$dbpassword;

$DB_site->connect();
// end init db

// load options
$optionstemp=$DB_site->query_first("SELECT template FROM template WHERE title='options'");
eval($optionstemp[template]);

// ###################### Start iif #######################
function iif ($expression,$returntrue,$returnfalse) {

  if ($expression==0) {
    $areturn=$returnfalse;
  } else {
    $areturn=$returntrue;
  }
  return $areturn;

}

// ###################### Start writetofile #######################
function writetofile ($path,$data,$backup=0) {
// writes $data to $path renaming the old file if it exists

  if (file_exists($path)!=0) {
    if ($backup==1) {
      $filenamenew=$path."old";

      rename ($path,$filenamenew);
    } else {
      unlink($path);
    }
  }

  if ($data!="") {

    $filenum=fopen($path,"w");

    fwrite($filenum,$data);

    fclose($filenum);

  }

}

// ###################### Start readfromfile #######################
function readfromfile ($path) {
// returns all data in $path, or nothing if it does not exist

  if(file_exists($path)==0) {
    return "";
  } else {
    $filesize=filesize($path);

    $filenum=fopen($path,"r");

    $filestuff=fread($filenum,$filesize);

    fclose($filenum);

    return $filestuff;
  }

}

// ###################### Start makeinputcode #######################
function makeinputcode ($title,$name,$value="",$size=35) {
// makes code for an imput box: first column contains $title
// second column contains an input box of name, $name and value, $value. $value is "HTMLised"

  $htmlval=htmlspecialchars($value);
  $code="<tr>\n<td><p>$title</p></td>\n<td><p><input type=\"text\" size=\"$size\" name=\"$name\" value=\"$htmlval\"></p></td>\n</tr>\n";

  return $code;
}

// ###################### Start makehiddencode #######################
function makehiddencode ($name,$value="") {
// makes code for an imput box: first column contains $title
// second column contains an input box of name, $name and value, $value. $value is "HTMLised"

  $htmlval=htmlspecialchars($value);
  $code="<input type=\"hidden\" name=\"$name\" value=\"$htmlval\">\n";

  return $code;
}

// ###################### Start makepasswordcode #######################
function makepasswordcode ($title,$name,$value="",$size=35) {
// makes code for an imput box: first column contains $title
// second column contains an input box of name, $name and value, $value. $value is "HTMLised"

  $htmlval=htmlspecialchars($value);
  $code="<tr>\n<td><p>$title</p></td>\n<td><p><input type=\"password\" size=\"$size\" name=\"$name\" value=\"$htmlval\"></p></td>\n</tr>\n";

  return $code;
}

// ###################### Start makeyesnocode #######################
function makeyesnocode ($title,$name,$value=1) {
// Makes code for input buttons yes\no similar to makeinputcode

  if ($value==1) {
    $code="<tr>\n<td><p>$title</p></td>\n<td><p>Yes<input type=\"radio\" checked name=\"$name\" value=\"1\"> No <input type=\"radio\" name=\"$name\" value=\"0\"></p></td>\n</tr>";
  } else {
    $code="<tr>\n<td><p>$title</p></td>\n<td><p>Yes<input type=\"radio\" name=\"$name\" value=\"1\"> No <input type=\"radio\" checked name=\"$name\" value=\"0\"></p></td>\n</tr>";
  }

  return $code;
}

// ###################### Start maketextareacode #######################
function maketextareacode ($title,$name,$value="",$rows=4,$cols=40) {
// similar to makeinputcode, only for a text area

  $htmlval=htmlspecialchars($value);

  $code="<tr>\n<td><p>$title</p></td>\n<td><p><textarea name=\"$name\" rows=\"$rows\" cols=\"$cols\">$htmlval</textarea></p></td>\n</tr>\n";

  return $code;
}

// ###################### Start doformheader #######################
function doformheader ($phpscript,$action) {
// makes the standard form header, setting sctript to call and action to do

  $code="<form action=\"$phpscript.php\" method=\"post\">\n<input type=\"hidden\" name=\"action\" value=\"$action\">\n";
  return $code;
}

// ###################### Start doformfooter #######################
function doformfooter($submitname="Submit",$resetname="Reset") {
// closes the standard form table and makes a new one containing centred submit and reset buttons

  $code="</table>\n<div align=\"center\"><center><table border=\"0\">\n<tr>\n<td><p><p align=\"center\"><input type=\"submit\" name=\"submit\" value=\"$submitname\"></p></p></td>\n";
  if ($resetname!="") {
    $code.="<td><p><p align=\"center\"><input type=\"reset\" name=\"reset\" value=\"Reset\"></p></p></td>\n";
  }
  $code.="</tr>\n</table>\n</center></div>\n</form>\n";
  return $code;

}

// ###################### Start makechoosercode #######################
function makechoosercode ($title,$name,$tablename,$selvalue=-1,$extra="") {
// returns a combo box containing a list of titles in the $tablename table.
// allows specification of selected value in $selvalue
  global $DB_site;

  $code="<tr>\n<td><p>$title</p></td>\n<td><p><select name=\"$name\" size=\"1\">\n";
  $tableid=$tablename."id";

  $result=$DB_site->query("SELECT title,$tableid FROM $tablename ORDER BY title");
  while ($currow=$DB_site->fetch_array($result)) {

    if ($selvalue==$currow[$tableid]) {
      $code=$code."<option value=$currow[$tableid] SELECTED>$currow[title]</option>\n";
    } else {
      $code=$code."<option value=$currow[$tableid]>$currow[title]</option>\n";
    }
  } // for

  if ($extra!="") {
    if ($selvalue==-1) {
      $code=$code."<option value=-1 SELECTED>$extra</option>\n";
    } else {
      $code=$code."<option value=-1>$extra</option>\n";
    }
  }

  $code=$code."</select>\n</p></td>\n</tr>\n";

  return $code;

}

// ###################### Start getpermissions #######################
function getpermissions($userid=0,$usergroupid=0,$forumid=0) {
  global $DB_site;

  if ($usergroupid==0) {
    if ($userid==0) {
      $usergroupid=1;
    } else {
      $getuser=$DB_site->query_first("SELECT usergroupid FROM user WHERE userid=$userid");
      $usergroupid=$getuser[usergroupid];
    }
  }

  if ($forumid==0) {
    $getperms=$DB_site->query_first("SELECT canview,cansearch,canemail,canpostnew,canreply,canadminedit,canedit,candelete,canopenclose,canmove FROM usergroup WHERE usergroupid=$usergroupid");
  } else {
    if (!$getperms=$DB_site->query_first("SELECT canview,cansearch,canemail,canpostnew,canreply,canadminedit,canedit,candelete,canopenclose,canmove FROM forumpermission WHERE usergroupid=$usergroupid AND forumid=$forumid")) {
      $getperms=$DB_site->query_first("SELECT canview,cansearch,canemail,canpostnew,canreply,canadminedit,canedit,candelete,canopenclose,canmove FROM usergroup WHERE usergroupid=$usergroupid");
    }
  }

  return $getperms;

}

// ###################### Start cookies #######################
if (isset($username)!=0 and $username!="" and isset($password)!=0) {
  if (strpos($username,"%")>0) {
    $username=urldecode($username);
  }
  $bbuserid=0;
  $bbpassword="";
  if ($userinfo=$DB_site->query_first("SELECT userid,password FROM user WHERE username='".addslashes($username)."' AND password='".addslashes($password)."'")) {
    if ($userinfo[password]==$password) {
      setcookie("bbuserid",$userinfo[userid],mktime(0,0,0,0,0,2020),$cookiepath);
      setcookie("bbpassword",substr(md5($userinfo[password]),0,strlen($userinfo[password])),mktime(0,0,0,0,0,2020),$cookiepath);
      $bbuserid=$userinfo[userid];
      $bbpassword=substr(md5($userinfo[password]),0,strlen($userinfo[password]));

      setcookie("bbadminon",1,0,$cookiepath);
    }
  }
}

$bbusergroupid=1;

if (isset($bbuserid)!=0 and $bbuserid!=0 and isset($bbpassword)!=0) {

  $bbuserid=$bbuserid;
  if ($userinfo=$DB_site->query_first("SELECT username,password,usergroupid FROM user WHERE userid=$bbuserid")) {
    if ($bbpassword==$userinfo[password] or $bbpassword==substr(md5($userinfo[password]),0,strlen($userinfo[password]))) {
      $bbusergroupid=$userinfo[usergroupid];

    } else {
      $bbuserid=0;
    }
  } else {
    $bbuserid=0;
  }
} else {
  $bbuserid=0;
}

$getperms=$DB_site->query_first("SELECT cancontrolpanel FROM user,usergroup WHERE user.usergroupid=usergroup.usergroupid AND user.userid=$bbuserid");
if ($getperms[cancontrolpanel]!=1) {
  $bbuserid=0;
}

if (file_exists("install.php")==1 or file_exists("installtemplate.php")==1) {
  echo "<html><body><p>Security alert! Either install.php or installtemplate.php still remain in the admin directory. This poses a security risk, so please delete them. You cannot access the control panel until you do.</p></body></html>";
  exit;
}

if (file_exists("upgrade.php")==1 and substr($PHP_SELF,-11)!="upgrade.php") {
  echo "<html><body><p><a href=\"upgrade.php\">upgrade.php</a> exists. If you have already upgraded fully, please delete it. Otherwise, run it now.</p></body></html>";
  exit;
}

if ($bbadminon==0 and $redirect=="" and substr($PHP_SELF,-11)!="upgrade.php") {
  $bbuserid=0;
//} else {
//  setcookie("bbadminon",1,0,$cookiepath);
}

if ($bbuserid==0) {
?>
<html>
<head><title>Forums admin</title>
<body>
<p>You are either not a valid administrator or have not logged in. Please log in now:</p>
<form action="index.php" method=post>
<input type="hidden" name="redirect" value="<?php

if (GETENV("REQUEST_URI")!="") {
  echo GETENV("REQUEST_URI");
} else {
  echo $PHP_SELF;
}

?>">
<input type="text" name="username">
<input type="password" name="password">
<input type="submit" value="Submit">
</form>
</body>
</html>
<?php
  exit;
}

?>