<?php

if (function_exists("set_time_limit")==1 and get_cfg_var("safe_mode")==0) {
  set_time_limit(1200);
}

require("global.php");

?>
<html>
<?php

$newversion="1.1.4";

$oldversionbits=explode(".",$versionnumber);

//table changes
//new templates
//changed templates
//new options

if ($step=="") {
?><head><title>vBulletin Upgrade Wizard <?php echo $newversion; ?> - Welcome</title></head>
<body><p>Welcome to the vBulletin upgrade script for version <?php echo $newversion; ?></p>
<p><a href="upgrade.php?step=2">Click here to continue -></a></p>
<?php
}

if ($step==2) {
?><head><title>vBulletin Upgrade Wizard <?php echo $newversion; ?> - Update tables</title></head>
<body><p>This step will attempt to update the tables to the neccessary structure for the latest version.</p><?php

  // start version 1.1.1
  if ($oldversionbits[0]<=1 and $oldversionbits[1]<=1 and $oldversionbits[2]<1) {
    // update threadindex table

    echo "<p>Updating threadindex table...</p>";
    $DB_site->query("ALTER TABLE thread ADD subjectindex CHAR(100) NOT NULL,ADD threadindex MEDIUMTEXT NOT NULL,ADD userindex MEDIUMTEXT NOT NULL");
    $threads=$DB_site->query("SELECT threadid,title,pagetext,posters FROM threadindex ORDER BY threadid DESC");
    while($thread=$DB_site->fetch_array($threads)) {
      $DB_site->query("UPDATE thread SET subjectindex='".addslashes($thread[title])."',threadindex='".addslashes($thread[pagetext])."',userindex='".addslashes($thread[posters])."' WHERE threadid=$thread[threadid]");
      if ($thread[threadid]%100==0) {
        echo "Updating thread: $thread[threadid]\n<br>";
        flush();
      }
    }
    $DB_site->query("DROP TABLE threadindex");

    echo "<p>...successful</p>";
  }
  // end version 1.1.1

  // start version 1.1.2
  if ($oldversionbits[0]<=1 and $oldversionbits[1]<=1 and $oldversionbits[2]<2) {
    // sort tables and indicies
    echo "<p>Updating tables for 1.1.2</p>";

    // update for <normalfont tags
    $templates=$DB_site->query("SELECT templateid,title,template FROM template ORDER BY title");

    while ($template=$DB_site->fetch_array($templates)) {

      $newtemplate=$template[template];
      $newtemplate=str_replace("<font","<normalfont",$newtemplate);
      $newtemplate=str_replace("</font","</normalfont",$newtemplate);

      $DB_site->query("UPDATE template SET template='".addslashes($newtemplate)."' WHERE templateid=$template[templateid]");

      echo "<p>Updating $template[title]</p>";

    }
    $DB_site->query("UPDATE replacement SET findword='<normalfont' WHERE LEFT(findword,5)='<font'");
    $DB_site->query("INSERT INTO replacement VALUES(NULL,'</normalfont>','</font>')");

    $DB_site->reporterror=0;
    $DB_site->query("ALTER TABLE forumpermission ADD INDEX idxhome(usergroupid,canadminedit,forumid)");
    $DB_site->query("ALTER TABLE user ADD INDEX idxhome(usergroupid,username)");
    $DB_site->query("ALTER TABLE forum ADD INDEX idxhome(active,displayorder,categoryid)");
    $DB_site->query("ALTER TABLE thread ADD INDEX idxforumdisplay(lastpost,forumid,visible)");
    $DB_site->query("ALTER TABLE thread ADD INDEX idxme(forumid,lastpost,visible)");
    $DB_site->reporterror=1;
    $DB_site->query("CREATE TABLE session (
     sessionid MEDIUMINT UNSIGNED AUTO_INCREMENT NOT NULL,
     userid SMALLINT UNSIGNED NOT NULL,
     ipaddress CHAR(20) NOT NULL,
     lastactivity INT UNSIGNED NOT NULL,
     location CHAR(250) NOT NULL,
     PRIMARY KEY(sessionid)
    )");

    $DB_site->query("ALTER TABLE announcement
      CHANGE startdate startdate INT UNSIGNED NOT NULL,
      CHANGE enddate enddate INT UNSIGNED NOT NULL");

    $DB_site->query("ALTER TABLE category
      CHANGE displayorder displayorder SMALLINT NOT NULL");

    $DB_site->query("ALTER TABLE forum
      CHANGE active active SMALLINT NOT NULL,
      CHANGE replycount replycount INT UNSIGNED NOT NULL,
      CHANGE useadvheader useadvheader SMALLINT NOT NULL,
      CHANGE useadvfooter useadvfooter SMALLINT NOT NULL,
      CHANGE moderatenew moderatenew SMALLINT NOT NULL,
      CHANGE allowbbcode allowbbcode SMALLINT NOT NULL,
      CHANGE allowimages allowimages SMALLINT NOT NULL,
      CHANGE allowhtml allowhtml SMALLINT NOT NULL,
      CHANGE allowsmilies allowsmilies SMALLINT NOT NULL,
      ADD lastpost2 INT UNSIGNED NOT NULL AFTER lastpost");

    $DB_site->query("UPDATE forum SET lastpost2=UNIX_TIMESTAMP(lastpost)");

    $DB_site->query("ALTER TABLE forum
      DROP lastpost,
      CHANGE lastpost2 lastpost INT NOT NULL");

    $DB_site->query("ALTER TABLE forumpermission
      CHANGE canview canview SMALLINT NOT NULL,
      CHANGE cansearch cansearch SMALLINT NOT NULL,
      CHANGE canemail canemail SMALLINT NOT NULL,
      CHANGE canpostnew canpostnew SMALLINT NOT NULL,
      CHANGE canreply canreply SMALLINT NOT NULL,
      CHANGE canadminedit canadminedit SMALLINT NOT NULL,
      CHANGE canedit canedit SMALLINT NOT NULL,
      CHANGE candelete candelete SMALLINT NOT NULL,
      CHANGE canopenclose canopenclose SMALLINT NOT NULL,
      CHANGE canmove canmove SMALLINT NOT NULL");

    $DB_site->query("ALTER TABLE post
      CHANGE postid postid INT UNSIGNED NOT NULL AUTO_INCREMENT,
      CHANGE userid userid INT UNSIGNED NOT NULL,
      CHANGE threadid threadid INT UNSIGNED NOT NULL,
      CHANGE allowsmilie allowsmilie SMALLINT NOT NULL,
      CHANGE email email SMALLINT NOT NULL,
      CHANGE signature signature SMALLINT NOT NULL,
      CHANGE visible visible SMALLINT NOT NULL,
      ADD dateline2 INT UNSIGNED NOT NULL AFTER dateline");

    $DB_site->query("UPDATE post SET dateline2=UNIX_TIMESTAMP(dateline)");

    $DB_site->query("ALTER TABLE post
      DROP dateline,
      CHANGE dateline2 dateline INT UNSIGNED NOT NULL");

    $DB_site->query("ALTER TABLE thread
      CHANGE threadid threadid INT UNSIGNED NOT NULL AUTO_INCREMENT,
      CHANGE replycount replycount INT UNSIGNED NOT NULL,
      CHANGE visible visible SMALLINT NOT NULL,
      ADD dateline2 INT UNSIGNED NOT NULL AFTER dateline,
      ADD lastpost2 INT UNSIGNED NOT NULL AFTER lastpost");

    $DB_site->query("UPDATE thread SET lastpost2=UNIX_TIMESTAMP(lastpost),dateline2=UNIX_TIMESTAMP(dateline)");

    $DB_site->query("ALTER TABLE thread
      DROP lastpost,
      CHANGE lastpost2 lastpost INT UNSIGNED NOT NULL,
      DROP dateline,
      CHANGE dateline2 dateline INT UNSIGNED NOT NULL");

    $DB_site->query("ALTER TABLE user
      ADD invisible SMALLINT NOT NULL AFTER showemail,       # NEW FIELD
      CHANGE userid userid INT UNSIGNED NOT NULL AUTO_INCREMENT,
      CHANGE adminemail adminemail SMALLINT NOT NULL,
      CHANGE showemail showemail SMALLINT NOT NULL,
      CHANGE coppauser coppauser SMALLINT NOT NULL,
      CHANGE customtitle customtitle SMALLINT NOT NULL,
      CHANGE cookieuser cookieuser SMALLINT NOT NULL,
      CHANGE timezoneoffset timezoneoffset SMALLINT NOT NULL,
      CHANGE emailnotification emailnotification SMALLINT NOT NULL,
      ADD joindate2 INT UNSIGNED NOT NULL AFTER joindate,
      ADD lastvisit2 INT UNSIGNED NOT NULL AFTER lastvisit,
      ADD lastactivity2 INT UNSIGNED NOT NULL AFTER lastactivity,
      ADD lastpost2 INT UNSIGNED NOT NULL AFTER lastpost");

    $DB_site->query("UPDATE user SET invisible=NOT showemail,joindate2=UNIX_TIMESTAMP(joindate),lastvisit2=UNIX_TIMESTAMP(lastvisit),lastactivity2=UNIX_TIMESTAMP(lastactivity),lastpost2=UNIX_TIMESTAMP(lastpost)");

    $DB_site->query("ALTER TABLE user
      DROP joindate,
      DROP lastvisit,
      DROP lastactivity,
      DROP lastpost,
      CHANGE joindate2 joindate INT UNSIGNED NOT NULL,
      CHANGE lastvisit2 lastvisit INT UNSIGNED NOT NULL,
      CHANGE lastactivity2 lastactivity INT UNSIGNED NOT NULL,
      CHANGE lastpost2 lastpost INT UNSIGNED NOT NULL");

    $DB_site->query("ALTER TABLE usergroup
      CHANGE canview canview SMALLINT NOT NULL,
      CHANGE cansearch cansearch SMALLINT NOT NULL,
      CHANGE canemail canemail SMALLINT NOT NULL,
      CHANGE canpostnew canpostnew SMALLINT NOT NULL,
      CHANGE canreply canreply SMALLINT NOT NULL,
      CHANGE canadminedit canadminedit SMALLINT NOT NULL,
      CHANGE canedit canedit SMALLINT NOT NULL,
      CHANGE candelete candelete SMALLINT NOT NULL,
      CHANGE canopenclose canopenclose SMALLINT NOT NULL,
      CHANGE canmove canmove SMALLINT NOT NULL,
      CHANGE cancontrolpanel cancontrolpanel SMALLINT NOT NULL");
  }
  // end version 1.1.2

  echo "<p>Tables updated successfully.</p>";
  echo "<p><a href=\"upgrade.php?step=3\">Click here to continue -></a></p>";

}

if ($step==3) {
?><head><title>vBulletin Upgrade Wizard <?php echo $newversion; ?> - Add new templates</title></head>
<body><p>This step will create the new templates for this version.</p><?php

  //start version 1.1.1
  if ($oldversionbits[0]<=1 and $oldversionbits[1]<=1 and $oldversionbits[2]<1) {
    $newtemplate[error_toomanyimages] = "You have included too many images in your signature or in your previous post. Please go back and correct the problem and then continue again.</p>
<p>Images include use of smilies, the vB code [img] tag and HTML &lt;img&gt; tags. The use of these is all subject to them being enabled by the administrator.";
    $newtemplate[error_emailmismatch] = "The two email addresses that you typed do not match. Please press the back button, correct the error and try again.";
    $newtemplate[quotereply] = "[QUOTE][i]Originally posted by \$originalposter [/i]
[B]\$pagetext [/B][/QUOTE]";
    $newtemplate[showthread_nextnewestthread] = "&nbsp; <a href=\"showthread.php?threadid=\$nextnewestthreadid\">Next Thread &gt;</a>";
    $newtemplate[showthread_nextoldestthread] = "<a href=\"showthread.php?threadid=\$nextoldestthreadid\">&lt; Last Thread</a> &nbsp;";
    $newtemplate[forumdisplay_gotonew] = "<a href=\"showthread.php?goto=newpost&threadid=\$threadid\"><img src=\"images/firstnew.gif\" border=0 alt=\"Go to first new post\"></a>";
  }
  //end version 1.1.1

  //start version 1.1.2
  if ($oldversionbits[0]<=1 and $oldversionbits[1]<=1 and $oldversionbits[2]<2) {
    $newtemplate[error_showemail] = "The email address for \$destusername is <a href=\"mailto:\$email\">$email</a>";
    $newtemplate[loggedinuser] = "<a href=\"member.php?action=getinfo&userid=\$userid\">\$username</a>";
    $newtemplate[notifyemailsubject] = "Reply to post \'\$subject\'";
    $newtemplate[printthreadbit] = "<hr>
<p>Posted by \$username on \$postdate \$posttime</p>

<p><b>\$posticon \$postitle</b></p>

<p>\$message</p>
";
    $newtemplate[printthread] = "{htmldoctype}
<HTML>
<HEAD><TITLE>\$bbtitle - \$threadtitle</title>
</head>
<body >

<p><img src=\"\$titleimage\" border=\"0\"></p>

<p><b>\$bbtitle</b> (\$bburl/index.php)<br>
- <b>\$forumtitle</b> (\$bburl/forumdisplay.php?forumid=\$forumid)<br>
-- <b>\$threadtitle</b> (\$bburl/showthread.php?threadid=\$threadid)</p>

\$postbits

<hr>

<p>All times are \$timezone &nbsp;&nbsp;</p>

<p><center>Powered by: vBulletin Version \$versionnumber<BR>
Copyright &copy; Jelsoft Enterprises Limited 2000.<br>
\$copyrighttext</center></p>

</body>
</html>";
    $newtemplate[error_invalidacivateid] = "We could not activate your account because this web address is not valid. Make sure that you have the entire address from the email, and that your email client has not split the address over several lines.

Please try again with the full address from the email that you received. If it still does not work, email the <a href=\"mailto:\$webmasteremail\">administrator</a>, making sure that you include your registered email address and username.";
    $newtemplate[mailmessage] = "This is a message from \$username at \$bbtitle ( \$bburl/index.php ). The \$bbtitle owners cannot accept any responsibility for the contents of the email.

Please do not reply directly to this email. To email \$username, you can use this online form:
\$bburl/member.php?action=mailform&userid=\$userid

OR, by email:
mailto:\$useremail

This is the message:

\$message";
    $newtemplate[mailform] = "{htmldoctype}
<HTML>
<HEAD>
<title>\$bbtitle - Send Email</title>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

<FORM ACTION=\"member.php\" NAME=\"REPLIER\" METHOD=\"POST\">
<table border=0 cellpadding=4 cellspacing=1 width=100%>
<tr bgcolor=\"{tableheadbgcolor}\"><TD colspan=2 width=\"100%\">
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><B>Send an Email to: \$destusername</B></normalfont>
</td></tr>

<tr bgcolor=\"{firstaltcolor}\"><td valign=top>
<normalfont><B>Your UserName:</B></normalfont></td>
<td valign=top>
<INPUT TYPE=\"TEXT\" NAME=\"username\" VALUE=\"\$username\" SIZE=25 MAXLENGTH=25>&nbsp;&nbsp;

<smallfont><A HREF=\"member.php?action=signup\">Want to register?</a></smallfont>
</td>
</tr>
<tr bgcolor=\"{secondaltcolor}\">
<td valign=top>
<normalfont><B>Your Password:</B></normalfont></td>
<td valign=top><INPUT TYPE=\"PASSWORD\" NAME=\"password\" VALUE=\"\$password\" SIZE=13 MAXLENGTH=13>&nbsp;&nbsp;
<smallfont><A HREF=\"member.php?action=lostpw\">Forgotten your password?</A></smallfont></td></tr>

<tr bgcolor=\"{firstaltcolor}\">
<td valign=top>
<normalfont><B>Email subject:</B></normalfont></td>
<td valign=top><INPUT TYPE=\"text\" NAME=\"subject\" VALUE=\"\$subject\" SIZE=40 MAXLENGTH=85>&nbsp;</td></tr>

<TR bgcolor=\"{secondaltcolor}\"><TD valign=top nowrap>
<p><normalfont><B>Message:</B></normalfont></p>
<p>
<smallfont>
Note: by using this form,<br>
your email address will<br>
become available to the<br>
user who you are emailing.</smallfont></p>
</td>
<td>
<TEXTAREA NAME=\"message\" ROWS=10 COLS=50 WRAP=\"VIRTUAL\">\$message</TEXTAREA>
</td></tr>
</table>

<P align=\"center\">
<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"emailmessage\">
<INPUT TYPE=\"HIDDEN\" NAME=\"userid\" VALUE=\"\$userid\">
<INPUT TYPE=\"Submit\" NAME=\"submit\" VALUE=\"Send email\">
<INPUT TYPE=\"RESET\" NAME=\"RESET\" VALUE=\"Clear Fields\">
</p></form>

<p align=\"center\">\$forumjump</p>

\$footer

</body>
</html>";
    $newtemplate[error_usernoemail] = "Sorry! That user has specified that they do not wish to receive emails through this board. If you still wish to send an email to this user, please contact the <a href=\"mailto:\$webmasteremail\">administrator</a> and they may be able to help.";
    $newtemplate[memberlist] = "{htmldoctype}
<html><head><title>\$bbtitle - Members List</title>
\$cssinclude
<script language=\"javascript\">
<!--
function aimwindow(aimid) {
window.open(\"member.php?action=aimmessage&aim=\"+aimid,\"_blank\",\"toolbar=no,location=no,menubar=no,scrollbars=no,width=175,height=275,resizeable=yes,status=no\")
}
// -->
</script></head>
<body>
\$header

<table border=0 width=99% cellspacing=1 cellpadding=3>
<tr>
<td align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=0></a></td>
<td align=\"center\">\$fivelinks</td>
</tr>
</table>

<table border=0 align=right width=99% cellspacing=1 cellpadding=3>
<tr align=right>
<td>
<smallfont><a href=\"memberlist.php?action=search\">advanced search</a> |
<a href=\"memberlist.php?what=topposters&perpage=\$memberlisttopposters\">top \$memberlisttopposters posters</a> |
<a href=\"memberlist.php\">alphabetical</a> |
<a href=\"memberlist.php?what=datejoined\">date joined</a>
</smallfont>
</td>
</tr>
</table>
<br>
<table border=0 width=99% cellspacing=1 cellpadding=3>
<tr>
<td align=\"center\" bgcolor=\"{tableheadbgcolor}\"><smallfont color=\"{tableheadtextcolor}\"><b>User Name</b></smallfont></td>
<td align=\"center\" bgcolor=\"{tableheadbgcolor}\"><smallfont color=\"{tableheadtextcolor}\"><b>Email</b></smallfont></td>
<td align=\"center\" bgcolor=\"{tableheadbgcolor}\"><smallfont color=\"{tableheadtextcolor}\"><b>Homepage</b></smallfont></td>
<td align=\"center\" bgcolor=\"{tableheadbgcolor}\"><smallfont color=\"{tableheadtextcolor}\"><b>Posts by this user</b></smallfont></td>
<!--
<td align=\"center\" bgcolor=\"{tableheadbgcolor}\"><smallfont color=\"{tableheadtextcolor}\"><b>ICQ</b></smallfont></td>
<td align=\"center\" bgcolor=\"{tableheadbgcolor}\"><smallfont color=\"{tableheadtextcolor}\"><b>AIM</b></smallfont></td>
<td align=\"center\" bgcolor=\"{tableheadbgcolor}\"><smallfont color=\"{tableheadtextcolor}\"><b>Yahoo!</b></smallfont></td>
-->
<td align=\"center\" bgcolor=\"{tableheadbgcolor}\"><smallfont color=\"{tableheadtextcolor}\"><b>Biography</b></smallfont></td>
<td align=\"center\" bgcolor=\"{tableheadbgcolor}\"><smallfont color=\"{tableheadtextcolor}\"><b>Join Date</b></smallfont></td>
<td align=\"center\" bgcolor=\"{tableheadbgcolor}\"><smallfont color=\"{tableheadtextcolor}\"><b>Posts</b></smallfont></td>
</tr>
\$memberlistbits
</table>

<p><smallfont>\$pagenav</smallfont></p>

\$footer

</body>
</html>
";
    $newtemplate[memberlistbit] = "<tr>
<td bgcolor=\"{firstaltcolor}\"><normalfont face=\"Arial\" size=2><a href=\"member.php?action=getinfo&userid=\$userid\">\$username</a></normalfont></td>
<td bgcolor=\"{secondaltcolor}\" align=\"center\">\$useremail</td>
<td bgcolor=\"{secondaltcolor}\" align=\"center\">\$homepage</td>
<td bgcolor=\"{secondaltcolor}\" align=\"center\"><a href=\"search.php?action=simplesearch&exactname=yes&searchuser=\$searchuser\"><img src=\"images/find.gif\" border=0 alt=\"Find more posts by \$username\"></a></td>
<!--
<td bgcolor=\"{secondaltcolor}\" align=\"center\">\$ icqicon</td>
<td bgcolor=\"{firstaltcolor}\" align=\"center\">\$ aimicon</td>
<td bgcolor=\"{secondaltcolor}\" align=\"center\">\$ yahooicon</td>
-->
<td bgcolor=\"{firstaltcolor}\"><normalfont>\$bio</normalfont></td>
<td bgcolor=\"{secondaltcolor}\" align=\"center\"><normalfont>\$joindate</normalfont></td>
<td bgcolor=\"{firstaltcolor}\" align=\"center\"><normalfont>\$posts</normalfont></td>
</tr>";
    $newtemplate[memberlistsearch] = "{htmldoctype}
<html>
<head>
<title>\$bbtitle - Members List - Advanced Search</title>
\$cssinclude
</head>
<body>
\$header

<table border=0 width=99% cellspacing=1 cellpadding=3>
<tr>
<td align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=0></a></td>
<td align=\"center\">\$fivelinks</td>
</tr>
</table>

<table border=0 align=right width=99% cellspacing=1 cellpadding=3>
<tr align=right>
<td>
<smallfont><a href=\"memberlist.php?action=search\">advanced search</a> |
<a href=\"memberlist.php?what=topposters&perpage=\$memberlisttopposters\">top \$memberlisttopposters posters</a> |
<a href=\"memberlist.php\">alphabetical</a> |
<a href=\"memberlist.php?what=datejoined\">date joined</a>
</smallfont>
</td>
</tr>
</table>
<br>

<form action=\"memberlist.php\" method=\"post\">
<input type=\"hidden\" name=\"action\" value=\"getall\">

<table border=0 width=\"99%\" cellspacing=1 cellpadding=3>
<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2><normalfont color=\"{tableheadtextcolor}\"><b>Show users where: (blank fields are ignored)</b></normalfont></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\">
<td><normalfont><b>User Name contains</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"ausername\" value=\"\"></td>
</tr>

<tr bgcolor=\"{secondaltcolor}\">
<td><normalfont><b>and homepage contains</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"homepage\" value=\"\"></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\">
<td><normalfont><b>and ICQ Number contains</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"icq\" value=\"\"></td>
</tr>

<tr bgcolor=\"{secondaltcolor}\">
<td><normalfont><b>and AIM Handle contains</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"aim\" value=\"\"></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\">
<td><normalfont><b>and Yahoo Messenger Handle contains</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"yahoo\" value=\"\"></td>
</tr>

<tr bgcolor=\"{secondaltcolor}\">
<td><normalfont><b>and Biography contains</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"biography\" value=\"\"></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\">
<td><normalfont><b>and Join Date is after<br>(Format: yyyy-mm-dd)</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"joindateafter\" value=\"\"></td>
</tr>

<tr bgcolor=\"{secondaltcolor}\">
<td><normalfont><b>and Join Date is before<br>(Format: yyyy-mm-dd)</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"joindatebefore\" value=\"\"></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\">
<td><normalfont><b>and Last Post is after<br>(Format: yyyy-mm-dd hh:mm:ss)</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"lastpostafter\" value=\"\"></td>
</tr>

<tr bgcolor=\"{secondaltcolor}\">
<td><normalfont><b>and Last Post is before<br>(Format: yyyy-mm-dd hh:mm:ss)</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"lastpostbefore\" value=\"\"></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\">
<td><normalfont><b>and Number of Posts is greater than</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"postslower\" value=\"\"></td>
</tr>

<tr bgcolor=\"{secondaltcolor}\">
<td><normalfont><b>and Number of Posts is less than</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"postsupper\" value=\"\"></td>
</tr>

<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2><normalfont color=\"{tableheadtextcolor}\"><b>Options</b></normalfont></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\"><td><normalfont><b>Order by:</b></normalfont></td><td>
<select name=\"orderby\">
<option selected>username</option>
<option>joindate</option>
<option>lastpost</option>
<option>posts</option>
</select>
<select name=\"direction\">
<option value=\"\">in ascending order</option>
<option value=\"DESC\">in descending order</option>
</select>
</td></tr>

<tr bgcolor=\"{secondaltcolor}\">
<td><normalfont><b>Number of records per page:</b></normalfont></td>
<td><input type=\"text\" size=\"35\" name=\"perpage\" value=\"\$memberlistperpage\"></td>
</tr>

</table>

<div align=\"center\"><center>
<table border=\"0\">
<tr>
<td><p align=\"center\"><input type=\"submit\" name=\"submit\" value=\"Submit\"></p></td>
<td><p align=\"center\"><input type=\"reset\" name=\"reset\" value=\"Reset\"></p></td>
</tr>
</table>

</center></div>
</form>

\$footer
</body></html>";
    $newtemplate[error_nomemberlist] = "Sorry! The administrator has disabled the list of members.";
    $newtemplate[error_nomemberlistsearch] = "Sorry! The administrator has disabled searching of the member list.";
    $newtemplate[error_censorfield] = "One of the fields that you have entered for your profile contains words that have been added to the list of disallowed words by the administrator. Please correct any words that you think might be on the list. If the problem persists, please contact the <a href=\"mailto:\$webmasteremail\">administrator</a>.";
    $newtemplate[sendtofriendemail] = "This is a message from \$fromname ( mailto:\$fromemail ) :

\$emailmessage

\$bbtitle takes no responsibility for messages sent through its bulletin board systems.";
  }
  //end version 1.1.2

  while (list($key,$val)=@each($newtemplate)) {
    $DB_site->query("INSERT INTO template VALUES(NULL,'".addslashes($key)."','".addslashes($val)."')");
    echo "<p>Adding $key.</p>";
  }

  echo "<p>Complete.</p>";
  echo "<p><a href=\"upgrade.php?step=4\">Click here to continue -></a></p>";
}

if ($step==4 or $step==5 or $step==6) {

  // start version 1.1.1
  if ($oldversionbits[0]<=1 and $oldversionbits[1]<=1 and $oldversionbits[2]<1) {
    $newtemplate[error_wrongusername]="Invalid username. Please press the back button, enter the correct password and try again. To register, click <a href=\"member.php?action=signup\">here</a>!";
    $notes[error_wrongusername]="Fixed registration link to include correct URL. ";

    //################################################################
    $newtemplate[activateemail]="Thank you for registering at the \$bbtitle, found at \$bburl.

Your login details are as follows:
Username: \$username
Password: \$password

Don\'t forget that the password is case sensitive.

To activate your account, please visit this page:
\$bburl/member.php?action=activate&username=\$usernameenc&password=\$password&activateid=\$activateid
(Note: make sure that you paste the entire URL above into your browser, and that your email client has not wrapped it over multiple lines)

Thanks very much,
\$bbtitle team
";
    $notes[activateemail]="Fixed URL that user clicks on to activate account. ";

    //################################################################
    $newtemplate[error_wrongpassword] = "Wrong Password. Please press the back button, enter the correct password and try again. Don't forget that the password is case sensitive. Forgotten your password? Click <a href=\"member.php?action=lostpw\">here</a>!";
    $notes[error_wrongpassword] = "Fixed URL for lost password link. ";

    //################################################################
    $newtemplate[getinfo] = "{htmldoctype}
<HTML>
<HEAD>
<title>\$bbtitle - View Profile</title>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>


<table border=0 cellpadding=4 border=0 cellspacing=1 width=100%>
<tr bgcolor=\"{tableheadbgcolor}\"><TD COLSPAN=2>

<table width=\"100%\" border=0 cellpadding=0 cellspacing=0>
<tr><td align=\"left\" valign=\"middle\">

<normalfont color=\"{tableheadtextcolor}\"><B>Profile For \$username</B></normalfont>

</td><td align=\"right\" valign=\"middle\">

<A HREF=\"search.php?action=simplesearch&exactname=yes&searchuser=\$username\"><smallfont color=\"{tableheadtextcolor}\" class=thtcolor>Search: All posts by this registered user.</a></A>

</td></tr></table>

</td></tr>

<tr bgcolor=\"{secondaltcolor}\"><td>
<normalfont><B>Date Registered:</B></normalfont></td>
<td><normalfont>\$datejoined</normalfont>
</td></tr>

<tr bgcolor=\"{firstaltcolor}\"><td>
<normalfont><B>Status:</B></normalfont></td>
<td><normalfont>\$usertitle</normalfont>
</td></tr>

<tr bgcolor=\"{secondaltcolor}\"><td>
<normalfont><B>Total Posts:</B></normalfont></td>
<td><normalfont>\$totalposts</normalfont>
</td></tr>

<tr bgcolor=\"{firstaltcolor}\"><td>
<normalfont><B>Last Post:</B></normalfont></td>
<td><normalfont>\$lastpostdate \$lastposttime<br>
<a href=\"\$lastposturl\">\$lastposttitle</a>\$nolastpost</normalfont>
</td></tr>

<tr bgcolor=\"{secondaltcolor}\"><td>
<normalfont><B>Current Email:</B></normalfont></td>
<td><normalfont><A HREF=\"mailto:\$useremail\">\$useremail</A>\$usernoemail</normalfont>
</td></tr>

<TR bgcolor=\"{firstaltcolor}\">
<td><normalfont><B>Homepage:</B></normalfont></td>
<td><normalfont><A HREF=\"\$userhomepage\" target=_top>\$userhomepage</A></normalfont>
</td></tr>

<TR bgcolor=\"{secondaltcolor}\">
<td><normalfont><B>ICQ Number:</B></normalfont></td>
<td><normalfont>\$icqnumber <!-- \$ icq --></normalfont>
</td></tr>

<TR bgcolor=\"{firstaltcolor}\">
<td><normalfont><B>AOL Instant Messenger Handle:</B></normalfont></td>
<td><normalfont>\$aimhandle <!-- \$ aim --></normalfont>
</td></tr>

<TR bgcolor=\"{secondaltcolor}\">
<td><normalfont><B>Yahoo Instant Messenger Handle:</B></normalfont></td>
<td><normalfont>\$yahoohandle <!-- \$ yahoo --></normalfont>
</td></tr>

<TR bgcolor=\"{firstaltcolor}\" valign=top>
<td><normalfont><B>Biography:</B></normalfont></td>
<td><normalfont>\$biography</normalfont>
</td></tr>

</table>

<center><p><smallfont><b>Administrative Options: <a href=\"moderator.php?action=useroptions&userid=\$userid\">User Options</a></b></smallfont></p></center>

\$footer

</body>
</html>";
    $notes[getinfo] = "Created link to last post made by user. ";

    //################################################################
    $newtemplate[notifyemail] = "Hello,

\$username has just replied to your thread entitled - \$subject - in the \$forumtitle forum of \$bbtitle.

This thread is located at:
\$bburl/showthread.php?threadid=\$threadid

There may be other replies also, but you will not receive any more notifications until you visit the thread.";
    $notes[notifyemail]="Changes the wording so that visitors will only expect one notification message until they next return to the forum. ";

    //################################################################
    $newtemplate[newreply] = "{htmldoctype}
<HTML><HEAD><TITLE>\$bbtitle - Reply to Topic</TITLE>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

\$postpreview

<p><smallfont><b>Forum Rules:</b><br>
\$forumrules</smallfont></p>

<table border=\"0\" width=\"100%\" cellpadding=\"2\">
<tr><td width=\"100%\">

<normalfont><b><a href=\"index.php\">\$bbtitle</A> &gt; <a href=\"forumdisplay.php?forumid=\$forumid\">\$forumtitle</a> &gt; <a href=\"showthread.php?threadid=\$threadid\">\$threadtitle</a></b></normalfont>

</td></tr></table>

<FORM ACTION=\"newreply.php\" NAME=\"REPLIER\" METHOD=\"POST\">
<table border=0 cellpadding=4 cellspacing=1 width=\"100%\">
<tr bgcolor=\"{tableheadbgcolor}\"><TD COLSPAN=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><B>Post Reply</B></normalfont></td></tr>
<tr bgcolor=\"{firstaltcolor}\"><td valign=top>
<normalfont><B>Your UserName:</B></normalfont></td>
<td valign=top>
<INPUT TYPE=\"TEXT\" NAME=\"username\" VALUE=\"\$username\" SIZE=25 MAXLENGTH=25>&nbsp;&nbsp;

<smallfont><A HREF=\"member.php?action=signup\">Want to register?</a></smallfont>
</td>
</tr>
<tr bgcolor=\"{secondaltcolor}\">
<td valign=top>
<normalfont><B>Your Password:</B></normalfont></td>
<td valign=top><INPUT TYPE=\"PASSWORD\" NAME=\"password\" VALUE=\"\$password\" SIZE=13 MAXLENGTH=13>&nbsp;&nbsp;
<smallfont><A HREF=\"member.php?action=lostpw\">Forgotten your password?</A></smallfont></td></tr>

<tr bgcolor=\"{firstaltcolor}\">
<td valign=top>
<normalfont><B>Post subject:</B></normalfont></td>
<td valign=top><INPUT TYPE=\"text\" NAME=\"title\" VALUE=\"\$title\" SIZE=40 MAXLENGTH=85>&nbsp;<smallfont>(Optional)</smallfont></td></tr>

\$posticons

<TR bgcolor=\"{firstaltcolor}\"><TD valign=top nowrap>
<normalfont><B>Your Reply:</B></normalfont>
<p><BR>
<smallfont>
See Forum Rules (above) for<br>
more information about what<br>
codes you are allowed to use<br>
in your posts.</smallfont>
</td>
<td>
<TEXTAREA NAME=\"message\" ROWS=20 COLS=60 WRAP=\"VIRTUAL\">\$message</TEXTAREA>
</td></tr>
<TR bgcolor=\"{secondaltcolor}\">
<td valign=top>
<normalfont>
<B>Options</B>
</normalfont></td>
<td valign=top><smallfont>
<INPUT TYPE=\"CHECKBOX\" NAME=\"parseurl\" VALUE=\"yes\" \$parseurlchecked> <B>Automatically parse URLs:</B> automatically adds [url] and [/url] around internet addresses.
<BR><INPUT TYPE=\"CHECKBOX\" NAME=\"email\" VALUE=\"yes\" \$emailchecked> <B>Email Notification:</B> emails sent to you whenever someone replies. Only registered users are eligible.
\$disablesmiliesoption
<BR><INPUT TYPE=\"CHECKBOX\" NAME=\"signature\" VALUE=\"yes\" \$signaturechecked> <B>Show Signature:</B> include your profile signature.  Only registered users may have signatures.
</smallfont>
</td>
</tr>
</table>

<P align=\"center\">
<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"postreply\">
<INPUT TYPE=\"HIDDEN\" NAME=\"threadid\" VALUE=\"\$threadid\">
<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Preview Reply\">
<INPUT TYPE=\"Submit\" NAME=\"submit\" VALUE=\"Submit Reply\">
<INPUT TYPE=\"RESET\" NAME=\"RESET\" VALUE=\"Clear Fields\">
</p></form>

<TABLE cellpadding=4 border=0 cellspacing=1 WIDTH=\"100%\">
<TR bgcolor=\"{tableheadbgcolor}\"><TD COLSPAN=2 align=\"center\">
<normalfont COLOR=\"{tableheadtextcolor}\"><b>Topic Review (Newest First)</b></normalfont>
</td></tr>

\$threadreviewbits

</table>

\$footer

</body>
</html>";
    $notes[newreply] = "This template has been updated to fix a WebTV problem. I removed a spurious form tag, and added a missing closing form tag. ";


    //################################################################
    $newtemplate[newthread] = "{htmldoctype}
<HTML>
<HEAD>
<TITLE>\$bbtitle - Post New Thread</TITLE>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

\$postpreview

<p><smallfont><b>Forum Rules:</b><br>
\$forumrules</smallfont></p>

<table border=\"0\" width=\"100%\" cellpadding=\"2\">
<tr><td width=\"100%\">

<normalfont><b><a href=\"index.php\">\$bbtitle</A> &gt; <a href=\"forumdisplay.php?forumid=\$forumid\">\$forumtitle</a></b></normalfont>
</td></tr></table>

<FORM ACTION=\"newthread.php\" METHOD=\"POST\" NAME=\"postthread\">

<table border=0 cellpadding=4 cellspacing=1 width=100%>
<tr bgcolor=\"{tableheadbgcolor}\"><TD COLSPAN=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><B>Post New Thread</B></normalfont></td></tr>
<tr bgcolor=\"{firstaltcolor}\">
<td><normalfont><B>Your UserName:</B></normalfont></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"username\" SIZE=25 MAXLENGTH=25 value=\"\$username\">&nbsp;&nbsp;
<smallfont><A HREF=\"member.php?action=signup\">Want to register?</a></smallfont></td>

</tr><tr bgcolor=\"{secondaltcolor}\">

<td><normalfont><B>Your Password:</B></normalfont></td>
<td><INPUT TYPE=\"PASSWORD\" NAME=\"password\" SIZE=13 MAXLENGTH=13 value=\"\$password\">&nbsp;&nbsp;<smallfont><A HREF=\"member.php?action=lostpw\">Forgotten your password?</A></normalfont></td>

</tr><TR bgcolor=\"{firstaltcolor}\">

<td><normalfont><B>Subject:</B></normalfont></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"subject\" VALUE=\"\$subject\" SIZE=40 MAXLENGTH=85></td>

</tr>

\$posticons

<tr bgcolor=\"{firstaltcolor}\">
<td valign=top NOWRAP>

<normalfont><B>Message:</B></normalfont>

<p><smallfont>
See Forum Rules (above) for<br>
more information about what<br>
codes you are allowed to use<br>
in your posts.</smallfont>
</td>
<td>
<TEXTAREA NAME=\"message\" ROWS=20 COLS=60 WRAP=\"VIRTUAL\">\$message</TEXTAREA></td></tr>

<TR bgcolor=\"{secondaltcolor}\">
<td valign=top><normalfont><B>Options</B></normalfont></td>

<td valign=top><smallfont>
<INPUT TYPE=\"CHECKBOX\" NAME=\"parseurl\" VALUE=\"yes\" \$parseurlchecked> <B>Automatically parse URLs:</B> automatically adds [url] and [/url] around internet addresses.
<br><INPUT TYPE=\"CHECKBOX\" NAME=\"email\" VALUE=\"yes\" \$emailchecked> <B>Email Notification:</B> emails sent to you whenever someone replies. Only registered users are eligible.
\$disablesmiliesoption
<BR><INPUT TYPE=\"CHECKBOX\" NAME=\"signature\" VALUE=\"yes\" \$signaturechecked> <B>Show Signature:</B> include your profile signature.  Only registered users may have signatures.</smallfont>
</td></tr>
</table>

<P align=\"center\">
<INPUT TYPE=\"HIDDEN\" NAME=\"forumid\" VALUE=\"\$forumid\">
<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"postthread\">
<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Preview New Thread\">
<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit New Thread\">
<INPUT TYPE=\"RESET\" NAME=\"Reset\" VALUE=\"Clear Fields\">
</p>
</form>

\$footer

</body>
</html>";
    $notes[newthread]="This template has been updated to be WebTV compliant. Removed spurious form tag and added missing closing form tag. ";

    //################################################################
    $newtemplate[registeradult] = "{htmldoctype}
<HTML>
<HEAD>
<TITLE>\$bbtitle Registration</TITLE>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

<p><normalfont>In order to be able to post messages on the \$bbtitle forums, you must first register.</normalfont></p>


<table border=0 cellspacing=1 cellpadding=4 width=\"100%\">
<FORM METHOD=POST ACTION=\"member.php\">
<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><b>Registration: Required Information </b></normalfont><smallfont color=\"{tableheadtextcolor}\" class=thtcolor>All fields are required.  Please note that passwords are case sensitive.</smallfont></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\">

<TD><normalfont><B>User Name:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"username\" SIZE=25 MAXLENGTH=25>
</TD>
</TR>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Password:</B></normalfont></TD>
<TD><INPUT TYPE=\"PASSWORD\" NAME=\"password\" SIZE=25 MAXLENGTH=15> </TD></TR>

<TR bgcolor=\"{secondaltcolor}\"><TD><normalfont><B>Enter Password Again:</B></normalfont></TD>
<TD><INPUT TYPE=\"PASSWORD\" NAME=\"passwordconfirm\" SIZE=25 MAXLENGTH=15></TD></tr>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Email:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"email\" SIZE=25 MAXLENGTH=50>
</TD>
</TR>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Enter Email Again:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"emailconfirm\" SIZE=25 MAXLENGTH=50>
</TD>
</TR>

<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><b>Optional Information </b></normalfont><smallfont color=\"{tableheadtextcolor}\" class=thtcolor>All information will be viewable by other \$bbtitle members.</smallfont>
</td></tr>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Homepage:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"homepage\" VALUE=\"http://\" SIZE=25 MAXLENGTH=100>
</TD></tr>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>ICQ Number:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"icq\" SIZE=25 MAXLENGTH=20>
</TD></tr>

<tr bgcolor=\"{secondaltcolor}\">
<td>
<B><normalfont>AOL Instant Messenger Handle:</normalfont></B>
</td>
<td>
<INPUT TYPE=\"TEXT\" NAME=\"aim\" SIZE=25 MAXLENGTH=20>
</td></tr>

<tr bgcolor=\"{firstaltcolor}\">
<td>
<B><normalfont>Yahoo Messenger Handle:</normalfont></B>
</td>
<td>
<INPUT TYPE=\"TEXT\" NAME=\"yahoo\" SIZE=25 MAXLENGTH=20>
</td></tr>

<tr bgcolor=\"{secondaltcolor}\">
<td valign=top>
<B><normalfont>Biography:</normalfont></B><br>
<smallfont>A little bit of info about yourself. You might want to include: Location, occupation, interests, Instant messenger handles, etc.</smallfont>
</td>
<td>
<TEXTAREA NAME=\"biography\" ROWS=5 COLS=35>Location:
Occupation:
Interests:
</TEXTAREA>
</td></tr>

<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2>
<normalfont color=\"{tableheadtextcolor}\"><b>Preferences</b></normalfont></td>
</tr>

<TR bgcolor=\"{firstaltcolor}\">
<TD valign=top><normalfont><B>Signature:</B></normalfont><BR>
<smallfont>Optional signature you may use to appear at bottom of your posts.<br><br>
HTML code is \$htmlonoff<br>
<A HREF=\"index.php?action=bbcode\">vB Code</A> is \$bbcodeonoff<br>
[img] code is \$imgcodeonoff<br>
<a href=\"index.php?action=showsmilies\">Smilies</a> are \$smiliesonoff
</smallfont>
</TD>
<TD><TEXTAREA NAME=\"signature\" ROWS=5 COLS=35 WRAP=PHYSICAL></TEXTAREA>
</TD></tr>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Allow Bulletin Board Administrators and Moderators To Send You Email Notices?</B></normalfont></TD>
<TD><normalfont><INPUT TYPE=\"RADIO\" NAME=\"allowmail\" VALUE=\"yes\" CHECKED> yes <INPUT TYPE=\"RADIO\" NAME=\"allowmail\" VALUE=\"no\"> no</normalfont>
</TD></tr>

<tr bgcolor=\"{firstaltcolor}\">
<TD valign=top><normalfont><B>Privacy Mode:</b><br>
<smallfont>Clicking yes hides email, ICQ number, AIM ID in profile and also hides you in 'Logged In Users' list.</smallfont>
</normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"showemail\" VALUE=\"no\" > yes <INPUT TYPE=\"RADIO\" NAME=\"showemail\" VALUE=\"yes\" checked>
 no</normalfont></TD>
</TR>

<tr bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Store Username & Password in browser memory</B></normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"namestorage\" VALUE=\"yes\" CHECKED>
 yes <INPUT TYPE=\"RADIO\" NAME=\"namestorage\" VALUE=\"no\"> no</normalfont>
</TD>
</TR>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Default Thread View:</B></normalfont></TD>
<TD valign=top><SELECT NAME=\"prunedays\">
<OPTION value=\"-1\" selected>Use forum default
<OPTION value=\"1\" >Show threads from last day
<OPTION value=\"2\" >Show threads from last 2 days
<OPTION value=\"5\" >Show threads from last 5 days
<OPTION value=\"10\" >Show threads from last 10 days
<OPTION value=\"20\" >Show threads from last 20 days
<OPTION value=\"30\" >Show threads from last 30 days
<OPTION value=\"45\" >Show threads from last 45 days
<OPTION value=\"60\" >Show threads from last 60 days
<OPTION value=\"75\" >Show threads from last 75 days
<OPTION value=\"100\" >Show threads from last 100 days
<OPTION value=\"365\" >Show threads from the last year
<option value=\"1000\" >Show all threads
</SELECT>
</TD></tr>

<TR bgcolor=\"{secondaltcolor}\">
<TD valign=top><normalfont><B>Time offset:</B><br>
<smallfont>All times on the server are \$timezoneorig. Enter the number of hours that you are offset from this timezone, and all the times on the board will be altered to fit your timezone.</smallfont></normalfont></TD>
<TD valign=top><INPUT TYPE=\"TEXT\" NAME=\"timezoneoffset\" SIZE=7 MAXLENGTH=3 value=0></TD>
<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Use 'Email Notification' by default</B></normalfont><br>
<smallfont>Using this option emails you whenever someone replies to a thread that you have participated in.</smallfont></TD>
<TD><normalfont><INPUT TYPE=\"RADIO\" NAME=\"emailnotification\" VALUE=\"yes\" checked> yes <INPUT TYPE=\"RADIO\" NAME=\"emailnotification\" VALUE=\"no\" > no</normalfont>
</TD></tr>
</tr>
</TABLE>

<p align=\"center\">
<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"addmember\">
<INPUT TYPE=\"SUBMIT\" NAME=\"Submit\" VALUE=\"Submit\">
<INPUT TYPE=\"RESET\" NAME=\"Reset\" VALUE=\"Reset\">
</p></form>

\$footer

</body>
</html>";
    $notes[registeradult] = "Added 'confirm email address' field. This should reduce typos in the email box. ";

    //################################################################
    $newtemplate[registercoppa] = "{htmldoctype}
<HTML>
<HEAD>
<title>\$bbtitle - COPPA Registration</title>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

<normalfont>

<p><b>Note:</b> Until we receive a signed permission form from your parent or guardian you will be unable to post messages on this forum.</p>

<p>All of the information you provide on this page will be emailed to you and your parent or guardian with instructions for sending in the approval.</p>

</normalfont>

<FORM METHOD=POST ACTION=\"member.php\">
<input type=hidden name=coppauser value=1>

<table border=0 cellspacing=1 cellpadding=4 width=\"100%\">

<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><b>Registration: Required Information </b></normalfont><smallfont color=\"{tableheadtextcolor}\" class=thtcolor>All fields are required.  Please note that passwords are case sensitive.</smallfont></td>
</tr>

<tr bgcolor=\"{secondaltcolor}\">

<TD><normalfont><B>User Name:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"username\" SIZE=25 MAXLENGTH=25>
</TD>
</TR>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Password:</B></normalfont></TD>
<TD><INPUT TYPE=\"PASSWORD\" NAME=\"password\" SIZE=25 MAXLENGTH=15> </TD></TR>

<TR bgcolor=\"{firstaltcolor}\"><TD><normalfont><B>Enter Password Again:</B></normalfont></TD>
<TD><INPUT TYPE=\"PASSWORD\" NAME=\"passwordconfirm\" SIZE=25 MAXLENGTH=15></TD></tr>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Email:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"email\" SIZE=25 MAXLENGTH=50>
</TD>
</TR>
<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Enter Email Again:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"emailconfirm\" SIZE=25 MAXLENGTH=50>
</TD>
</TR>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Parent/Guardian Email:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"parentemail\" SIZE=25 MAXLENGTH=50>
</TD>
</TR>

<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><b>Optional Information </b></normalfont><smallfont color=\"{tableheadtextcolor}\" class=thtcolor>It is recommended that you do not reveal any personally identifying information in your profile.  All information will be viewable by other \$bbtitle members.</smallfont>
</td></tr>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Homepage:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"homepage\" VALUE=\"http://\" SIZE=25 MAXLENGTH=100>
</TD></tr>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>ICQ Number:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"icq\" SIZE=25 MAXLENGTH=20>
</TD></tr>

<tr bgcolor=\"{secondaltcolor}\">
<td>
<B><normalfont>AOL Instant Messenger Handle:</normalfont></B>
</td>
<td>
<INPUT TYPE=\"TEXT\" NAME=\"aim\" SIZE=25 MAXLENGTH=20>
</td></tr>

<tr bgcolor=\"{firstaltcolor}\">
<td>
<B><normalfont>Yahoo Messenger Handle:</normalfont></B>
</td>
<td>
<INPUT TYPE=\"TEXT\" NAME=\"yahoo\" SIZE=25 MAXLENGTH=20>
</td></tr>

<tr bgcolor=\"{secondaltcolor}\">
<td valign=top>
<B><normalfont>Biography:</normalfont></B><br>
<smallfont>A little bit of info about yourself. Do NOT include information about where you live.</smallfont>
</td>
<td>
<TEXTAREA NAME=\"biography\" ROWS=5 COLS=35>Location:
Occupation:
Interests:
</TEXTAREA>
</td></tr>

<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><b>Preferences</b></normalfont></td>
</tr>

<TR bgcolor=\"{firstaltcolor}\">
<TD valign=top><normalfont><B>Signature:</B></normalfont><BR>
<smallfont>Optional signature you may use to appear at bottom of your posts.<br><br>
HTML code is \$htmlonoff<br>
<A HREF=\"index.php?action=bbcode\">vB Code</A> is \$bbcodeonoff<br>
[img] code is \$imgcodeonoff<br>
<a href=\"index.php?action=showsmilies\">Smilies</a> are \$smiliesonoff
</smallfont>
</TD>
<TD><TEXTAREA NAME=\"signature\" ROWS=5 COLS=35 WRAP=PHYSICAL></TEXTAREA>
</TD></tr>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Allow Bulletin Board Administrators and Moderators To Send You Email Notices?</B></normalfont></TD>
<TD><normalfont><INPUT TYPE=\"RADIO\" NAME=\"allowmail\" VALUE=\"yes\" CHECKED> yes <INPUT TYPE=\"RADIO\" NAME=\"allowmail\" VALUE=\"no\"> no</normalfont>
</TD></tr>

<tr bgcolor=\"{firstaltcolor}\">
<TD valign=top><normalfont><B>Privacy Mode:</b><br>
<smallfont>Clicking yes hides email, ICQ number, AIM ID in profile and also hides you in 'Logged In Users' list.</smallfont>
</normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"showemail\" VALUE=\"no\" checked> yes <INPUT TYPE=\"RADIO\" NAME=\"showemail\" VALUE=\"yes\">
 no</normalfont></TD>
</TR>

<tr bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Store Username & Password in browser memory:</B></normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"namestorage\" VALUE=\"yes\" CHECKED>
 yes <INPUT TYPE=\"RADIO\" NAME=\"namestorage\" VALUE=\"no\"> no</normalfont>
</TD>
</TR>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Default Thread View:</B></normalfont></TD>
<TD valign=top><SELECT NAME=\"prunedays\">
<OPTION value=\"-1\" selected>Use forum default
<OPTION value=\"1\" >Show threads from last day
<OPTION value=\"2\" >Show threads from last 2 days
<OPTION value=\"5\" >Show threads from last 5 days
<OPTION value=\"10\" >Show threads from last 10 days
<OPTION value=\"20\" >Show threads from last 20 days
<OPTION value=\"30\" >Show threads from last 30 days
<OPTION value=\"45\" >Show threads from last 45 days
<OPTION value=\"60\" >Show threads from last 60 days
<OPTION value=\"75\" >Show threads from last 75 days
<OPTION value=\"100\" >Show threads from last 100 days
<OPTION value=\"365\" >Show threads from the last year
<option value=\"1000\" >Show all threads
</SELECT>
</TD></tr>

<TR bgcolor=\"{secondaltcolor}\">
<TD valign=top><normalfont><B>Time offset:</B><br>
<smallfont>All times on the server are \$timezoneorig. Enter the number of hours that you are offset from this timezone, and all the times on the board will be altered to fit your timezone.</smallfont></normalfont></TD>
<TD valign=top><INPUT TYPE=\"TEXT\" NAME=\"timezoneoffset\" SIZE=7 MAXLENGTH=3 value=0></TD>
<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Use 'Email Notification' by default</B></normalfont><br>
<smallfont>Using this option emails you whenever someone replies to a thread that you have participated in.</smallfont></TD>
<TD><normalfont><INPUT TYPE=\"RADIO\" NAME=\"emailnotification\" VALUE=\"yes\" checked> yes <INPUT TYPE=\"RADIO\" NAME=\"emailnotification\" VALUE=\"no\" > no</normalfont>
</TD></tr>
</tr>
</TABLE>

<p align=\"center\">
<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"addmember\">
<INPUT TYPE=\"SUBMIT\" NAME=\"Submit\" VALUE=\"Submit\">
<INPUT TYPE=\"RESET\" NAME=\"Reset\" VALUE=\"Reset\">
</p>
</form>

\$footer

</body>
</html>";
    $notes[registercoppa]="Added 'confirm email address' box. This should reduce typos in the email address. ";

    //################################################################
    $newtemplate[modifyprofile] = "{htmldoctype}
<HTML>
<HEAD>
<title>\$bbtitle - Update profile</title>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

\$coppatext

<FORM ACTION=\"member.php\" METHOD=\"POST\">

<table border=0 cellpadding=4 cellspacing=1 width=100%>
<tr bgcolor=\"{tableheadbgcolor}\"><TD COLSPAN=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><B>Edit Profile - \$username</B></normalfont></td></tr>
\$parentemail

<tr bgcolor=\"{firstaltcolor}\">
<td><normalfont><B>Email Address:</B></normalfont></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"email\" VALUE=\"\$useremail\" SIZE=30 MAXLENGTH=150> <normalfont color=\"#ff0000\"><sup>*</sup></normalfont></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\">
<td><normalfont><B>Confirm Email Address:</B></normalfont></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"emailconfirm\" VALUE=\"\$useremail\" SIZE=30 MAXLENGTH=150> <normalfont color=\"#ff0000\"><sup>*</sup></normalfont></td>
</tr>

<tr bgcolor=\"{secondaltcolor}\">
<td><normalfont><B>Password:</B></normalfont></td>
<td><INPUT TYPE=\"password\" NAME=\"password\" VALUE=\"\$password\" SIZE=30 MAXLENGTH=13> <normalfont color=\"#ff0000\"><sup>*</sup></normalfont></td>
</tr><tr bgcolor=\"{secondaltcolor}\">

<td><normalfont><B>Confim Password:</B></normalfont></td>
<td><INPUT TYPE=\"password\" NAME=\"passwordconfirm\" VALUE=\"\$password\" SIZE=30 MAXLENGTH=13> <normalfont color=\"#ff0000\"><sup>*</sup></normalfont></td>

</tr><tr bgcolor=\"{firstaltcolor}\">

<td><B><normalfont>Homepage:</normalfont></B></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"homepage\" VALUE=\"\$homepage\" SIZE=30 MAXLENGTH=200>
</td>

</tr><tr bgcolor=\"{secondaltcolor}\">

<td><B><normalfont>ICQ Number:</normalfont></B></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"icq\" VALUE=\"\$icq\" SIZE=30 MAXLENGTH=30></td>

</tr><tr bgcolor=\"{firstaltcolor}\">

<td><B><normalfont>AOL Instant Messenger Handle:</normalfont></B></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"aim\" VALUE=\"\$aim\" SIZE=30 MAXLENGTH=30></td>

</tr><tr bgcolor=\"{secondaltcolor}\">

<td><B><normalfont>Yahoo Messenger Handle:</normalfont></B></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"yahoo\" VALUE=\"\$yahoo\" SIZE=30 MAXLENGTH=30></td>

</tr><tr bgcolor=\"{firstaltcolor}\">

<td valign=top><B><normalfont>Biography:</normalfont></B><br>
<smallfont>A little bit of info about yourself. You might want to include: Location, occupation, interests, etc.</smallfont></td>
<td><TEXTAREA NAME=\"biography\" ROWS=5 COLS=35>\$biography</TEXTAREA></td>

</tr><tr bgcolor=\"{secondaltcolor}\">

<td valign=top><B><normalfont>Signature:</normalfont></B><BR><smallfont>Optional signature you may use to appear at bottom of your posts.<br><br>
HTML code is \$htmlonoff<br>
<A HREF=\"index.php?action=bbcode\">vB Code</A> is \$bbcodeonoff<br>
[img] code is \$imgcodeonoff<br>
<a href=\"index.php?action=showsmilies\">Smilies</a> are \$smiliesonoff
</smallfont>
</td><td><TEXTAREA NAME=\"signature\" ROWS=5 COLS=35>\$signature</TEXTAREA></td>

</tr><TR bgcolor=\"{firstaltcolor}\">

<TD><normalfont><B>Allow Bulletin Board Administrators and Moderators To Send You Email Notices?</B></normalfont></TD>
<TD><normalfont><INPUT TYPE=\"RADIO\" NAME=\"allowmail\" VALUE=\"yes\" \$allowmailchecked> yes <INPUT TYPE=\"RADIO\" NAME=\"allowmail\" VALUE=\"no\" \$allowmailnotchecked> no</normalfont></TD>

</tr><tr bgcolor=\"{secondaltcolor}\">

<TD valign=top><normalfont><B>Privacy Mode</b><br>
<smallfont>Clicking yes hides email, ICQ number, AIM ID in profile and also hides you in 'Logged In Users' list.</smallfont>
</normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"showemail\" VALUE=\"no\" \$showemailnotchecked> yes <INPUT TYPE=\"RADIO\" NAME=\"showemail\" VALUE=\"yes\" \$showemailchecked>
 no</normalfont></TD>

</TR><tr bgcolor=\"{firstaltcolor}\">

<TD><normalfont><b>Store Username & Password in browser memory</b></normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"cookieuser\" \$cookieuserchecked VALUE=\"yes\">
 yes <INPUT TYPE=\"RADIO\" NAME=\"cookieuser\" \$cookieusernotchecked VALUE=\"no\"> no</normalfont></TD>

</TR><TR bgcolor=\"{secondaltcolor}\">

<td><normalfont><b>Default Thread View:</b></normalfont></TD>
<TD valign=top><SELECT NAME=\"prunedays\">
<option value=\"-1\" \$daysdefaultselected>Use forum default</option>
<OPTION value=\"1\" \$days1selected>Show threads from last day</option>
<OPTION value=\"2\" \$days2selected>Show threads from last 2 days</option>
<OPTION value=\"5\" \$days5selected>Show threads from last 5 days</option>
<OPTION value=\"10\" \$days10selected>Show threads from last 10 days</option>
<OPTION value=\"20\" \$days20selected>Show threads from last 20 days</option>
<OPTION value=\"30\" \$days30selected>Show threads from last 30 days</option>
<OPTION value=\"45\" \$days45selected>Show threads from last 45 days</option>
<OPTION value=\"60\" \$days60selected>Show threads from last 60 days</option>
<OPTION value=\"75\" \$days75selected>Show threads from last 75 days</option>
<OPTION value=\"100\" \$days100selected>Show threads from last 100 days</option>
<OPTION value=\"365\" \$days365selected>Show threads from the last year</option>
<OPTION value=\"1000\" \$days1000selected>Show all threads</option>
</SELECT>
</TD>

</tr><TR bgcolor=\"{firstaltcolor}\">

<TD valign=top><normalfont><B>Time offset:</B><br>
<smallfont>All times on the server are \$timezoneorig. Enter the number of hours that you are offset from this timezone, and all the times on the board will be altered to fit your timezone.</smallfont></normalfont></TD>
<TD valign=top><INPUT TYPE=\"TEXT\" NAME=\"timezoneoffset\" SIZE=7 MAXLENGTH=3 value=\$timezoneoffset></TD>
<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Use 'Email Notification' by default</B></normalfont><br>
<smallfont>Using this option emails you whenever someone replies to a thread that you have participated in.</smallfont></TD>
<TD><normalfont><INPUT TYPE=\"RADIO\" NAME=\"emailnotification\" VALUE=\"yes\" \$emailnotificationchecked> yes <INPUT TYPE=\"RADIO\" NAME=\"emailnotification\" VALUE=\"no\" \$emailnotificationnotchecked> no</normalfont>
</TD></tr>

</tr></table>
<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">
<tr><td width=\"100%\" align=\"right\">
<normalfont><b><normalfont color=\"#ff0000\"><sup>*</sup> - Required Field</normalfont></b></normalfont>
</td></tr>
</table>

<p align=\"center\">
<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"updateprofile\">
<INPUT TYPE=\"HIDDEN\" NAME=\"userid\" VALUE=\"\$userid\">
<INPUT TYPE=\"HIDDEN\" NAME=\"oldpassword\" VALUE=\"\$password\">
<INPUT TYPE=\"SUBMIT\" NAME=\"Submit\" VALUE=\"Submit Modifications\">
<INPUT TYPE=\"RESET\" NAME=\"Reset\" VALUE=\"Clear Fields\">
</p>
</form>

\$footer

</body>
</html>";
    $notes[modifyprofile]="Added 'confirm email address' field. This should reduce typos in the email address. ";

    //################################################################
    $newtemplate[postbit] = "<tr bgcolor=\"\$backcolor\">
<TD width=\"20%\" valign=\"top\" nowrap>

<table width=\"100%\" cellpadding=\"4\" cellspacing=\"0\" border=\"0\">
<tr><td width=\"100%\">
<a name=\"post\$postid\"></a>
\$firstnewname
<normalfont><B>\$username</B></normalfont><br>
<smallfont>\$usertitle</smallfont><br><br>
<smallfont>Registered: \$userjoindate<br>
Posts: \$userpostcount</smallfont>

</td></tr></table>

</td><td valign=\"top\" width=\"80%\">

<table width=\"100%\" cellpadding=\"4\" cellspacing=\"0\" border=\"0\">
<tr><td width=\"100%\">

\$posticon <smallfont><B>\$postitle</b></smallfont>
<p><normalfont>\$message</normalfont></p>

</td></tr></table>

</td></tr>

<tr bgcolor=\"\$backcolor\">
<td width=\"20%\" valign=\"middle\" height=\"16\" nowrap>

\$foldericon <smallfont>\$postdate \$posttime</smallfont>
</td><td width=\"80%\" valign=\"middle\" height=\"16\">

<table width=\"100%\" border=0 cellpadding=0 cellspacing=0>
<tr><td align=\"left valign=\"middle\">

\$profile \$useremail \$homepage <a href=\"search.php?action=simplesearch&exactname=yes&searchuser=\$searchuser\"><img src=\"images/find.gif\" border=0 alt=\"Find more posts by \$username\"></a> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a HREF=\"editpost.php?action=editpost&postid=\$postid\"><IMG SRC=\"images/edit.gif\"  BORDER=0 ALT=\"Edit/Delete Message\"></A> &nbsp;&nbsp; <A HREF=\"newreply.php?action=newreply&postid=\$postid\"><IMG SRC=\"images/quote.gif\" BORDER=0 ALT=\"Reply w/Quote\"></A>

</td><td align=\"right\" valign=\"middle\" nowrap>
<smallfont>\$iplogged</smallfont>
</td></tr>
</table>

</td></tr>";
    $notes[postbit] = "Added a name tag for linking direct to an individual post. Tidied tags slightly. ";

    //################################################################
    $newtemplate[redirect_postthanks] ="Thank you for posting, \$username. You will now be taken to your post. If the administrator has selected to moderate all posts in this forum, you will be taken back to the forum and your post will be displayed presently.";
    $notes[redirect_postthanks] = "Re-worded slightly since you are now returned to your thread. ";

    //################################################################
    $newtemplate[forumdisplay] = "{htmldoctype}
<HTML>
<HEAD><TITLE>\$bbtitle - \$forumtitle</title>
\$cssinclude
</head>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

<table border=\"0\" width=\"100%\" cellpadding=\"2\">
<form action=\"forumdisplay.php\" method=\"get\">
<tr><td width=\"100%\">

<normalfont><b><a href=\"index.php\">\$bbtitle</A> &gt; \$forumtitle</b><br><smallfont>\$moderatedby</smallfont></normalfont>

</td><td valign=\"bottom\" align=\"right\" nowrap>
<normalfont><b>Show threads from:</b></normalfont>
<INPUT TYPE=\"HIDDEN\" NAME=\"forumid\" VALUE=\"\$forumid\">
<SELECT NAME=\"daysprune\">
  <OPTION value=\"1\" \$daysprune1selected>Last day
  <OPTION value=\"2\" \$daysprune2selected>Last 2 days
  <OPTION value=\"5\" \$daysprune5selected>Last 5 days
  <OPTION value=\"10\" \$daysprune10selected>Last 10 days
  <OPTION value=\"20\" \$daysprune20selected>Last 20 days
  <OPTION value=\"30\" \$daysprune30selected>Last 30 days
  <OPTION value=\"45\" \$daysprune45selected>Last 45 days
  <OPTION value=\"60\" \$daysprune60selected>Last 60 days
  <OPTION value=\"75\" \$daysprune75selected>From last 75 days
  <OPTION value=\"100\" \$daysprune100selected>From last 100 days
  <OPTION value=\"365\" \$daysprune365selected>From the last year
  <OPTION value=\"1000\" \$daysprune1000selected>Show all threads
</SELECT>
<INPUT TYPE=\"SUBMIT\" VALUE=\"Go\"></smallfont>
</TD></tr></form>
</table>


<table border=0 cellpadding=4 border=0 cellspacing=1 width=\"100%\">
<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=3>
<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">
<tr>
<td>
<A HREF=\"newthread.php?action=newthread&forumid=\$forumid\"><IMG SRC=\"\$newthreadimage\"  BORDER=0 ALT=\"Post New Thread\"></A>
</td>
<td width=\"100%\" align=\"center\">
<smallfont color=\"{tableheadtextcolor}\"><B>Thread</A></B></smallfont>
</td>
</tr></table>

</td>

<td align=center nowrap><smallfont color=\"{tableheadtextcolor}\"><B>Thread Starter</B></smallfont>
</td>
<td align=center><smallfont color=\"{tableheadtextcolor}\"><B>Replies</B></smallfont>
</td>
<td align=center><smallfont color=\"{tableheadtextcolor}\"><B>Views</B></smallfont>
</td>
<td align=center nowrap>

<smallfont color=\"{tableheadtextcolor}\"><B>Last Post</A></B></smallfont>

</td></tr>

\$announcement
\$forumdisplaybits

<TR bgcolor=\"{tableheadbgcolor}\">
<TD valign=\"middle\" width=\"100%\" colspan=\"7\">

<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">
<tr>

<td valign=\"middle\">
<A HREF=\"newthread.php?action=newthread&forumid=\$forumid\"><IMG SRC=\"\$newthreadimage\"  BORDER=0 ALT=\"Post New Thread\"></A>
</td>

<td width=\"100%\" valign=\"middle\" align=\"right\">
<smallfont color=\"{tableheadtextcolor}\"><b>
All times are \$timezone. All dates are in Month-Day-Year format.</b></smallfont>
</td>

</tr></table>

</table>

<table border=\"0\" width=\"100%\" cellpadding=\"2\">
<tr><td width=\"100%\" valign=\"top\">

\$forumjump

</td><td valign=\"top\" align=\"right\" nowrap>
<smallfont>\$pagenav</TD></tr></table>

<center><table border=0><tr>
<td><img src=\"images/newfolder.gif\" border=0 alt=\"New Posts\"></td>
<td><b><smallfont>New Posts</smallfont></b></td>
<td><img src=\"images/folder.gif\" border=0 alt=\"No New Posts\"></td>
<td><b><smallfont>No New Posts</smallfont></b></td>
<td><img src=\"images/newhotfolder.gif\" border=0 alt=\"Hot Thread\"><img src=\"images/hotfolder.gif\" border=0 alt=\"Hot Thread\"></td>
<td><b><smallfont>More than \$hotnumber replies</smallfont></b></td>
<td><IMG SRC=\"images/lock.gif\" BORDER=0 ALT=\"Closed Thread\"></td>
<td><b><smallfont>Closed thread</smallfont></b>
</tr></table></center>

<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">
<tr><td width=\"100%\">
<p><smallfont><b>Forum Rules:</b><br>
\$forumrules</smallfont></p>
</td><td nowrap>
<p><smallfont><b>Admin Options:</b><br>
<a href=\"moderator.php?action=viewqueue&forumid=\$forumid\">View Moderation Queue</a><br>
<a href=\"moderator.php?action=move&forumid=\$forumid\">Mass Move</a><br>
<a href=\"moderator.php?action=prune&forumid=\$forumid\">Mass Prune</a>
</smallfont></td></tr></table>

\$footer";
    $notes[forumdisplay] = "Addressed netscape issues where columns widths were mixed up. ";

    //################################################################
    $newtemplate[fivelinks] = "<A HREF=\"member.php?action=editprofile\"><img src=\"images/top_profile.gif\" alt=\"Edit your profile\" border=0></A> &nbsp;
<A HREF=\"member.php?action=signup\"><img src=\"images/top_register.gif\" alt=\"Registration is free!\" border=0></A> &nbsp;
<A HREF=\"index.php?action=faq\" target=_blank><img src=\"images/top_faq.gif\" alt=\"Frequently Asked Questions\" border=0></A> &nbsp;
<A HREF=\"search.php\"><img src=\"images/top_search.gif\" alt=\"Search\" border=0></A> &nbsp;
<A HREF=\"index.php\"><img src=\"images/top_home.gif\" alt=\"Home\" border=0></A>";
    $notes[fivelinks] = "Added link to home page. ";

    //################################################################
    $newtemplate[announcebit] = "<tr bgcolor=\"\$backcolor\">
<TD width=18% valign=top>
\$firstnewname
<normalfont><B>\$username</B></normalfont><BR>
<smallfont>
\$usertitle<br><br>
Registered: \$userjoindate<br>
Posts: \$userpostcount<!-- <br>
ICQ Status: \$ icq<br>
\$ aim<br>
Yahoo Messenger status: \$ yahoo<br> -->
</smallfont></td></td>
<TD valign=top><normalfont><B>\$postitle</b> <smallfont color=\"{timecolor}\"> (\$announcestartdate until \$announceenddate) &nbsp;&nbsp;&nbsp;
<A HREF=\"member.php?action=getinfo&userid=\$userid\" target=_blank>
<IMG SRC=\"images/profile.gif\" BORDER=0 ALT=\"Click Here to See the Profile for \$username\"></A> &nbsp;&nbsp;
\$useremail
&nbsp; &nbsp;
</normalfont><HR>

\$message

</normalfont></td></tr>";
    $notes[announcebit] = "Tidied HTML. ";

    //################################################################
    $newtemplate[announcement] = "{htmldoctype}
<HTML><HEAD>
<TITLE>\$bbtitle - \$forumtitle Announcements</title>
\$cssinclude
<script language=\"javascript\">
<!--
function aimwindow(aimid) {
window.open(\"member.php?action=aimmessage&aim=\"+aimid,\"_blank\",\"toolbar=no,location=no,menubar=no,scrollbars=no,width=175,height=275,resizeable=yes,status=no\")
// -->
}
</script>
</head>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

<table border=\"0\" width=\"100%\" cellpadding=\"2\">
<tr><td width=\"100%\">
<normalfont><b><a href=\"index.php\">\$bbtitle</A> &gt; <a href=\"forumdisplay.php?forumid=\$forumid\">\$forumtitle</a> &gt; Announcements</normalfont>
</td><td nowrap align=\"right\">
<normalfont><b>Current Announcements: \$announcecount</b></normalfont></td>
</tr></table>

<a name=\"posttop\">

<table width=100% border=0 cellspacing=1 cellpadding=4><TR bgcolor=\"{tableheadbgcolor}\">

<TD valign=middle width=20%>
<smallfont color=\"{tableheadtextcolor}\"><B>Author</B></smallfont></TD>

<TD valign=middle>
&nbsp;
</TD>
</TR>

\$announcebits

<TR bgcolor=\"{tableheadbgcolor}\">
<TD valign=\"middle\" width=\"100%\" colspan=\"2\">

<smallfont color=\"{tableheadtextcolor}\"><b>
All times are \$timezone. All dates are in Month-Day-Year format.</b></smallfont></td>
</tr></table>

<table width=\"100%\" border=\"0\" cellpadding=\"0\">
<tr><td align=\"right\" width=\"100%\">
\$forumjump
</td></tr></table>

\$footer

</html>
</body>";
    $notes[announcement]="Tidied HTML code. ";

    //################################################################
    $newtemplate[categorybit] = "<TR bgcolor=\"{categorybackcolor}\" id=cat><TD colspan=6>
<normalfont color=\"{categoryfontcolor}\"><B>\$categorytitle</B></normalfont></td>
</tr>";
    $notes[categorybit]="Changed font color to support CSS. ";

    //################################################################
    $newtemplate[forumbit] = "<TR>
<TD bgcolor=\"{firstaltcolor}\" align=center valign=top><IMG SRC=\"images/\$onoff.gif\" BORDER=0></td>
<TD bgcolor=\"{firstaltcolor}\" valign=top><normalfont><B>
<A HREF=\"forumdisplay.php?forumid=\$forumid\">\$forumtitle</A></B></normalfont><BR>
<smallfont>\$forumdescription</smallfont></td>
<td bgcolor=\"{secondaltcolor}\" align=center valign=top NOWRAP>
<normalfont>\$numberposts</normalfont></td>
<td bgcolor=\"{firstaltcolor}\" align=center valign=top NOWRAP>
<normalfont>\$numberthreads</normalfont></td>
<td bgcolor=\"{secondaltcolor}\" NOWRAP valign=top align=center>
<normalfont><a href=\"showthread.php?goto=lastpost&forumid=\$forumid\"><img src=\"images/lastpost.gif\" border=0 alt=\"Go to last post\"></a> \$lastpostdate <normalfont COLOR=\"{timecolor}\">\$lastposttime</normalfont>
<br><smallfont>\$lastposter</smallfont></td>
<td bgcolor=\"{firstaltcolor}\" valign=top align=center>
<normalfont>\$moderators</normalfont></td>
</tr>

";
    $notes[forumbit] = "Added blue arrow links and sorted Netscape problems. ";

    //################################################################
    $newtemplate[forumdisplaybit] = "<TR>
<TD align=center bgcolor=\"{firstaltcolor}\">
<IMG SRC=\"images/\$newoldhot.gif\" BORDER=0></td>

<td align=center bgcolor=\"{secondaltcolor}\">
\$threadicon
</td>

<td bgcolor=\"{firstaltcolor}\" width=\"100%\"><normalfont>
\$gotonew <A HREF=\"showthread.php?threadid=\$threadid\">\$threadtitle</a> <smallfont>\$pagenav</smallfont></normalfont>
</td>

<td align=center bgcolor=\"{secondaltcolor}\" nowrap>
<normalfont>\$firstposter</normalfont>
</td>

<td align=center bgcolor=\"{firstaltcolor}\">
<normalfont>\$replies</normalfont>
</td>

<td align=center bgcolor=\"{secondaltcolor}\">
<normalfont>\$views</normalfont>
</td>

<td bgcolor=\"{firstaltcolor}\" nowrap>
<normalfont><a href=\"showthread.php?goto=lastpost&threadid=\$threadid\"><img src=\"images/lastpost.gif\" border=0 alt=\"Go to last post\"></a> \$lastreplydate <normalfont COLOR=\"{timecolor}\">\$lastreplytime</normalfont> by \$lastposter</normalfont>
</td></tr>";
    $notes[forumdisplaybit] = "Added blue arrows to link to last new post and last post in thread. ";

    //################################################################
    $newtemplate[forumdisplay_announcement] = "<TR>
<TD align=center bgcolor=\"{firstaltcolor}\">
<IMG SRC=\"images/\$newannounceimage\" BORDER=0></td>

<td align=center bgcolor=\"{secondaltcolor}\">
&nbsp;
</td>

<td bgcolor=\"{firstaltcolor}\"><normalfont>
Announcement: <A HREF=\"announcement.php?forumid=\$forumid\">\$announcementtitle</a></normalfont>
</td>

<td align=center nowrap bgcolor=\"{secondaltcolor}\">
<normalfont>\$announceposter </normalfont><smallfont>(\$announceusertitle)</smallfont>
</td>

<td align=center bgcolor=\"{firstaltcolor}\">
<normalfont>-</normalfont>
</td>

<td align=center bgcolor=\"{secondaltcolor}\">
<normalfont>-</normalfont>
</td>

<td bgcolor=\"{firstaltcolor}\" nowrap>
<normalfont>\$postdate</normalfont>
</td></tr>
";
    $notes[forumdisplay_announcement] = "Tidied HTML. ";

    //################################################################
    $newtemplate[loggedinusers] = "<TR bgcolor=\"{categorybackcolor}\" id=cat><TD colspan=6>
<normalfont color=\"{categoryfontcolor}\"><B>Currently Active Users:</B></normalfont></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\"><td colspan=6>
<smallfont>\$activeusers</smallfont></td>
</tr>";
    $notes[loggedinusers] = "Tidied HTML code. ";

  }
  // end version 1.1.1

  // start version 1.1.2
  if ($oldversionbits[0]<=1 and $oldversionbits[1]<=1 and $oldversionbits[2]<2) {
    //################################################################
    $newtemplate[loggedinusers] = "<TR bgcolor=\"{categorybackcolor}\" id=cat><TD colspan=6>
<normalfont color=\"{categoryfontcolor}\"><B>Currently Active Users:</B></normalfont><br><smallfont>There are currently \$numberregistered  member(s) and \$numberguest guest(s) on the boards.</smallfont></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\"><td colspan=6>
<smallfont>\$activeusers</smallfont></td>
</tr>
";
    $notes[loggedinusers] .= "Added support for guest users. You now get the number of guests online too. ";

    //################################################################
    $newtemplate[categorybit] = "<TR bgcolor=\"{categorybackcolor}\" id=cat><TD colspan=6>
<normalfont color=\"{categoryfontcolor}\"><B><a href=\"index.php?categoryid=\$categoryid\">\$categorytitle</a></B></normalfont></td>
</tr>";
    $notes[categorybit] .= "Added hyperlink to individual category page. This now has an anchor in it where it was previously in the code. ";

    //################################################################
    $newtemplate[standarderror] = "{htmldoctype}
<HTML>
<HEAD><TITLE>\$pagetitle</title>
\$cssinclude
\$headinsert
</head>
<body>
\$header


<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

<table border=0 cellpadding=4 cellspacing=1 width=100%>
<tr bgcolor=\"{tableheadbgcolor}\"><TD width=\"100%\">

<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><B>vBulletin Message</B></normalfont>

</td></tr>
<tr bgcolor=\"{firstaltcolor}\"><td width=\"100%\">
<normalfont>\$errormessage</normalfont>
</td></tr></table>

<p align=\"center\">\$forumjump</p>

\$footer

</body>
</html>";
    $notes[standarderror] .= "Fixed lack of closing body and html tags. ";

    //################################################################
    $newtemplate[error_nopermission] = "You are not logged in or you do not have permission to access this page. This could be due to one of several reasons:

<ol>
<li>You are not logged in. Fill in the form at the bottom of this page and try again.</li>
<li>You do not have permission to access the page that you were trying to. Are you trying to edit someone else\'s post or trying to access administrative features? Check that you are allowed to perform this action in the Forum Rules.</li>
<li>If you are trying to post, to administrator may have disabled your account, or it may be awaiting activation.</li>
</ol>

<p>To log in, fill in the form below:

<p>
<form action=\"index.php\" method=post>
Username: <INPUT TYPE=\"TEXT\" NAME=\"username\" SIZE=7 MAXLENGTH=25>
Password: <INPUT TYPE=\"PASSWORD\" NAME=\"password\" SIZE=7 MAXLENGTH=13>
<input type=\"hidden\" name=\"action\" value=\"login\">
<input type=\"hidden\" name=\"redirect\" value=\"\$url\">
<input type=\"submit\" value=\"Login!\">

<p><smallfont>The administrator may have required you to <a href=\"member.php?action=signup\">register</a> before you can view this page. <a href=\"member.php?action=lostpw\">Forgotten your password?</a></smallfont>";
    $notes[error_nopermission] .= "Added closing form tag to template. This was causing the form to be mucked up by certain browsers. ";

    //################################################################
    $newtemplate[notifyemail] = "Hello,

\$username has just replied to your thread entitled - \$subject - in the \$forumtitle forum of \$bbtitle.

This thread is located at:
\$bburl/showthread.php?threadid=\$threadid

There may be other replies also, but you will not receive any more notifications until you visit the thread.";
    $notes[notifyemail] .= "Updated to reflect change in times when email sent. Email is now only sent once every time the user visits. ";

    //################################################################
    $newtemplate[showthread_numpages] = "This thread is \$totalpages pages long: &nbsp;&nbsp;";
    $notes[showthread_numpages] .= "Added 2 x nbsp tags at end to provide spacing. ";

    //################################################################
    $newtemplate[forumdisplay] = "{htmldoctype}
<HTML>
<HEAD><TITLE>\$bbtitle - \$forumtitle</title>
\$cssinclude
</head>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

<table border=\"0\" width=\"100%\" cellpadding=\"2\">
<form action=\"forumdisplay.php\" method=\"get\">
<tr><td width=\"100%\">

<normalfont><b><a href=\"index.php\">\$bbtitle</A> &gt; \$forumtitle</b><br><smallfont>\$moderatedby</smallfont></normalfont>

</td><td valign=\"bottom\" align=\"right\" nowrap>
<normalfont><b>Show threads from:</b></normalfont>
<INPUT TYPE=\"HIDDEN\" NAME=\"forumid\" VALUE=\"\$forumid\">
<SELECT NAME=\"daysprune\">
  <OPTION value=\"1\" \$daysprune1selected>Last day
  <OPTION value=\"2\" \$daysprune2selected>Last 2 days
  <OPTION value=\"5\" \$daysprune5selected>Last 5 days
  <OPTION value=\"10\" \$daysprune10selected>Last 10 days
  <OPTION value=\"20\" \$daysprune20selected>Last 20 days
  <OPTION value=\"30\" \$daysprune30selected>Last 30 days
  <OPTION value=\"45\" \$daysprune45selected>Last 45 days
  <OPTION value=\"60\" \$daysprune60selected>Last 60 days
  <OPTION value=\"75\" \$daysprune75selected>From last 75 days
  <OPTION value=\"100\" \$daysprune100selected>From last 100 days
  <OPTION value=\"365\" \$daysprune365selected>From the last year
  <OPTION value=\"1000\" \$daysprune1000selected>Show all threads
</SELECT>
<INPUT TYPE=\"SUBMIT\" VALUE=\"Go\"></smallfont>
</TD></tr></form>
</table>


<table border=0 cellpadding=4 border=0 cellspacing=1 width=\"100%\">
<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=3>
<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">
<tr>
<td>
<A HREF=\"newthread.php?action=newthread&forumid=\$forumid\"><IMG SRC=\"\$newthreadimage\"  BORDER=0 ALT=\"Post New Thread\"></A>
</td>
<td width=\"100%\" align=\"center\">
<smallfont color=\"{tableheadtextcolor}\"><B>Thread</A></B></smallfont>
</td>
</tr></table>

</td>

<td align=center nowrap><smallfont color=\"{tableheadtextcolor}\"><B>Thread Starter</B></smallfont>
</td>
<td align=center><smallfont color=\"{tableheadtextcolor}\"><B>Replies</B></smallfont>
</td>
<td align=center><smallfont color=\"{tableheadtextcolor}\"><B>Views</B></smallfont>
</td>
<td align=center nowrap>

<smallfont color=\"{tableheadtextcolor}\"><B>Last Post</A></B></smallfont>

</td></tr>

\$announcement
\$forumdisplaybits

<TR bgcolor=\"{tableheadbgcolor}\">
<TD valign=\"middle\" width=\"100%\" colspan=\"7\">

<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">
<tr>

<td valign=\"middle\">
<A HREF=\"newthread.php?action=newthread&forumid=\$forumid\"><IMG SRC=\"\$newthreadimage\" BORDER=0 ALT=\"Post New Thread\"></A>
</td>

<td width=\"100%\" valign=\"middle\" align=\"right\">
<smallfont color=\"{tableheadtextcolor}\"><b>
All times are \$timezone. All dates are in Month-Day-Year format.</b></smallfont>
</td>

</tr></table>

</table>

<table border=\"0\" width=\"100%\" cellpadding=\"2\">
<tr><td nowrap valign=\"top\">

\$forumjump

</td><td valign=\"top\" align=\"right\">
<smallfont>\$pagenav</TD></tr></table>

<center><table border=0><tr>
<td><img src=\"images/newfolder.gif\" border=0 alt=\"New Posts\"></td>
<td><b><smallfont>New Posts</smallfont></b></td>
<td><img src=\"images/folder.gif\" border=0 alt=\"No New Posts\"></td>
<td><b><smallfont>No New Posts</smallfont></b></td>
<td><img src=\"images/newhotfolder.gif\" border=0 alt=\"Hot Thread\"><img src=\"images/hotfolder.gif\" border=0 alt=\"Hot Thread\"></td>
<td><b><smallfont>More than \$hotnumber replies</smallfont></b></td>
<td><IMG SRC=\"images/lock.gif\" BORDER=0 ALT=\"Closed Thread\"></td>
<td><b><smallfont>Closed thread</smallfont></b>
</tr></table></center>

<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">
<tr><td width=\"100%\">
<p><smallfont><b>Forum Rules:</b><br>
\$forumrules</smallfont></p>
</td><td nowrap>
<p><smallfont><b>Admin Options:</b><br>
<a href=\"moderator.php?action=viewqueue&forumid=\$forumid\">View Moderation Queue</a><br>
<a href=\"moderator.php?action=move&forumid=\$forumid\">Mass Move</a><br>
<a href=\"moderator.php?action=prune&forumid=\$forumid\">Mass Prune</a>
</smallfont></td></tr></table>

\$footer
</body>
</html>";
    $notes[forumdisplay] .= "Sorted problem with long lists of numbers. ";

    //################################################################
    $newtemplate[newreply] = "{htmldoctype}
<HTML><HEAD><TITLE>\$bbtitle - Reply to Topic</TITLE>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

\$postpreview

<p><smallfont><b>Forum Rules:</b><br>
\$forumrules</smallfont></p>

<table border=\"0\" width=\"100%\" cellpadding=\"2\">
<tr><td width=\"100%\">

<normalfont><b><a href=\"index.php\">\$bbtitle</A> &gt; <a href=\"forumdisplay.php?forumid=\$forumid\">\$forumtitle</a> &gt; <a href=\"showthread.php?threadid=\$threadid\">\$threadtitle</a></b></normalfont>

</td></tr></table>

<FORM ACTION=\"newreply.php\" NAME=\"REPLIER\" METHOD=\"POST\">
<table border=0 cellpadding=4 cellspacing=1 width=\"100%\">
<tr bgcolor=\"{tableheadbgcolor}\"><TD COLSPAN=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><B>Post Reply</B></normalfont></td></tr>
<tr bgcolor=\"{firstaltcolor}\"><td valign=top>
<normalfont><B>Your UserName:</B></normalfont></td>
<td valign=top>
<INPUT TYPE=\"TEXT\" NAME=\"username\" VALUE=\"\$username\" SIZE=25 MAXLENGTH=25>&nbsp;&nbsp;

<smallfont><A HREF=\"member.php?action=signup\">Want to register?</a></smallfont>
</td>
</tr>
<tr bgcolor=\"{secondaltcolor}\">
<td valign=top>
<normalfont><B>Your Password:</B></normalfont></td>
<td valign=top><INPUT TYPE=\"PASSWORD\" NAME=\"password\" VALUE=\"\$password\" SIZE=13 MAXLENGTH=13>&nbsp;&nbsp;
<smallfont><A HREF=\"member.php?action=lostpw\">Forgotten your password?</A></smallfont></td></tr>

<tr bgcolor=\"{firstaltcolor}\">
<td valign=top>
<normalfont><B>Post subject:</B></normalfont></td>
<td valign=top><INPUT TYPE=\"text\" NAME=\"title\" VALUE=\"\$title\" SIZE=40 MAXLENGTH=85>&nbsp;<smallfont>(Optional)</smallfont></td></tr>

\$posticons

<TR bgcolor=\"{firstaltcolor}\"><TD valign=top nowrap>
<normalfont><B>Your Reply:</B></normalfont>
<p><BR>
<smallfont>
See Forum Rules (above) for<br>
more information about what<br>
codes you are allowed to use<br>
in your posts.</smallfont>
</td>
<td>
<TEXTAREA NAME=\"message\" ROWS=20 COLS=60 WRAP=\"VIRTUAL\">\$message</TEXTAREA>
</td></tr>
<TR bgcolor=\"{secondaltcolor}\">
<td valign=top>
<normalfont>
<B>Options</B>
</normalfont></td>
<td valign=top><smallfont>
<INPUT TYPE=\"CHECKBOX\" NAME=\"parseurl\" VALUE=\"yes\" \$parseurlchecked> <B>Automatically parse URLs:</B> automatically adds [url] and [/url] around internet addresses.
<BR><INPUT TYPE=\"CHECKBOX\" NAME=\"email\" VALUE=\"yes\" \$emailchecked> <B>Email Notification:</B> emails sent to you whenever someone replies. Only registered users are eligible.
\$disablesmiliesoption
<BR><INPUT TYPE=\"CHECKBOX\" NAME=\"signature\" VALUE=\"yes\" \$signaturechecked> <B>Show Signature:</B> include your profile signature.  Only registered users may have signatures.
</smallfont>
</td>
</tr>
</table>

<P align=\"center\">
<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"postreply\">
<INPUT TYPE=\"HIDDEN\" NAME=\"threadid\" VALUE=\"\$threadid\">
<INPUT TYPE=\"Submit\" NAME=\"preview\" VALUE=\"Preview Reply\">
<INPUT TYPE=\"Submit\" NAME=\"submit\" VALUE=\"Submit Reply\">
<INPUT TYPE=\"RESET\" NAME=\"RESET\" VALUE=\"Clear Fields\">
</p></form>

<TABLE cellpadding=4 border=0 cellspacing=1 WIDTH=\"100%\">
<TR bgcolor=\"{tableheadbgcolor}\"><TD COLSPAN=2 align=\"center\">
<normalfont COLOR=\"{tableheadtextcolor}\"><b>Topic Review (Newest First)</b></normalfont>
</td></tr>

\$threadreviewbits

</table>

\$footer

</body>
</html>";
    $notes[newreply] .= "Changed preview button code. It now will work with translations. ";

    //################################################################
    $newtemplate[newthread] = "{htmldoctype}
<HTML>
<HEAD>
<TITLE>\$bbtitle - Post New Thread</TITLE>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

\$postpreview

<p><smallfont><b>Forum Rules:</b><br>
\$forumrules</smallfont></p>

<table border=\"0\" width=\"100%\" cellpadding=\"2\">
<tr><td width=\"100%\">

<normalfont><b><a href=\"index.php\">\$bbtitle</A> &gt; <a href=\"forumdisplay.php?forumid=\$forumid\">\$forumtitle</a></b></normalfont>
</td></tr></table>

<FORM ACTION=\"newthread.php\" METHOD=\"POST\" NAME=\"postthread\">

<table border=0 cellpadding=4 cellspacing=1 width=100%>
<tr bgcolor=\"{tableheadbgcolor}\"><TD COLSPAN=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><B>Post New Thread</B></normalfont></td></tr>
<tr bgcolor=\"{firstaltcolor}\">
<td><normalfont><B>Your UserName:</B></normalfont></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"username\" SIZE=25 MAXLENGTH=25 value=\"\$username\">&nbsp;&nbsp;
<smallfont><A HREF=\"member.php?action=signup\">Want to register?</a></smallfont></td>

</tr><tr bgcolor=\"{secondaltcolor}\">

<td><normalfont><B>Your Password:</B></normalfont></td>
<td><INPUT TYPE=\"PASSWORD\" NAME=\"password\" SIZE=13 MAXLENGTH=13 value=\"\$password\">&nbsp;&nbsp;<smallfont><A HREF=\"member.php?action=lostpw\">Forgotten your password?</A></normalfont></td>

</tr><TR bgcolor=\"{firstaltcolor}\">

<td><normalfont><B>Subject:</B></normalfont></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"subject\" VALUE=\"\$subject\" SIZE=40 MAXLENGTH=85></td>

</tr>

\$posticons

<tr bgcolor=\"{firstaltcolor}\">
<td valign=top NOWRAP>

<normalfont><B>Message:</B></normalfont>

<p><smallfont>
See Forum Rules (above) for<br>
more information about what<br>
codes you are allowed to use<br>
in your posts.</smallfont>
</td>
<td>
<TEXTAREA NAME=\"message\" ROWS=20 COLS=60 WRAP=\"VIRTUAL\">\$message</TEXTAREA></td></tr>

<TR bgcolor=\"{secondaltcolor}\">
<td valign=top><normalfont><B>Options</B></normalfont></td>

<td valign=top><smallfont>
<INPUT TYPE=\"CHECKBOX\" NAME=\"parseurl\" VALUE=\"yes\" \$parseurlchecked> <B>Automatically parse URLs:</B> automatically adds [url] and [/url] around internet addresses.
<br><INPUT TYPE=\"CHECKBOX\" NAME=\"email\" VALUE=\"yes\" \$emailchecked> <B>Email Notification:</B> emails sent to you whenever someone replies. Only registered users are eligible.
\$disablesmiliesoption
<BR><INPUT TYPE=\"CHECKBOX\" NAME=\"signature\" VALUE=\"yes\" \$signaturechecked> <B>Show Signature:</B> include your profile signature.  Only registered users may have signatures.
</smallfont>
</td></tr>
</table>

<P align=\"center\">
<INPUT TYPE=\"HIDDEN\" NAME=\"forumid\" VALUE=\"\$forumid\">
<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"postthread\">
<INPUT TYPE=\"Submit\" NAME=\"preview\" VALUE=\"Preview Reply\">
<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit New Thread\">
<INPUT TYPE=\"RESET\" NAME=\"Reset\" VALUE=\"Clear Fields\">
</p>
</form>

\$footer

</body>
</html>";
    $notes[newthread] .= "Changed preview button code. It will now work with translations. ";

    //################################################################
    $newtemplate[activateemailsubject] = "Activation Instructions for \$bbtitle";
    $notes[activateemailsubject] .= "Changed wording";

    //################################################################
    $newtemplate[activateemail] = "Thank you for registering at the \$bbtitle, found at \$bburl.

Your login details are as follows:
Username: \$username
Password: \$password

Don\'t forget that the password is case sensitive.

To activate your account, please visit this page:
\$bburl/member.php?action=activate&username=\$usernameenc&password=\$password&activateid=\$activateid
(Note: make sure that you paste the entire URL above into your browser, and that your email client has not wrapped it over multiple lines)

Until you activate your account, you will be told that you do not have permission whenever you try to post.

Thanks very much,
\$bbtitle team
";
    $notes[activateemail] .= "Altered email to support more secure method of registration. The activateid is now passed to prevent user from by passing it. ";

    //################################################################
    $newtemplate[showthread] = "{htmldoctype}
<HTML>
<HEAD><TITLE>\$bbtitle - \$threadtitle</title>
\$cssinclude
<script language=\"javascript\">
<!--
function aimwindow(aimid) {
window.open(\"member.php?action=aimmessage&aim=\"+aimid,\"_blank\",\"toolbar=no,location=no,menubar=no,scrollbars=no,width=175,height=275,resizeable=yes,status=no\")
// -->
}
</script>
</head>
<body>
\$header


<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
<br><smallfont><img src=\"images/sendtofriend.gif\" border=\"0\"> <a href=\"sendtofriend.php?threadid=\$threadid\">Email This Page to Someone!</a></smallfont>
<br><smallfont><img src=\"images/printer.gif\" border=\"0\"> <a href=\"printthread.php?threadid=\$threadid\">Show a Printable Version</a></smallfont>
</td></tr></table>

<table width=\"100%\" cellpadding=\"4\" cellspacing=\"0\" border=\"0\">
<tr><td width=\"100%\">
\$firstunread
</td></tr></table>

<table border=\"0\" width=\"100%\" cellpadding=\"2\">
<tr><td width=\"100%\">

<normalfont><b><a href=\"index.php\">\$bbtitle</A> &gt; <A HREF=\"forumdisplay.php?forumid=\$forumid\">\$forumtitle</a><br>\$threadtitle</b></normalfont>

</td>
<td valign=\"bottom\" align=\"right\" nowrap><smallfont>\$nextoldest \$nextnewest</smallfont></TD>
</tr></table>

<a name=\"posttop\">
<table width=100% border=0 cellspacing=1 cellpadding=4>
<TR bgcolor=\"{tableheadbgcolor}\">
<TD valign=\"middle\" width=\"175\" nowrap>
<smallfont color=\"{tableheadtextcolor}\" class=thtcolor><B>Author</B></smallfont>
</TD>
<TD valign=\"middle\" width=\"100%\">

<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">
<tr><td width=\"100%\" valign=\"middle\">

<smallfont color=\"{tableheadtextcolor}\" class=thtcolor><B>Thread &nbsp;&nbsp; \$pagenav</B></smallfont>

</td><td valign=\"middle\">

<A HREF=\"newthread.php?action=newthread&forumid=\$forumid\"><IMG SRC=\"\$newthreadimage\"  BORDER=0 ALT=\"Post New Thread\"></A>

</td><td valign=\"middle\">
<normalfont>&nbsp;&nbsp;&nbsp;</normalfont>

</td><td valign=\"middle\">

<A HREF=\"newreply.php?action=newreply&threadid=\$threadid\"><IMG SRC=\"\$replyclose\" BORDER=0 ALT=\"Post A Reply\"></A>

</td></tr></table>

</TD>
</TR>
</table>

\$postbits

<table width=100% border=0 cellspacing=1 cellpadding=4>
<TR bgcolor=\"{tableheadbgcolor}\">
<TD valign=\"middle\" width=\"100%\" colspan=\"2\">

<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">
<tr><td width=\"100%\" valign=\"middle\">

<smallfont color=\"{tableheadtextcolor}\"><b>
All times are \$timezone &nbsp;&nbsp; \$pagenav
</b></smallfont>

</td><td valign=\"middle\">

<A HREF=\"newthread.php?action=newthread&forumid=\$forumid\"><IMG SRC=\"\$newthreadimage\"  BORDER=0 ALT=\"Post New Thread\"></A>

</td><td valign=\"middle\">
<normalfont>&nbsp;&nbsp;&nbsp;</normalfont>

</td><td valign=\"middle\">

<A HREF=\"newreply.php?action=newreply&threadid=\$threadid\"><IMG SRC=\"\$replyclose\" BORDER=0 ALT=\"Post A Reply\"></A>

</td></tr></table>

</table>

<table border=\"0\" width=\"100%\" cellpadding=\"2\">
<tr><td width=\"100%\" valign=\"top\">

\$forumjump

</td>
<td valign=\"top\" align=\"right\" nowrap><smallfont>\$nextoldest \$nextnewest</smallfont></TD>
</tr></table>


<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">
<tr><td width=\"100%\">
<p><smallfont><b>Forum Rules:</b><br>
\$forumrules</smallfont></p>
</td><td nowrap>
<p><smallfont><b>Admin Options:</b><br>
<a href=\"postings.php?action=openclosethread&threadid=\$threadid\">Open / Close Thread</a><br>
<a href=\"postings.php?action=move&threadid=\$threadid\">Move Thread</a><br>
<a href=\"postings.php?action=deletethread&threadid=\$threadid\">Delete Thread</a><br>
<a href=\"postings.php?action=editthread&threadid=\$threadid\">Edit Thread</a></smallfont></p>
</td></tr></table>

\$footer

</body>
</html>";
    $notes[showthread] .= "Made each post in a separate table to speed rendering. Also added Printer Friendly link. ";

    //################################################################
    $newtemplate[postbit] = "<table width=100% border=0 cellspacing=1 cellpadding=4>
<tr bgcolor=\"\$backcolor\">
<TD width=\"175\" valign=\"top\" nowrap>

<table width=\"100%\" cellpadding=\"4\" cellspacing=\"0\" border=\"0\">
<tr><td width=\"100%\">
<a name=\"post\$postid\"></a>
\$firstnewname
<normalfont><B>\$username</B></normalfont><br>
<smallfont>\$usertitle</smallfont><br><br>
<smallfont>Registered: \$userjoindate<br>
Posts: \$userpostcount</smallfont>

</td></tr></table>

</td><td valign=\"top\" width=\"100%\">

<table width=\"100%\" cellpadding=\"4\" cellspacing=\"0\" border=\"0\">
<tr><td width=\"100%\">

\$posticon <smallfont><B>\$postitle</b></smallfont>
<p><normalfont>\$message</normalfont></p>

</td></tr></table>

</td></tr>

<tr bgcolor=\"\$backcolor\">
<td width=\"175\" valign=\"middle\" height=\"16\" nowrap>

\$foldericon <smallfont>\$postdate \$posttime</smallfont>
</td><td width=\"100%\" valign=\"middle\" height=\"16\">

<table width=\"100%\" border=0 cellpadding=0 cellspacing=0>
<tr><td align=\"left valign=\"middle\">

\$profile \$useremail \$homepage <a href=\"search.php?action=simplesearch&exactname=yes&searchuser=\$searchuser\"><img src=\"images/find.gif\" border=0 alt=\"Find more posts by \$username\"></a> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a HREF=\"editpost.php?action=editpost&postid=\$postid\"><IMG SRC=\"images/edit.gif\"  BORDER=0 ALT=\"Edit/Delete Message\"></A> &nbsp;&nbsp; <A HREF=\"newreply.php?action=newreply&postid=\$postid\"><IMG SRC=\"images/quote.gif\" BORDER=0 ALT=\"Reply w/Quote\"></A>

</td><td align=\"right\" valign=\"middle\" nowrap>
<smallfont>\$iplogged</smallfont>
</td></tr>
</table>

</td></tr></table>";
    $notes[postbit] .= "Made each post in a separate table to speed rendering. ";

    //################################################################
    $newtemplate[forumrules] = "<B>Who Can Read The Forum?</b> Any registered user or guest.<br>
<b>Who Can Post New Topics?</b> Any registered user.<br>
<B>Who Can Post Replies?</b> Any registered user.<br>
<b>Changes:</b> Messages can be edited by their author. Messages can be deleted by their author.<br>
<b>Posts:</b> HTML code is \$htmlcodeon. <a href=\"index.php?action=showsmilies\" target=_blank>Smilies</a> are \$smilieson. <a href=\"index.php?action=bbcode\" target=_blank>vB code</a> is \$bbcodeon. [IMG] code is \$imgcodeon.";
    $notes[forumrules] .= "Added support for on/off switches for HTML code, vB code, etc. These are now updated to reflect forum settings. ";

    //################################################################
    $newtemplate[fivelinks] = "<A HREF=\"member.php?action=editprofile\"><img src=\"images/top_profile.gif\" alt=\"Edit your profile\" border=0></A> &nbsp;
<A HREF=\"member.php?action=signup\"><img src=\"images/top_register.gif\" alt=\"Registration is free!\" border=0></A> &nbsp;
<A HREF=\"memberlist.php\"><img src=\"images/top_members.gif\" alt=\"Find other members\" border=0></A><br>
<A HREF=\"index.php?action=faq\" target=_blank><img src=\"images/top_faq.gif\" alt=\"Frequently Asked Questions\" border=0></A> &nbsp;
<A HREF=\"search.php\"><img src=\"images/top_search.gif\" alt=\"Search\" border=0></A> &nbsp;
<A HREF=\"index.php\"><img src=\"images/top_home.gif\" alt=\"Home\" border=0></A> <!-- &nbsp;
<A HREF=\"member.php?action=clearcookies\"><img src=\"images/top_logout.gif\" alt=\"Logout\" border=0></A>  -->";
    $notes[fivelinks] .= "Added member list link. ";

    //################################################################
    $newtemplate[modifyprofile] = "{htmldoctype}
<HTML>
<HEAD>
<title>\$bbtitle - Update profile</title>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

\$coppatext

<FORM ACTION=\"member.php\" METHOD=\"POST\">

<table border=0 cellpadding=4 cellspacing=1 width=100%>
<tr bgcolor=\"{tableheadbgcolor}\"><TD COLSPAN=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><B>Edit Profile - \$username</B></normalfont></td></tr>
\$parentemail

<tr bgcolor=\"{firstaltcolor}\">
<td><normalfont><B>Email Address:</B></normalfont></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"email\" VALUE=\"\$useremail\" SIZE=30 MAXLENGTH=150> <normalfont color=\"#ff0000\"><sup>*</sup></normalfont></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\">
<td><normalfont><B>Confirm Email Address:</B></normalfont></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"emailconfirm\" VALUE=\"\$useremail\" SIZE=30 MAXLENGTH=150> <normalfont color=\"#ff0000\"><sup>*</sup></normalfont></td>
</tr>

<tr bgcolor=\"{secondaltcolor}\">
<td><normalfont><B>Password:</B></normalfont></td>
<td><INPUT TYPE=\"password\" NAME=\"password\" VALUE=\"\$password\" SIZE=30 MAXLENGTH=13> <normalfont color=\"#ff0000\"><sup>*</sup></normalfont></td>
</tr><tr bgcolor=\"{secondaltcolor}\">

<td><normalfont><B>Confim Password:</B></normalfont></td>
<td><INPUT TYPE=\"password\" NAME=\"passwordconfirm\" VALUE=\"\$password\" SIZE=30 MAXLENGTH=13> <normalfont color=\"#ff0000\"><sup>*</sup></normalfont></td>

</tr><tr bgcolor=\"{firstaltcolor}\">

<td><B><normalfont>Homepage:</normalfont></B></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"homepage\" VALUE=\"\$homepage\" SIZE=30 MAXLENGTH=200>
</td>

</tr><tr bgcolor=\"{secondaltcolor}\">

<td><B><normalfont>ICQ Number:</normalfont></B></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"icq\" VALUE=\"\$icq\" SIZE=30 MAXLENGTH=30></td>

</tr><tr bgcolor=\"{firstaltcolor}\">

<td><B><normalfont>AOL Instant Messenger Handle:</normalfont></B></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"aim\" VALUE=\"\$aim\" SIZE=30 MAXLENGTH=30></td>

</tr><tr bgcolor=\"{secondaltcolor}\">

<td><B><normalfont>Yahoo Messenger Handle:</normalfont></B></td>
<td><INPUT TYPE=\"TEXT\" NAME=\"yahoo\" VALUE=\"\$yahoo\" SIZE=30 MAXLENGTH=30></td>

</tr><tr bgcolor=\"{firstaltcolor}\">

<td valign=top><B><normalfont>Biography:</normalfont></B><br>
<smallfont>A little bit of info about yourself. You might want to include: Location, occupation, interests, etc.</smallfont></td>
<td><TEXTAREA NAME=\"biography\" ROWS=5 COLS=35>\$biography</TEXTAREA></td>

</tr><tr bgcolor=\"{secondaltcolor}\">

<td valign=top><B><normalfont>Signature:</normalfont></B><BR><smallfont>Optional signature you may use to appear at bottom of your posts.<br><br>
HTML code is \$htmlonoff<br>
<A HREF=\"index.php?action=bbcode\">vB Code</A> is \$bbcodeonoff<br>
[img] code is \$imgcodeonoff<br>
<a href=\"index.php?action=showsmilies\">Smilies</a> are \$smiliesonoff
</smallfont>
</td><td><TEXTAREA NAME=\"signature\" ROWS=5 COLS=35>\$signature</TEXTAREA></td>

</tr><TR bgcolor=\"{firstaltcolor}\">

<TD><normalfont><B>Allow Bulletin Board Administrators and Moderators To Send You Email Notices?</B></normalfont></TD>
<TD><normalfont><INPUT TYPE=\"RADIO\" NAME=\"allowmail\" VALUE=\"yes\" \$allowmailchecked> yes <INPUT TYPE=\"RADIO\" NAME=\"allowmail\" VALUE=\"no\" \$allowmailnotchecked> no</normalfont></TD>

</tr>

<tr bgcolor=\"{secondaltcolor}\">
<TD valign=top><normalfont><B>Invisible Mode:</b><br>
<smallfont>Selecting yes allows you to surf the forums without appearing in the \'Logged In Users\' list.</smallfont>
</normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"invisible\" VALUE=\"yes\" \$invisiblechecked> yes <INPUT TYPE=\"RADIO\" NAME=\"invisible\" VALUE=\"no\" \$invisiblenotchecked>
 no</normalfont></TD>
</TR>

<tr bgcolor=\"{firstaltcolor}\">
<TD valign=top><normalfont><B>Hide Email Address:</b><br>
<smallfont>Clicking yes hides your email address in your public profile, so that it is not accessible by other users.</smallfont>
</normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"showemail\" VALUE=\"no\" \$showemailnotchecked> yes <INPUT TYPE=\"RADIO\" NAME=\"showemail\" VALUE=\"yes\" \$showemailchecked>
 no</normalfont></TD>
</TR>

<tr bgcolor=\"{secondaltcolor}\">
<TD><normalfont><b>Store Username & Password in browser memory</b></normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"cookieuser\" \$cookieuserchecked VALUE=\"yes\">
 yes <INPUT TYPE=\"RADIO\" NAME=\"cookieuser\" \$cookieusernotchecked VALUE=\"no\"> no</normalfont></TD>

</TR><TR bgcolor=\"{firstaltcolor}\">

<td><normalfont><b>Default Thread View:</b></normalfont></TD>
<TD valign=top><SELECT NAME=\"prunedays\">
<option value=\"-1\" \$daysdefaultselected>Use forum default</option>
<OPTION value=\"1\" \$days1selected>Show threads from last day</option>
<OPTION value=\"2\" \$days2selected>Show threads from last 2 days</option>
<OPTION value=\"5\" \$days5selected>Show threads from last 5 days</option>
<OPTION value=\"10\" \$days10selected>Show threads from last 10 days</option>
<OPTION value=\"20\" \$days20selected>Show threads from last 20 days</option>
<OPTION value=\"30\" \$days30selected>Show threads from last 30 days</option>
<OPTION value=\"45\" \$days45selected>Show threads from last 45 days</option>
<OPTION value=\"60\" \$days60selected>Show threads from last 60 days</option>
<OPTION value=\"75\" \$days75selected>Show threads from last 75 days</option>
<OPTION value=\"100\" \$days100selected>Show threads from last 100 days</option>
<OPTION value=\"365\" \$days365selected>Show threads from the last year</option>
<OPTION value=\"1000\" \$days1000selected>Show all threads</option>
</SELECT>
</TD>

</tr><TR bgcolor=\"{secondaltcolor}\">

<TD valign=top><normalfont><B>Time offset:</B><br>
<smallfont>All times on the server are \$timezoneorig. Enter the number of hours that you are offset from this timezone, and all the times on the board will be altered to fit your timezone.</smallfont></normalfont></TD>
<TD valign=top><INPUT TYPE=\"TEXT\" NAME=\"timezoneoffset\" SIZE=7 MAXLENGTH=3 value=\$timezoneoffset></TD>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Use \'Email Notification\' by default</B></normalfont><br>
<smallfont>Using this option emails you whenever someone replies to a thread that you have participated in.</smallfont></TD>
<TD><normalfont><INPUT TYPE=\"RADIO\" NAME=\"emailnotification\" VALUE=\"yes\" \$emailnotificationchecked> yes <INPUT TYPE=\"RADIO\" NAME=\"emailnotification\" VALUE=\"no\" \$emailnotificationnotchecked> no</normalfont>
</TD></tr>

</tr></table>
<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">
<tr><td width=\"100%\" align=\"right\">
<normalfont><b><normalfont color=\"#ff0000\"><sup>*</sup> - Required Field</normalfont></b></normalfont>
</td></tr>
</table>

<p align=\"center\">
<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"updateprofile\">
<INPUT TYPE=\"HIDDEN\" NAME=\"userid\" VALUE=\"\$userid\">
<INPUT TYPE=\"HIDDEN\" NAME=\"oldpassword\" VALUE=\"\$password\">
<INPUT TYPE=\"SUBMIT\" NAME=\"Submit\" VALUE=\"Submit Modifications\">
<INPUT TYPE=\"RESET\" NAME=\"Reset\" VALUE=\"Clear Fields\">
</p>
</form>

\$footer

</body>
</html>";
    $notes[modifyprofile] .= "Added invisible field. The user can specify not to appear in the online users list. ";

    //################################################################
    $newtemplate[registeradult] = "{htmldoctype}
<HTML>
<HEAD>
<TITLE>\$bbtitle Registration</TITLE>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

<p><normalfont>In order to be able to post messages on the \$bbtitle forums, you must first register.</normalfont></p>


<table border=0 cellspacing=1 cellpadding=4 width=\"100%\">
<FORM METHOD=POST ACTION=\"member.php\">
<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><b>Registration: Required Information </b></normalfont><smallfont color=\"{tableheadtextcolor}\" class=thtcolor>All fields are required.  Please note that passwords are case sensitive.</smallfont></td>
</tr>

<tr bgcolor=\"{firstaltcolor}\">

<TD><normalfont><B>User Name:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"username\" SIZE=25 MAXLENGTH=25>
</TD>
</TR>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Password:</B></normalfont></TD>
<TD><INPUT TYPE=\"PASSWORD\" NAME=\"password\" SIZE=25 MAXLENGTH=15> </TD></TR>

<TR bgcolor=\"{secondaltcolor}\"><TD><normalfont><B>Enter Password Again:</B></normalfont></TD>
<TD><INPUT TYPE=\"PASSWORD\" NAME=\"passwordconfirm\" SIZE=25 MAXLENGTH=15></TD></tr>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Email:</B></normalfont><br>
<smallfont>Please enter a valid email address. You can choose to hide it below in the preferences section.</smallfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"email\" SIZE=25 MAXLENGTH=50>
</TD>
</TR>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Enter Email Again:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"emailconfirm\" SIZE=25 MAXLENGTH=50>
</TD>
</TR>

<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><b>Optional Information </b></normalfont><smallfont color=\"{tableheadtextcolor}\" class=thtcolor>All information will be viewable by other \$bbtitle members.</smallfont>
</td></tr>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Homepage:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"homepage\" VALUE=\"http://\" SIZE=25 MAXLENGTH=100>
</TD></tr>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>ICQ Number:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"icq\" SIZE=25 MAXLENGTH=20>
</TD></tr>

<tr bgcolor=\"{secondaltcolor}\">
<td>
<B><normalfont>AOL Instant Messenger Handle:</normalfont></B>
</td>
<td>
<INPUT TYPE=\"TEXT\" NAME=\"aim\" SIZE=25 MAXLENGTH=20>
</td></tr>

<tr bgcolor=\"{firstaltcolor}\">
<td>
<B><normalfont>Yahoo Messenger Handle:</normalfont></B>
</td>
<td>
<INPUT TYPE=\"TEXT\" NAME=\"yahoo\" SIZE=25 MAXLENGTH=20>
</td></tr>

<tr bgcolor=\"{secondaltcolor}\">
<td valign=top>
<B><normalfont>Biography:</normalfont></B><br>
<smallfont>A little bit of info about yourself. You might want to include: Location, occupation, interests, Instant messenger handles, etc.</smallfont>
</td>
<td>
<TEXTAREA NAME=\"biography\" ROWS=5 COLS=35>Location:
Occupation:
Interests:
</TEXTAREA>
</td></tr>

<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2>
<normalfont color=\"{tableheadtextcolor}\"><b>Preferences</b></normalfont></td>
</tr>

<TR bgcolor=\"{firstaltcolor}\">
<TD valign=top><normalfont><B>Signature:</B></normalfont><BR>
<smallfont>Optional signature you may use to appear at bottom of your posts.<br><br>
HTML code is \$htmlonoff<br>
<A HREF=\"index.php?action=bbcode\">vB Code</A> is \$bbcodeonoff<br>
[img] code is \$imgcodeonoff<br>
<a href=\"index.php?action=showsmilies\">Smilies</a> are \$smiliesonoff
</smallfont>
</TD>
<TD><TEXTAREA NAME=\"signature\" ROWS=5 COLS=35 WRAP=PHYSICAL></TEXTAREA>
</TD></tr>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Allow Bulletin Board Administrators and Moderators To Send You Email Notices?</B></normalfont></TD>
<TD><normalfont><INPUT TYPE=\"RADIO\" NAME=\"allowmail\" VALUE=\"yes\" CHECKED> yes <INPUT TYPE=\"RADIO\" NAME=\"allowmail\" VALUE=\"no\"> no</normalfont>
</TD></tr>

<tr bgcolor=\"{firstaltcolor}\">
<TD valign=top><normalfont><B>Invisible Mode:</b><br>
<smallfont>Selecting yes allows you to surf the forums without appearing in the \'Logged In Users\' list.</smallfont>
</normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"invisible\" VALUE=\"yes\" > yes <INPUT TYPE=\"RADIO\" NAME=\"invisible\" VALUE=\"no\" checked>
 no</normalfont></TD>
</TR>

<tr bgcolor=\"{secondaltcolor}\">
<TD valign=top><normalfont><B>Hide Email Address:</b><br>
<smallfont>Clicking yes hides your email address in your public profile, so that it is not accessible by other users.</smallfont>
</normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"showemail\" VALUE=\"no\" > yes <INPUT TYPE=\"RADIO\" NAME=\"showemail\" VALUE=\"yes\" checked>
 no</normalfont></TD>
</TR>

<tr bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Store Username & Password in browser memory</B></normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"namestorage\" VALUE=\"yes\" CHECKED>
 yes <INPUT TYPE=\"RADIO\" NAME=\"namestorage\" VALUE=\"no\"> no</normalfont>
</TD>
</TR>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Default Thread View:</B></normalfont></TD>
<TD valign=top><SELECT NAME=\"prunedays\">
<OPTION value=\"-1\" selected>Use forum default
<OPTION value=\"1\" >Show threads from last day
<OPTION value=\"2\" >Show threads from last 2 days
<OPTION value=\"5\" >Show threads from last 5 days
<OPTION value=\"10\" >Show threads from last 10 days
<OPTION value=\"20\" >Show threads from last 20 days
<OPTION value=\"30\" >Show threads from last 30 days
<OPTION value=\"45\" >Show threads from last 45 days
<OPTION value=\"60\" >Show threads from last 60 days
<OPTION value=\"75\" >Show threads from last 75 days
<OPTION value=\"100\" >Show threads from last 100 days
<OPTION value=\"365\" >Show threads from the last year
<option value=\"1000\" >Show all threads
</SELECT>
</TD></tr>

<TR bgcolor=\"{firstaltcolor}\">
<TD valign=top><normalfont><B>Time offset:</B><br>
<smallfont>All times on the server are \$timezoneorig. Enter the number of hours that you are offset from this timezone, and all the times on the board will be altered to fit your timezone.</smallfont></normalfont></TD>
<TD valign=top><INPUT TYPE=\"TEXT\" NAME=\"timezoneoffset\" SIZE=7 MAXLENGTH=3 value=0></TD>
<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Use \'Email Notification\' by default</B></normalfont><br>
<smallfont>Using this option emails you whenever someone replies to a thread that you have participated in.</smallfont></TD>
<TD><normalfont><INPUT TYPE=\"RADIO\" NAME=\"emailnotification\" VALUE=\"yes\" checked> yes <INPUT TYPE=\"RADIO\" NAME=\"emailnotification\" VALUE=\"no\" > no</normalfont>
</TD></tr>
</tr>
</TABLE>

<p align=\"center\">
<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"addmember\">
<INPUT TYPE=\"SUBMIT\" NAME=\"Submit\" VALUE=\"Submit\">
<INPUT TYPE=\"RESET\" NAME=\"Reset\" VALUE=\"Reset\">
</p></form>

\$footer

</body>
</html>";
    $notes[registeradult] .= "Added invisible field. Now the user can specify not to appear in the online users list. ";

    //################################################################
    $newtemplate[registercoppa] = "{htmldoctype}
<HTML>
<HEAD>
<title>\$bbtitle - COPPA Registration</title>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>

<normalfont>

<p><b>Note:</b> Until we receive a signed permission form from your parent or guardian you will be unable to post messages on this forum.</p>

<p>All of the information you provide on this page will be emailed to you and your parent or guardian with instructions for sending in the approval.</p>

</normalfont>

<FORM METHOD=POST ACTION=\"member.php\">
<input type=hidden name=coppauser value=1>

<table border=0 cellspacing=1 cellpadding=4 width=\"100%\">

<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><b>Registration: Required Information </b></normalfont><smallfont color=\"{tableheadtextcolor}\" class=thtcolor>All fields are required.  Please note that passwords are case sensitive.</smallfont></td>
</tr>

<tr bgcolor=\"{secondaltcolor}\">

<TD><normalfont><B>User Name:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"username\" SIZE=25 MAXLENGTH=25>
</TD>
</TR>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Password:</B></normalfont></TD>
<TD><INPUT TYPE=\"PASSWORD\" NAME=\"password\" SIZE=25 MAXLENGTH=15> </TD></TR>

<TR bgcolor=\"{firstaltcolor}\"><TD><normalfont><B>Enter Password Again:</B></normalfont></TD>
<TD><INPUT TYPE=\"PASSWORD\" NAME=\"passwordconfirm\" SIZE=25 MAXLENGTH=15></TD></tr>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Email:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"email\" SIZE=25 MAXLENGTH=50>
</TD>
</TR>
<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Enter Email Again:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"emailconfirm\" SIZE=25 MAXLENGTH=50>
</TD>
</TR>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Parent/Guardian Email:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"parentemail\" SIZE=25 MAXLENGTH=50>
</TD>
</TR>

<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><b>Optional Information </b></normalfont><smallfont color=\"{tableheadtextcolor}\" class=thtcolor>It is recommended that you do not reveal any personally identifying information in your profile.  All information will be viewable by other \$bbtitle members.</smallfont>
</td></tr>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Homepage:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"homepage\" VALUE=\"http://\" SIZE=25 MAXLENGTH=100>
</TD></tr>

<TR bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>ICQ Number:</B></normalfont></TD>
<TD><INPUT TYPE=\"TEXT\" NAME=\"icq\" SIZE=25 MAXLENGTH=20>
</TD></tr>

<tr bgcolor=\"{secondaltcolor}\">
<td>
<B><normalfont>AOL Instant Messenger Handle:</normalfont></B>
</td>
<td>
<INPUT TYPE=\"TEXT\" NAME=\"aim\" SIZE=25 MAXLENGTH=20>
</td></tr>

<tr bgcolor=\"{firstaltcolor}\">
<td>
<B><normalfont>Yahoo Messenger Handle:</normalfont></B>
</td>
<td>
<INPUT TYPE=\"TEXT\" NAME=\"yahoo\" SIZE=25 MAXLENGTH=20>
</td></tr>

<tr bgcolor=\"{secondaltcolor}\">
<td valign=top>
<B><normalfont>Biography:</normalfont></B><br>
<smallfont>A little bit of info about yourself. Do NOT include information about where you live.</smallfont>
</td>
<td>
<TEXTAREA NAME=\"biography\" ROWS=5 COLS=35>Location:
Occupation:
Interests:
</TEXTAREA>
</td></tr>

<tr bgcolor=\"{tableheadbgcolor}\">
<td colspan=2>
<normalfont color=\"{tableheadtextcolor}\" class=thtcolor><b>Preferences</b></normalfont></td>
</tr>

<TR bgcolor=\"{firstaltcolor}\">
<TD valign=top><normalfont><B>Signature:</B></normalfont><BR>
<smallfont>Optional signature you may use to appear at bottom of your posts.<br><br>
HTML code is \$htmlonoff<br>
<A HREF=\"index.php?action=bbcode\">vB Code</A> is \$bbcodeonoff<br>
[img] code is \$imgcodeonoff<br>
<a href=\"index.php?action=showsmilies\">Smilies</a> are \$smiliesonoff
</smallfont>
</TD>
<TD><TEXTAREA NAME=\"signature\" ROWS=5 COLS=35 WRAP=PHYSICAL></TEXTAREA>
</TD></tr>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Allow Bulletin Board Administrators and Moderators To Send You Email Notices?</B></normalfont></TD>
<TD><normalfont><INPUT TYPE=\"RADIO\" NAME=\"allowmail\" VALUE=\"yes\" CHECKED> yes <INPUT TYPE=\"RADIO\" NAME=\"allowmail\" VALUE=\"no\"> no</normalfont>
</TD></tr>

<tr bgcolor=\"{firstaltcolor}\">
<TD valign=top><normalfont><B>Invisible Mode:</b><br>
<smallfont>Selecting yes allows you to surf the forums without appearing in the \'Logged In Users\' list.</smallfont>
</normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"invisible\" VALUE=\"yes\" checked> yes <INPUT TYPE=\"RADIO\" NAME=\"invisible\" VALUE=\"no\" >
 no</normalfont></TD>
</TR>

<tr bgcolor=\"{secondaltcolor}\">
<TD valign=top><normalfont><B>Hide Email Address:</b><br>
<smallfont>Clicking yes hides your email address in your public profile, so that it is not accessible by other users.</smallfont>
</normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"showemail\" VALUE=\"no\" checked> yes <INPUT TYPE=\"RADIO\" NAME=\"showemail\" VALUE=\"yes\" >
 no</normalfont></TD>
</TR>

<tr bgcolor=\"{firstaltcolor}\">
<TD><normalfont><B>Store Username & Password in browser memory:</B></normalfont></TD>
<TD valign=top><normalfont><INPUT TYPE=\"RADIO\" NAME=\"namestorage\" VALUE=\"yes\" CHECKED>
 yes <INPUT TYPE=\"RADIO\" NAME=\"namestorage\" VALUE=\"no\"> no</normalfont>
</TD>
</TR>

<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Default Thread View:</B></normalfont></TD>
<TD valign=top><SELECT NAME=\"prunedays\">
<OPTION value=\"-1\" selected>Use forum default
<OPTION value=\"1\" >Show threads from last day
<OPTION value=\"2\" >Show threads from last 2 days
<OPTION value=\"5\" >Show threads from last 5 days
<OPTION value=\"10\" >Show threads from last 10 days
<OPTION value=\"20\" >Show threads from last 20 days
<OPTION value=\"30\" >Show threads from last 30 days
<OPTION value=\"45\" >Show threads from last 45 days
<OPTION value=\"60\" >Show threads from last 60 days
<OPTION value=\"75\" >Show threads from last 75 days
<OPTION value=\"100\" >Show threads from last 100 days
<OPTION value=\"365\" >Show threads from the last year
<option value=\"1000\" >Show all threads
</SELECT>
</TD></tr>

<TR bgcolor=\"{firstaltcolor}\">
<TD valign=top><normalfont><B>Time offset:</B><br>
<smallfont>All times on the server are \$timezoneorig. Enter the number of hours that you are offset from this timezone, and all the times on the board will be altered to fit your timezone.</smallfont></normalfont></TD>
<TD valign=top><INPUT TYPE=\"TEXT\" NAME=\"timezoneoffset\" SIZE=7 MAXLENGTH=3 value=0></TD>
<TR bgcolor=\"{secondaltcolor}\">
<TD><normalfont><B>Use \'Email Notification\' by default</B></normalfont><br>
<smallfont>Using this option emails you whenever someone replies to a thread that you have participated in.</smallfont></TD>
<TD><normalfont><INPUT TYPE=\"RADIO\" NAME=\"emailnotification\" VALUE=\"yes\" checked> yes <INPUT TYPE=\"RADIO\" NAME=\"emailnotification\" VALUE=\"no\" > no</normalfont>
</TD></tr>
</tr>
</TABLE>

<p align=\"center\">
<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"addmember\">
<INPUT TYPE=\"SUBMIT\" NAME=\"Submit\" VALUE=\"Submit\">
<INPUT TYPE=\"RESET\" NAME=\"Reset\" VALUE=\"Reset\">
</p>
</form>

\$footer

</body>
</html>";
    $notes[registercoppa] .= "Added invisible field. Now the user can specify not to appear in the online users list. ";

    //################################################################
    $newtemplate[postbit_useremail] = "<A HREF=\"member.php?action=mailform&userid=\$userid\" target=_blank><IMG SRC=\"images/email.gif\" BORDER=0 ALT=\"Click Here to Email \$username\"></A>&nbsp;&nbsp;";
    $notes[postbit_useremail] .= "Does not display email address directly. Changed URL of anchor tag. ";

    //################################################################
    $newtemplate[error_registeremail] = "Thank you for registering, \$username. An email has been dispatched to \$email with details on how to activate your account. Click <a href=\"index.php\">here</a> to return to the forum index.</p>

<p>You will receive an email in your inbox. You MUST follow the link in that email before you can post on these forums. Until you do that, you will be told that you do not have permission to post.";
    $notes[error_registeremail] .= "Changed wording to emphasise importance of email";

    //################################################################
    $newtemplate[getinfo] = "{htmldoctype}
<HTML>
<HEAD>
<title>\$bbtitle - View Profile</title>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>


<table border=0 cellpadding=4 border=0 cellspacing=1 width=100%>
<tr bgcolor=\"{tableheadbgcolor}\"><TD COLSPAN=2>

<table width=\"100%\" border=0 cellpadding=0 cellspacing=0>
<tr><td align=\"left\" valign=\"middle\">

<normalfont color=\"{tableheadtextcolor}\"><B>Profile For \$username</B></normalfont>

</td><td align=\"right\" valign=\"middle\">

<A HREF=\"search.php?action=simplesearch&exactname=yes&searchuser=\$username\"><smallfont color=\"{tableheadtextcolor}\" class=thtcolor>Search: All posts by this registered user.</a></A>

</td></tr></table>

</td></tr>

<tr bgcolor=\"{secondaltcolor}\"><td>
<normalfont><B>Date Registered:</B></normalfont></td>
<td><normalfont>\$datejoined</normalfont>
</td></tr>

<tr bgcolor=\"{firstaltcolor}\"><td>
<normalfont><B>Status:</B></normalfont></td>
<td><normalfont>\$usertitle</normalfont>
</td></tr>

<tr bgcolor=\"{secondaltcolor}\"><td>
<normalfont><B>Total Posts:</B></normalfont></td>
<td><normalfont>\$totalposts</normalfont>
</td></tr>

<tr bgcolor=\"{firstaltcolor}\"><td>
<normalfont><B>Last Post:</B></normalfont></td>
<td><normalfont>\$lastpostdate \$lastposttime<br>
<a href=\"\$lastposturl\">\$lastposttitle</a>\$nolastpost</normalfont>
</td></tr>

<tr bgcolor=\"{secondaltcolor}\"><td>
<normalfont><B>Current Email:</B></normalfont></td>
<td><normalfont><A HREF=\"member.php?action=mailform&userid=\$userid\">Click here to email \$username</a></normalfont>
</td></tr>

<TR bgcolor=\"{firstaltcolor}\">
<td><normalfont><B>Homepage:</B></normalfont></td>
<td><normalfont><A HREF=\"\$userhomepage\" target=_top>\$userhomepage</A></normalfont>
</td></tr>

<TR bgcolor=\"{secondaltcolor}\">
<td><normalfont><B>ICQ Number:</B></normalfont></td>
<td><normalfont>\$icqnumber <!-- \$ icq --></normalfont>
</td></tr>

<TR bgcolor=\"{firstaltcolor}\">
<td><normalfont><B>AOL Instant Messenger Handle:</B></normalfont></td>
<td><normalfont>\$aimhandle <!-- \$ aim --></normalfont>
</td></tr>

<TR bgcolor=\"{secondaltcolor}\">
<td><normalfont><B>Yahoo Instant Messenger Handle:</B></normalfont></td>
<td><normalfont>\$yahoohandle <!-- \$ yahoo --></normalfont>
</td></tr>

<TR bgcolor=\"{firstaltcolor}\" valign=top>
<td><normalfont><B>Biography:</B></normalfont></td>
<td><normalfont>\$biography</normalfont>
</td></tr>

</table>

<center><p><smallfont><b>Administrative Options: <a href=\"moderator.php?action=useroptions&userid=\$userid\">User Options</a></b></smallfont></p></center>

\$footer

</body>
</html>";
    $notes[getinfo] = "Changed Link for emailing to new secure form";

  }
  // end version 1.1.2

  // start version 1.1.4
  if ($oldversionbits[0]<=1 and $oldversionbits[1]<=1 and $oldversionbits[2]<4) {
  $newtemplate[getinfo]="{htmldoctype}
<HTML>
<HEAD>
<title>\$bbtitle - View Profile</title>
\$cssinclude
</HEAD>
<body>
\$header

<table border=\"0\" width=\"100%\"><tr>
<td valign=\"top\" align=\"left\"><a href=\"index.php\"><img src=\"\$titleimage\" border=\"0\"></a></td>

<td valign=\"middle\" align=\"center\" nowrap>
\$fivelinks
</td></tr></table>


<table border=0 cellpadding=4 border=0 cellspacing=1 width=100%>
<tr bgcolor=\"{tableheadbgcolor}\"><TD COLSPAN=2>

<table width=\"100%\" border=0 cellpadding=0 cellspacing=0>
<tr><td align=\"left\" valign=\"middle\">

<normalfont color=\"{tableheadtextcolor}\"><B>Profile For \$username</B></normalfont>

</td><td align=\"right\" valign=\"middle\">

<A HREF=\"search.php?action=simplesearch&exactname=yes&searchuser=\$searchusername\"><smallfont color=\"{tableheadtextcolor}\" class=thtcolor>Search: All posts by this registered user.</a></A>

</td></tr></table>

</td></tr>

<tr bgcolor=\"{secondaltcolor}\"><td>
<normalfont><B>Date Registered:</B></normalfont></td>
<td><normalfont>\$datejoined</normalfont>
</td></tr>

<tr bgcolor=\"{firstaltcolor}\"><td>
<normalfont><B>Status:</B></normalfont></td>
<td><normalfont>\$usertitle</normalfont>
</td></tr>

<tr bgcolor=\"{secondaltcolor}\"><td>
<normalfont><B>Total Posts:</B></normalfont></td>
<td><normalfont>\$totalposts</normalfont>
</td></tr>

<tr bgcolor=\"{firstaltcolor}\"><td>
<normalfont><B>Last Post:</B></normalfont></td>
<td><normalfont>\$lastpostdate \$lastposttime<br>
<a href=\"\$lastposturl\">\$lastposttitle</a>\$nolastpost</normalfont>
</td></tr>

<tr bgcolor=\"{secondaltcolor}\"><td>
<normalfont><B>Current Email:</B></normalfont></td>
<td><normalfont><A HREF=\"member.php?action=mailform&userid=\$userid\">Click here to email \$username</a></normalfont>
</td></tr>

<TR bgcolor=\"{firstaltcolor}\">
<td><normalfont><B>Homepage:</B></normalfont></td>
<td><normalfont><A HREF=\"\$userhomepage\" target=_top>\$userhomepage</A></normalfont>
</td></tr>

<TR bgcolor=\"{secondaltcolor}\">
<td><normalfont><B>ICQ Number:</B></normalfont></td>
<td><normalfont>\$icqnumber <!-- \$ icq --></normalfont>
</td></tr>

<TR bgcolor=\"{firstaltcolor}\">
<td><normalfont><B>AOL Instant Messenger Handle:</B></normalfont></td>
<td><normalfont>\$aimhandle <!-- \$ aim --></normalfont>
</td></tr>

<TR bgcolor=\"{secondaltcolor}\">
<td><normalfont><B>Yahoo Instant Messenger Handle:</B></normalfont></td>
<td><normalfont>\$yahoohandle <!-- \$ yahoo --></normalfont>
</td></tr>

<TR bgcolor=\"{firstaltcolor}\" valign=top>
<td><normalfont><B>Biography:</B></normalfont></td>
<td><normalfont>\$biography</normalfont>
</td></tr>

</table>

<center><p><smallfont><b>Administrative Options: <a href=\"moderator.php?action=useroptions&userid=\$userid\">User Options</a></b></smallfont></p></center>

\$footer

</body>
</html>";
  $notes[getinfo] .= "Changed \$username to \$searchusername variable in search for posts by this user URL.";
 }
 // end version 1.1.4
}


if ($step==4) {
?><head><title>vBulletin Upgrade Wizard <?php echo $newversion; ?> - Update existing templates</title></head>
<body><p>This step will allow you to update your existing templates to the current state.</p><?php

  echo "<form action=\"upgrade.php\" method=post><input type=hidden name=step value=6>";

  echo "<p>Templates:</p>";
  while (list($key,$val)=@each($newtemplate)) {
    echo "<p><b>$key</b> - $notes[$key] <a href=\"upgrade.php?step=5&viewtemplate=$key\" target=_blank>[view new template]</a>";
    if ($temp=$DB_site->query_first("SELECT templateid FROM template WHERE title='$key'")) {
      echo " <a href=\"template.php?action=edit&templateid=$temp[templateid]\" target=_blank>[view/edit existing template]</a>";
    }
    echo "<br>Upgrade this template? Yes<input type=\"radio\" name=\"dotemplate[$key]\" checked value=\"1\"> No <input type=\"radio\" name=\"dotemplate[$key]\" value=\"0\"></p>";
    echo "<hr>";
  }

  echo "<input type=submit></form>";

}

if ($step==5) {
?><head><title>vBulletin Upgrade Wizard <?php echo $newversion; ?> - View New template</title></head>
<body><?php

  echo "<p>New template:</p>";
  echo "<textarea rows=20 cols=80>".htmlspecialchars($newtemplate[$viewtemplate])."</textarea>";
  echo "<p>Notes: $notes[$viewtemplate]</p>";

}

if ($step==6) {
?><head><title>vBulletin Upgrade Wizard <?php echo $newversion; ?> - Update existing templates</title></head>
<body><p>Updating templates...</p><?php

  if (is_array($dotemplate)==1) {
    while (list($key,$val)=@each($dotemplate)) {
      if ($val==1) {
        $DB_site->query("UPDATE template SET template='".addslashes($newtemplate[$key])."' WHERE title='".addslashes($key)."'");
        echo "<p>Updating $key</p>";
      }
    }
  }

  echo "<p><a href=\"upgrade.php?step=7\">Click here to continue -></a></p>";

}

if ($step==7) {
?><head><title>vBulletin Upgrade Wizard <?php echo $newversion; ?> - Add new options</title></head>
<body><p>This step will create new options in the control panel. Once the upgrade is complete, we recommend that you go to the General Options area in the control panel and submit that form to confirm the new options.</p><?php

  // start version 1.1.1
  if ($oldversionbits[0]<=1 and $oldversionbits[1]<=1 and $oldversionbits[2]<1) {
    $newoption[cookietimeout] = 300;
    $newoption[maximages] = 0;
    $newoption[allowmultiregs] = 0;
    $newoption[cookiepath] = "/";
  }
  // end version 1.1.1

  // start version 1.1.2
  if ($oldversionbits[0]<=1 and $oldversionbits[1]<=1 and $oldversionbits[2]<2) {
    $newoption[noeditedbytime] = 2;
    $newoption[showeditedbyadmin] = 1;
    $newoption[pagenavpages] = 2;
    $newoption[wordwrap] = 100;
    $newoption[hideprivateforums] = 0;
    $newoption[secureemail] = 1;
    $newoption[enablememberlist] = 1;
    $newoption[usememberlistadvsearch] = 1;
    $newoption[memberlistperpage] = 30;
    $newoption[memberlisttopposters] = 10;
    $newoption[illegalusernames] = "";
  }
  // end version 1.1.2

  $newoption[versionnumber]=$newversion;

  $opttemp="\n\n";

  while (list($key,$val)=@each($newoption)) {
    $val=str_replace("\$","\\\$",$val);
    $val=str_replace("\"","\\\"",$val);
    $opttemp.="\$$key = \"$val\";\n";
  }

  $DB_site->query("UPDATE template SET template=CONCAT(template,'".addslashes($opttemp)."') WHERE title='options'");

  echo "<p>Options updated successfully.</p>";
  echo "<p><b>Upgrade complete. Please delete this upgrade.php file (for security reasons) then proceed to the control panel.</b></p>";
}


?></body></html>