<?php

require("global.php");

if ($allowsearches==0) {
  echo standarderror($bbtitle,gettemplate("error_searchdisabled",0));

  exit;
}


$permissions=getpermissions($bbuserid,$bbusergroupid);
if ($permissions[canview]!=1 or $permissions[cansearch]!=1) {
  eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
  exit;
}

if (isset($action)==0 or $action=="") {
  $action="intro";
}

if ($action=="intro") {

  $jumpforumbits="";
  $categorys=$DB_site->query("SELECT categoryid,title,displayorder FROM category WHERE displayorder<>0 ORDER BY displayorder");
  while ($category=$DB_site->fetch_array($categorys)) {

    $forums=$DB_site->query("SELECT forumid,title,displayorder FROM forum WHERE displayorder<>0 AND categoryid=$category[categoryid] ORDER BY displayorder");
    while ($forum=$DB_site->fetch_array($forums)) {
      $getperms=getpermissions($bbuserid,$bbusergroupid,$forum[forumid]);
      if ($getperms[canview]==1 and $getperms[cansearch]==1) {
        $jumpforumid=$forum[forumid];
        $jumpforumtitle="  $forum[title]";

        eval("\$jumpforumbits .= \"".gettemplate("jumpforumbit")."\";");
     }
    }
  }
  eval("echo dovars(\"".gettemplate("searchintro")."\");");
}

if (strstr($searchuser,"%")>0) {
  $searchuser=urldecode($searchuser);
}

if ($action=="simplesearch") {
  if ($query=="" and $searchuser=="" and $getdaily!="yes") {
    echo standarderror($bbtitle,gettemplate("error_searchspecifyterms",0));

    exit;
  }

  $query=urlencode($query);
  $searchuser=urlencode($searchuser);

  echo standardredirect($bbtitle,gettemplate("redirect_search",0),"search.php?query=$query&forumchoice=$forumchoice&booleanand=$booleanand&searchin=$searchin&searchdate=$searchdate&searchuser=$searchuser&searchdateline=$searchdateline&exactname=$exactname&action=dosearch&getdaily=$getdaily&pagenum=$pagenum");

}

if ($action=="getnew") {
  if ($bbuserid!=0 or $bblastvisit=0) {
    $numdays=intval((time()-$bblastvisit)/86400)+1;
    echo standardredirect($bbtitle,gettemplate("redirect_search",0),"search.php?getdaily=yes&action=dosearch&searchdateline=$bblastvisit");
  } else {
    $action="getdaily";
  }
}

if ($action=="getdaily") {
  echo standardredirect($bbtitle,gettemplate("redirect_search",0),"search.php?getdaily=yes&action=dosearch&searchdate=1");
}

if ($action=="dosearch") {

  if ($forumchoice!=-1) {
    $permissions=getpermissions($bbuserid,$bbusergroupid,$forumchoice);
    if ($permissions[canview]!=1 or $permissions[cansearch]!=1) {
      eval("echo standarderror(\$bbtitle,\"".gettemplate("error_nopermission")."\");");
      exit;
    }
  }

  $query=wordsonly(urldecode($query));
  $searchuser=wordsonly(urldecode($searchuser));

  if ($query=="" and $searchuser=="" and $getdaily!="yes") {
    echo standarderror($bbtitle,gettemplate("error_searchspecifyterms",0));

    exit;
  }

//  $searchuser=strtolower($searchuser);

//  $wordstring=wordsonly(" $query ");
  $words=explode(" ",addslashes($query));

  $query=htmlspecialchars($query);

  if ($query!="") {
    if ($booleanand=="yes") {
      $joiner="AND";
    } else {
      $joiner="OR";
    }

    if ($searchin=="subject") {
      $searchfield="subjectindex";
    } else {
      $searchfield="threadindex";
    }

    $combinedwords="AND (INSTR($searchfield,'".implode($words,"')>0 $joiner INSTR($searchfield,'")."')>0)";

  } else {
    if ($searchuser=="" and $getdaily!="yes") {
      echo standarderror($bbtitle,gettemplate("error_searchspecifyterms",0));

      exit;
    }

    $combinedwords="";
    $subjectonly="";
  }

  if ($searchdate!="-1" and isset($searchdate)!=0 and $searchdate!=0) {
    $datecut=time()-($searchdate*86400);
    $checkdate="AND thread.lastpost >= $datecut";
  } else {
    $checkdate="";
  }
  if ($searchdateline!="-1" and isset($searchdateline)!=0 and $searchdateline!=0 and $checkdate=="") {
    $checkdate="AND thread.lastpost>$searchdateline";
  }

  if ($searchuser!="") {
    if ($exactname=="yes") {
      $checkuser="AND INSTR(userindex,' ".addslashes($searchuser)." ')>0";
    } else {
      $checkuser="AND INSTR(userindex,'".addslashes($searchuser)."')>0";
    }
  } else {
    $checkuser="";
  }

  if ($forumchoice!=-1 and isset($forumchoice)!=0 and $forumchoice!=0) {
    $checkforum="AND thread.forumid=$forumchoice";
  } else {
    $forums=$DB_site->query("SELECT forumid FROM forum WHERE displayorder<>0");
    $checkforum="AND (";
    while ($forum=$DB_site->fetch_array($forums)) {
      $getperms=getpermissions($bbuserid,$bbusergroupid,$forum[forumid]);
      if ($getperms[canview]==1 and $getperms[cansearch]==1) {
        if ($checkforum=="AND (") {
          $checkforum.="thread.forumid=$forum[forumid] ";
        } else {
          $checkforum.="OR thread.forumid=$forum[forumid] ";
        }
      }
    }
    $checkforum.=") ";
  }

/*  echo "SELECT DISTINCT
    threadid,
    lastpost
    FROM thread
    WHERE visible=1 $checkforum $subjectonly $checkuser $checkdate $combinedwords
    ORDER BY lastpost DESC"; */

  $searchresults=$DB_site->query("SELECT DISTINCT
    threadid,
    lastpost
    FROM thread
    WHERE visible=1 $checkforum $subjectonly $checkuser $checkdate $combinedwords
    ORDER BY lastpost DESC");

  $countmatches=$DB_site->num_rows($searchresults);

  makeforumjump();

  // set defaults
  if (isset($perpage)==0 or $perpage==0 or $perpage=="" or $perpage>200) {
    $perpage=20;
  }
  if (isset($pagenum)==0 or $pagenum==0 or $pagenum=="") {
    $pagenum=1;
  }

  if ($countmatches!=0) {
    $first=($pagenum-1)*$perpage;
    $lower=$first+1;
    $upper=$pagenum*$perpage;
    if ($upper>$countmatches) {
      $upper=$countmatches;
    }

    $DB_site->data_seek($first,$searchresults);

    $curres=0;

    $searchresultbits = "";

    while ($searchresult=$DB_site->fetch_array($searchresults) and $curres++<$perpage) {
      $threadinfo=$DB_site->query_first("SELECT title,postusername,dateline,lastposter,postusername,replycount FROM thread WHERE threadid=$searchresult[threadid]");

      $foruminfo=$DB_site->query_first("SELECT forum.forumid,forum.title FROM thread,forum WHERE forum.forumid=thread.forumid and thread.threadid=$searchresult[threadid]");
      $forumtitle=htmlspecialchars($foruminfo[title]);
      $forumid=$foruminfo[forumid];

      $searchlink="showthread.php?threadid=$searchresult[threadid]";
      $replycount=$threadinfo[replycount];
      $lastposter=$threadinfo[lastposter];
      $postusername=$threadinfo[postusername];
      if ($threadinfo[dateline]!=0 and $threadinfo[dateline]!=4294967295) {
        $dateline=date($dateformat,intval($threadinfo[dateline])+intval($timeoffset+$bbtimezoneoffset)*3600);
      } else {
        $dateline="";
      }
      if ($wordwrap!=0) {
        $threadinfo[title]=dowordwrap($threadinfo[title]);
      }
      $threadtitle=htmlspecialchars($threadinfo[title]);
      $poster=htmlspecialchars($threadinfo[postusername]);
      $posterurl=urlencode($threadinfo[postusername]);

      if ($searchresult[lastpost]!=0 and $searchresult[lastpost]!=4294967295) {
        $lastpostdate=date($dateformat,intval($searchresult[lastpost])+intval($timeoffset+$bbtimezoneoffset)*3600);
      } else {
        $lastpostdate="";
      }

      eval ("\$searchresultbits .= \"".gettemplate("searchresultbit")."\";");
    }

    if ($upper<$countmatches) {
      $nextpagelink="<a href=\"search.php?query=".urlencode($query)."&getdaily=$getdaily&forumchoice=$forumchoice&searchin=$searchin&searchdateline=$searchdateline&searchdate=$searchdate&booleanand=$booleanand&getdaily=$getdaily&searchuser=".urlencode($searchuser)."&exactname=$exactname&action=simplesearch&pagenum=".($pagenum+1)."\">[Next Page]</a>";
    } else {
      $nextpagelink="";
    }

  } else {

    echo standarderror($bbtitle,gettemplate("error_searchnoresults",0));

    exit;
  }

  eval("echo dovars(\"".gettemplate("searchresults")."\");");

}

?>